unit puzzle_game_main_unit;

// 1641 variants of solution exists


// important: in "Project options" > "Application" you need to disable "Use LCL scaling (Hi-DPI)"
// https://forum.lazarus.freepascal.org/index.php?topic=45903.0
// "Application.Scaled := true" is added whenever the box "Use LCL scaling" of "Project options" > "Application" has been checked (which is the default in Laz 2.0+).
// It activates automatic scaling of controls according to screen resolution.


// https://wiki.freepascal.org/BGRAControls
//BGRA Controls is a set of graphical UI elements that you can use with Lazarus LCL applications. Under Linux you need to have installed libxtst-dev and libgl-dev.


// Add component:
// C:\fpcupdeluxe\lazarus\components\mouseandkeyinput
// Fatal: Cannot find MouseAndKeyInput used by puzzle_game_main_unit. Enable flag "Use Unit" of unit MouseAndKeyInput in package bgracontrols.

{$IFDEF DARWIN}
//{$linklib libXtst.a}
//{$linklib /usr/local/Cellar/libxtst/1.2.3/lib/libXtst.a}

//{$linklib libX11.a}
//{$linklib /usr/local/Cellar/libx11/1.7.3.1/lib/libX11-xcb.a}
//{$linklib /usr/local/Cellar/libx11/1.7.3.1/lib/libX11.a}


//{$linklib libXext.a}
//{$linklib /usr/local/Cellar/libxext/1.3.4/lib/libXext.a}

//{$linklib libXi.a}
//{$linklib /usr/local/Cellar/libxi/1.8/lib/libXi.a}

//{$linklib libXfixes.a}
//{$linklib /usr/local/Cellar/libxfixes/6.0.0/lib/libXfixes.a}

//{$linklib libXdmcp.a}
//{$linklib /usr/local/Cellar/libxdmcp/1.1.3/lib/libXdmcp.a}

//{$linklib libXau.a}
//{$linklib /usr/local/Cellar/libxau/1.0.9/lib/libXau.a}

//{$linklib /usr/local/Cellar/libxcb/1.14_2/lib/libxcb-composite.a}
//{$linklib /usr/local/Cellar/libxcb/1.14_2/lib/libxcb-damage.a}
//{$linklib /usr/local/Cellar/libxcb/1.14_2/lib/libxcb-dpms.a}
//{$linklib /usr/local/Cellar/libxcb/1.14_2/lib/libxcb-dri2.a}
//{$linklib /usr/local/Cellar/libxcb/1.14_2/lib/libxcb-dri3.a}
//{$linklib /usr/local/Cellar/libxcb/1.14_2/lib/libxcb-ge.a}
//{$linklib /usr/local/Cellar/libxcb/1.14_2/lib/libxcb-glx.a}
//{$linklib /usr/local/Cellar/libxcb/1.14_2/lib/libxcb-present.a}
//{$linklib /usr/local/Cellar/libxcb/1.14_2/lib/libxcb-randr.a}
//{$linklib /usr/local/Cellar/libxcb/1.14_2/lib/libxcb-record.a}
//{$linklib /usr/local/Cellar/libxcb/1.14_2/lib/libxcb-render.a}
//{$linklib /usr/local/Cellar/libxcb/1.14_2/lib/libxcb-res.a}
//{$linklib /usr/local/Cellar/libxcb/1.14_2/lib/libxcb-screensaver.a}
//{$linklib /usr/local/Cellar/libxcb/1.14_2/lib/libxcb-shape.a}
//{$linklib /usr/local/Cellar/libxcb/1.14_2/lib/libxcb-shm.a}
//{$linklib /usr/local/Cellar/libxcb/1.14_2/lib/libxcb-sync.a}
//{$linklib /usr/local/Cellar/libxcb/1.14_2/lib/libxcb-xevie.a}
//{$linklib /usr/local/Cellar/libxcb/1.14_2/lib/libxcb-xf86dri.a}
//{$linklib /usr/local/Cellar/libxcb/1.14_2/lib/libxcb-xfixes.a}
//{$linklib /usr/local/Cellar/libxcb/1.14_2/lib/libxcb-xinerama.a}
//{$linklib /usr/local/Cellar/libxcb/1.14_2/lib/libxcb-xinput.a}
//{$linklib /usr/local/Cellar/libxcb/1.14_2/lib/libxcb-xkb.a}
//{$linklib /usr/local/Cellar/libxcb/1.14_2/lib/libxcb-xprint.a}
//{$linklib /usr/local/Cellar/libxcb/1.14_2/lib/libxcb-xselinux.a}
//{$linklib /usr/local/Cellar/libxcb/1.14_2/lib/libxcb-xtest.a}
//{$linklib /usr/local/Cellar/libxcb/1.14_2/lib/libxcb-xv.a}
//{$linklib /usr/local/Cellar/libxcb/1.14_2/lib/libxcb-xvmc.a}
//{$linklib /usr/local/Cellar/libxcb/1.14_2/lib/libxcb.a}

{$ENDIF}



{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ComCtrls, LResources,
  ExtCtrls, StdCtrls, math, LCLType, Menus, fileutil, DateUtils,
//  {$IF not Defined (DARWIN)}
  {$IF Defined (WINDOWS)}
  MouseAndKeyInput,
  {$ENDIF}
  BGRAGraphicControl, BGRABitmap, BGRABitmapTypes, BCTypes, BCRadialProgressBar,
  BGRAKnob, BCSVGViewer, BCRoundedImage, BCLabel, BGRAThemeButton, BCButton,
  BCMDButton, BCMDButtonFocus, BCSVGButton, BGRAResizeSpeedButton,
  BGRASpeedButton, ColorSpeedButton, BCListBox, BCComboBox;

type

  { TPuzzleGameForm }

  TPuzzleGameForm = class(TForm)
    AddDeletePlayerButton: TBCButton;
    PlayerNameEdit: TEdit;
    PlayerSelectComboBox: TBCComboBox;
    FlipButton: TBCButton;
    DateLabel: TBCLabel;
    ErrorCircleImage: TBGRAGraphicControl;
    NewGameButton: TBCButton;
    ShowSavedSolutionsButton: TBCButton;
    MainMenu: TMainMenu;
    OutputLabel: TBCLabel;
    OutputImage: TBCRoundedImage;
    Board: TBGRAGraphicControl;
    FixButton: TButton;
    DebugLabel: TLabel;
    Piece01: TBGRAGraphicControl;
    Piece10: TBGRAGraphicControl;
    Piece11: TBGRAGraphicControl;
    Piece12: TBGRAGraphicControl;
    Piece13: TBGRAGraphicControl;
    Piece02: TBGRAGraphicControl;
    Piece03: TBGRAGraphicControl;
    Piece04: TBGRAGraphicControl;
    Piece05: TBGRAGraphicControl;
    Piece06: TBGRAGraphicControl;
    Piece07: TBGRAGraphicControl;
    Piece08: TBGRAGraphicControl;
    Piece09: TBGRAGraphicControl;
    MoveToNearestSlotAnimationTimer: TTimer;
    RotateToNearest60angleAnimationTimer: TTimer;
    ShowSolutionsTimer: TTimer;
    PieceRotationTrackBar: TTrackBar;
    procedure AddDeletePlayerButtonClick(Sender: TObject);
    procedure BoardRedraw(Sender: TObject; Bitmap: TBGRABitmap);
    procedure ErrorCircleImageClick(Sender: TObject);
    procedure ErrorCircleImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ErrorCircleImageRedraw(Sender: TObject; Bitmap: TBGRABitmap);
    procedure FixButtonClick(Sender: TObject);
    procedure FlipButtonClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure PlayerSelectComboBoxChange(Sender: TObject);
    procedure ShowSavedSolutionsButtonClick(Sender: TObject);
    procedure NewGameButtonClick(Sender: TObject);
    procedure Piece01MouseDown(Sender: TObject; Button: TMouseButton;  Shift: TShiftState; X, Y: Integer);
    procedure Piece01MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure Piece01MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Piece02MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Piece02MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure Piece02MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Piece03MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Piece03MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure Piece03MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Piece04MouseDown(Sender: TObject; Button: TMouseButton;  Shift: TShiftState; X, Y: Integer);
    procedure Piece04MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure Piece04MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Piece05MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Piece05MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure Piece05MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Piece06MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Piece06MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure Piece06MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Piece07MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Piece07MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure Piece07MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Piece08MouseDown(Sender: TObject; Button: TMouseButton;  Shift: TShiftState; X, Y: Integer);
    procedure Piece08MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure Piece08MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Piece09MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Piece09MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure Piece09MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Piece10Click(Sender: TObject);
    procedure Piece10MouseDown(Sender: TObject; Button: TMouseButton;  Shift: TShiftState; X, Y: Integer);
    procedure Piece10MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure Piece10MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Piece10Redraw(Sender: TObject; Bitmap: TBGRABitmap);
    procedure Piece11Click(Sender: TObject);
    procedure Piece11MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Piece11MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure Piece11MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Piece11Redraw(Sender: TObject; Bitmap: TBGRABitmap);
    procedure Piece12MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Piece12MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure Piece12MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Piece12Redraw(Sender: TObject; Bitmap: TBGRABitmap);
    procedure Piece13MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Piece13MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure Piece13MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Piece13Redraw(Sender: TObject; Bitmap: TBGRABitmap);
    procedure Piece01Redraw(Sender: TObject; Bitmap: TBGRABitmap);
    procedure Piece02Redraw(Sender: TObject; Bitmap: TBGRABitmap);
    procedure Piece03Redraw(Sender: TObject; Bitmap: TBGRABitmap);
    procedure Piece04Redraw(Sender: TObject; Bitmap: TBGRABitmap);
    procedure Piece05Redraw(Sender: TObject; Bitmap: TBGRABitmap);
    procedure Piece06Redraw(Sender: TObject; Bitmap: TBGRABitmap);
    procedure Piece07Redraw(Sender: TObject; Bitmap: TBGRABitmap);
    procedure Piece08Redraw(Sender: TObject; Bitmap: TBGRABitmap);
    procedure Piece09Redraw(Sender: TObject; Bitmap: TBGRABitmap);
    procedure FormCreate(Sender: TObject);
    procedure RotateToNearest60angleAnimationTimerStartTimer(Sender: TObject);
    procedure RotateToNearest60angleAnimationTimerTimer(Sender: TObject);
    procedure ShowSolutionsTimerTimer(Sender: TObject);
    procedure MoveToNearestSlotAnimationTimerStartTimer(Sender: TObject);
    procedure MoveToNearestSlotAnimationTimerTimer(Sender: TObject);
    procedure PieceRotationTrackBarChange(Sender: TObject);
    procedure PieceRotationTrackBarMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    function MessageDlgEx(const AMsg: string; ADlgType: TMsgDlgType; AButtons: TMsgDlgButtons; AParent: TForm): TModalResult;
    procedure RedrawCurrentPiece();
    procedure RedrawAllPieces();
    procedure SimplifySolution();
    procedure LoadPiecesIntoBoard();
    procedure LoadNextSolution(slideshow_direction: Integer);
    procedure ClearBoard();
    procedure ClearSlot(slot_number: Integer);
    procedure StartNewGame();
    procedure PlacePieceToStartPosition(piece_number: Integer);
    procedure ConvertPieceSlotPositionIntoSlotContent(piece_slot_position: Integer; piece_number: Integer);
    procedure PlacePieceIntoBoardToFindCollisions(piece_number: Integer; slot_number: Integer);
    function FindCollidingSpikesCoordinates(slot_number_1: Integer; spike_position_1: Integer; slot_number_2: Integer; spike_position_2: Integer): Integer;
    procedure SaveSolution();
    procedure UpdateSavedPuzzleFile(new_filename: TFileName; old_filename: TFileName);
    procedure LoadPlayerNames();


  public


    board_image: TBGRABitmap;
    piece_image_01: TBGRABitmap;
    piece_image_02: TBGRABitmap;
    piece_image_03: TBGRABitmap;
    piece_image_04: TBGRABitmap;
    piece_image_05: TBGRABitmap;
    piece_image_06: TBGRABitmap;
    piece_image_07: TBGRABitmap;
    piece_image_08: TBGRABitmap;
    piece_image_09: TBGRABitmap;
    piece_image_10: TBGRABitmap;
    piece_image_11: TBGRABitmap;
    piece_image_12: TBGRABitmap;
    piece_image_13: TBGRABitmap;
    output_image: TBGRABitmap;




  end;

var
  PuzzleGameForm: TPuzzleGameForm;


  bitmap_resource: TBitmap;
  png: TPortableNetworkGraphic;


  board_offset_x, board_offset_y: Integer;
  x_distance_between_slots, y_distance_between_slots, distance_between_pieces, pieces_top: Integer;

  board_border_x_center: array [0 .. 15] of integer;
  board_border_y_center: array [0 .. 15] of integer;
  board_border_radius: Single;
  board_border_color: TBGRAPixel;
  board_border_pen_width, error_circle_pen_width, error_circle_pen_width_div_2: Integer;


  current_piece: Integer;
  current_slot: Integer;

  piece_rotation_angle: array [0 .. 12] of Integer;
  piece_is_flipped: array [0 .. 12] of Boolean;
  piece_slot_address: array [0 .. 12] of Integer;


  slot_content: array [0 .. 12] of Integer;
  slot_left: array [0 .. 12] of integer;
  slot_top: array [0 .. 12] of integer;
  slot_x_center: array [0 .. 12] of integer;
  slot_y_center: array [0 .. 12] of integer;


  piece_quarter_size: Integer;
  piece_half_size: Integer;

  current_piece_marking_ellipse_radius, current_piece_marking_ellipse_diameter: Integer;
  current_piece_marking_ellipse_rect: TRect;

  error_spike_angle: Double;


  x_animation_increment, y_animation_increment, current_x_position, current_y_position: Double;
  number_of_animation_steps: Double;
  current_rotation_angle, final_rotation_angle, rotation_increment: Integer;
  rotation_increment_default: Integer;
  angle_difference: Integer;
  mouse_rotation_angle_difference, mouse_rotation_angle, mouse_rotation_angle_original: Double;
  angle_6th_part: Double;

  mousetop, mouseleft: Integer;
  clicked_X, clicked_Y: Integer;
  distance_x, distance_y, distance_r: Integer;
  rotation_mode: Boolean;
  mouse_button_pressed: Boolean;



  saved_puzzle_memo, fixed_puzzle_memo: TMemo;
  solved_puzzle_string: String;
  saved_puzzle_number: Integer;

  slideshow_mode: Boolean;
  saved_puzzle_stringlist: TStringList;
  date_and_time_string, old_date_and_time_string: String;


  file_handle: Longint;
  resources_filepath: TFileName;
  player_names_filename,  player_names_full_filename,  player_names_filepath: TFileName;
  player_names_memo: TMemo;

  puzzle_solutions_filename, puzzle_solutions_full_filename, puzzle_solutions_filepath: TFileName;
  puzzle_solutions_saved_file_age: Integer;
  current_date: TDateTime;





const
  PIECE_SIZE = 200;



//  spikes listed starting from the very top going clockwise
//  array size 13x6
    piece_spike_table: array of Integer = (
    1, 1, 1, 1, 1, 1, // 1 piece
    1, 1, 1, 0, 1, 1, // 2 piece
    1, 1, 0, 0, 1, 1, // 3 piece
    0, 1, 1, 0, 1, 1, // 4 piece
    1, 0, 1, 1, 1, 0, // 5 piece
    0, 0, 1, 1, 1, 0, // 6 piece
    1, 0, 1, 0, 1, 0, // 7 piece
    1, 0, 0, 1, 1, 0, // 8 piece
    1, 0, 0, 0, 1, 0, // 9 piece
    0, 0, 0, 0, 1, 1, // 10 piece
    1, 0, 0, 1, 0, 0, // 11 piece
    1, 0, 0, 0, 0, 0, // 12 piece
    1, 0, 0, 0, 0, 0); // 13 piece


    board_spike_table: array of Integer = (
    0, 0, 0, 0, 0, 0, // 1 slot
    0, 0, 0, 0, 0, 0, // 2 slot
    0, 0, 0, 0, 0, 0, // 3 slot
    0, 0, 0, 0, 0, 0, // 4 slot
    0, 0, 0, 0, 0, 0, // 5 slot
    0, 0, 0, 0, 0, 0, // 6 slot
    0, 0, 0, 0, 0, 0, // 7 slot
    0, 0, 0, 0, 0, 0, // 8 slot
    0, 0, 0, 0, 0, 0, // 9 slot
    0, 0, 0, 0, 0, 0, // 10 slot
    0, 0, 0, 0, 0, 0, // 11 slot
    0, 0, 0, 0, 0, 0, // 12 slot
    0, 0, 0, 0, 0, 0); // 13 slot


    board_colliding_spikes_table: array of Integer = (
    0, 0, 0, 0, 0, 0, // 1 slot
    0, 0, 0, 0, 0, 0, // 2 slot
    0, 0, 0, 0, 0, 0, // 3 slot
    0, 0, 0, 0, 0, 0, // 4 slot
    0, 0, 0, 0, 0, 0, // 5 slot
    0, 0, 0, 0, 0, 0, // 6 slot
    0, 0, 0, 0, 0, 0, // 7 slot
    0, 0, 0, 0, 0, 0, // 8 slot
    0, 0, 0, 0, 0, 0, // 9 slot
    0, 0, 0, 0, 0, 0, // 10 slot
    0, 0, 0, 0, 0, 0, // 11 slot
    0, 0, 0, 0, 0, 0, // 12 slot
    0, 0, 0, 0, 0, 0); // 13 slot



implementation

{$R *.lfm}

{ TPuzzleGameForm }



// https://lazarus-ccr.sourceforge.io/docs/lazutils/uitypes/tmsgdlgtype.html
//
//type TMsgDlgType = (
//  mtWarning, //Warning message box with an Exclamation mark icon
//  mtError, //Error message box with Stop sign icon
//  mtInformation, //Information message box with an Info icon
//  mtConfirmation, //Confirmation message box with a Question mark icon
//  mtCustom // Custom message box; No icon is displayed, and the caption contains the value in ApplicationName
//);

function TPuzzleGameForm.MessageDlgEx(const AMsg: string; ADlgType: TMsgDlgType;
  AButtons: TMsgDlgButtons; AParent: TForm): TModalResult;
var
  MsgFrm: TForm;
begin
  MsgFrm := CreateMessageDialog(AMsg, ADlgType, AButtons);
  try
    MsgFrm.Position := poDefaultSizeOnly;
    MsgFrm.FormStyle := fsSystemStayOnTop;
    MsgFrm.Left := AParent.Left + (AParent.Width - MsgFrm.Width) div 2;
    MsgFrm.Top := AParent.Top + (AParent.Height - MsgFrm.Height) div 2;
    Result := MsgFrm.ShowModal;
  finally
    MsgFrm.Free
  end;
end;


//  ClearSlot(piece_slot_address[12]);
procedure TPuzzleGameForm.ClearSlot(slot_number: Integer);
var
   n: Integer;
begin

OutputLabel.Visible := false;
DateLabel.Visible := false;


piece_slot_address[current_piece-1] := 0;
slot_content[slot_number-1] := 0;
current_slot := 0;


for n := 0 to 5 do
begin
board_spike_table[(slot_number-1)*6 + n] := 0;
end;


//for n := 0 to 77 do // 6 *13 = 78
//board_colliding_spikes_table[n] := 0;


end;


function TPuzzleGameForm.FindCollidingSpikesCoordinates(slot_number_1: Integer; spike_position_1: Integer; slot_number_2: Integer; spike_position_2: Integer): Integer;
var i, i2: Integer;
begin

DebugLabel.Caption := 'no collisions found';

if ((slot_number_1 < 1) or (slot_number_2 < 1)) then
ShowMessage('Error: (slot_number_1 < 1) or (slot_number_2 < 1)');



i :=  (slot_number_1-1)*6 + spike_position_1-1;
i2 := (slot_number_2-1)*6 + spike_position_2-1;



board_colliding_spikes_table[i] := board_colliding_spikes_table[i] + board_colliding_spikes_table[i2];


if(board_colliding_spikes_table[i] > 1) then
begin
//SaveButton.Enabled := false;


error_spike_angle := DegToRad(((spike_position_1-1)*60)-90);

//ErrorCircleImage.Left := slot_left[slot_number_1-1];
//ErrorCircleImage.Top := slot_top[slot_number_1-1];

ErrorCircleImage.Left := slot_left[slot_number_1-1] + piece_half_size + Round(80*cos(error_spike_angle) - current_piece_marking_ellipse_radius) - error_circle_pen_width_div_2;
ErrorCircleImage.Top := slot_top[slot_number_1-1] + piece_half_size + Round(80*sin(error_spike_angle) - current_piece_marking_ellipse_radius) - error_circle_pen_width_div_2;








ErrorCircleImage.BringToFront();
ErrorCircleImage.Visible := true;

//DebugLabel.Visible := true;
//DebugLabel.Caption := 'error_spike_angle = ' + FloatToStr(error_spike_angle) + ', x = ' + FloatToStr(80*cos(error_spike_angle)) + ', y = ' + FloatToStr(80*sin(error_spike_angle));

//DebugLabel.Caption := 'collision at slot ' + IntToStr(slot_number_1) + ' spike = ' + IntToStr(spike_position_1) + '(' + IntToStr(board_colliding_spikes_table[(slot_number_1-1)*6 + 0]) + IntToStr(board_colliding_spikes_table[(slot_number_1-1)*6 + 1]) + IntToStr(board_colliding_spikes_table[(slot_number_1-1)*6 + 2]) + IntToStr(board_colliding_spikes_table[(slot_number_1-1)*6 + 3]) + IntToStr(board_colliding_spikes_table[(slot_number_1-1)*6 + 4]) + IntToStr(board_colliding_spikes_table[(slot_number_1-1)*6 + 5]) + ')' +

DebugLabel.Caption := 'collision at slot ' + IntToStr(slot_number_1) + ' spike ' + IntToStr(spike_position_1) + '(' + IntToStr(board_spike_table[(slot_number_1-1)*6 + 0]) + IntToStr(board_spike_table[(slot_number_1-1)*6 + 1]) + IntToStr(board_spike_table[(slot_number_1-1)*6 + 2]) + IntToStr(board_spike_table[(slot_number_1-1)*6 + 3]) + IntToStr(board_spike_table[(slot_number_1-1)*6 + 4]) + IntToStr(board_spike_table[(slot_number_1-1)*6 + 5]) + ')' +
 ' and slot ' + IntToStr(slot_number_2) + ' spike ' + IntToStr(spike_position_2) + '(' + IntToStr(board_spike_table[(slot_number_2-1)*6 + 0]) + IntToStr(board_spike_table[(slot_number_2-1)*6 + 1]) + IntToStr(board_spike_table[(slot_number_2-1)*6 + 2]) + IntToStr(board_spike_table[(slot_number_2-1)*6 + 3]) + IntToStr(board_spike_table[(slot_number_2-1)*6 + 4]) + IntToStr(board_spike_table[(slot_number_2-1)*6 + 5]) + ')';


end; //if(board_colliding_spikes_table[i] > 1)


result := board_colliding_spikes_table[i];

end;


// PlacePieceIntoBoardToFindCollisions(1, current_slot);
procedure TPuzzleGameForm.PlacePieceIntoBoardToFindCollisions(piece_number: Integer; slot_number: Integer);
var
   n, n1, n2, slot_number_2, number_of_filled_slots: Integer;
   piece_spikes_rotated_and_flipped: array [0 .. 5] of Integer;
   temp_spike, rotation_steps: Integer;
begin

if (slot_number = 0) then
Exit();


 ErrorCircleImage.Visible := false;
 DebugLabel.Visible := false;
 OutputLabel.Visible := false;
 DateLabel.Visible := false;



//check for duplicate error
 for n := 0 to 12 do
 begin
   for n2 := 0 to 12 do
   begin
     if (n <> n2) then
     begin

       if ((slot_content[n] = slot_content[n2]) and (slot_content[n] <> 0)) then
       begin
        DebugLabel.Visible := true;
        DebugLabel.Caption := 'Error: slot_content duplicates for slots: ' + IntToStr(n+1) + ', ' + IntToStr(n2+1)+  ', slot_content = ' + IntToStr(slot_content[n]);
        Exit;
       end;

       if ((piece_slot_address[n] = piece_slot_address[n2]) and (piece_slot_address[n] <> 0)) then
       begin
        DebugLabel.Visible := true;
        DebugLabel.Caption := 'Error: piece_slot_address duplicates for pieces: ' + IntToStr(n+1) + ', ' + IntToStr(n2+1) +  ', piece_slot_address = ' + IntToStr(piece_slot_address[n]);
        Exit;
       end;

     end; //  if (n <> n2)
   end; //  for n2 := 0 to 12 do
 end; // for n := 0 to 12 do



 for n := 0 to 5 do
 piece_spikes_rotated_and_flipped[n] := piece_spike_table[(piece_number-1)*6 + n];



 if( piece_rotation_angle[piece_number-1] <> 0) then
 begin
   rotation_steps := piece_rotation_angle[piece_number-1] div 60;

//   DebugLabel.Visible := true;
//   DebugLabel.Caption := 'rotation_steps = ' + IntToStr(rotation_steps);

  if(rotation_steps < 0) then
  begin
  for n := 0 to (-1*rotation_steps)-1 do
  begin  //DebugLabel.Caption := '-1';
    temp_spike := piece_spikes_rotated_and_flipped[0];
    piece_spikes_rotated_and_flipped[0] := piece_spikes_rotated_and_flipped[1];
    piece_spikes_rotated_and_flipped[1] := piece_spikes_rotated_and_flipped[2];
    piece_spikes_rotated_and_flipped[2] := piece_spikes_rotated_and_flipped[3];
    piece_spikes_rotated_and_flipped[3] := piece_spikes_rotated_and_flipped[4];
    piece_spikes_rotated_and_flipped[4] := piece_spikes_rotated_and_flipped[5];
    piece_spikes_rotated_and_flipped[5] := temp_spike;
   end; //for n := 0 to rotation_steps do
  end //    if(rotation_steps < 0) do
  else
  begin   //DebugLabel.Caption := '+1';
  for n := 0 to rotation_steps-1 do
  begin
   temp_spike := piece_spikes_rotated_and_flipped[5];
   piece_spikes_rotated_and_flipped[5] := piece_spikes_rotated_and_flipped[4];
   piece_spikes_rotated_and_flipped[4] := piece_spikes_rotated_and_flipped[3];
   piece_spikes_rotated_and_flipped[3] := piece_spikes_rotated_and_flipped[2];
   piece_spikes_rotated_and_flipped[2] := piece_spikes_rotated_and_flipped[1];
   piece_spikes_rotated_and_flipped[1] := piece_spikes_rotated_and_flipped[0];
   piece_spikes_rotated_and_flipped[0] := temp_spike;
  end; //for n := 0 to rotation_steps do

  end; // else -->  if(rotation_steps < 0) do
 end; // if( piece_rotation_angle[piece_number-1] <> 0) then


 // 2 <-> 6  horizontal flip
 // 3 <-> 5 horizontal flip
  if (piece_is_flipped[piece_number-1] = true) then
  begin
 // ShowMessage('flipped');
    temp_spike := piece_spikes_rotated_and_flipped[1];
    piece_spikes_rotated_and_flipped[1] := piece_spikes_rotated_and_flipped[5];
    piece_spikes_rotated_and_flipped[5] := temp_spike;

    temp_spike := piece_spikes_rotated_and_flipped[2];
    piece_spikes_rotated_and_flipped[2] := piece_spikes_rotated_and_flipped[4];
    piece_spikes_rotated_and_flipped[4] := temp_spike;
  end;


 for n := 0 to 5 do
 board_spike_table[(slot_number-1)*6 + n] := piece_spikes_rotated_and_flipped[n];







 for n := 0 to 77 do // 6 *13 = 78
 board_colliding_spikes_table[n] := board_spike_table[n];


 //FindCollidingSpikesCoordinates(slot_number_1, spike_position1, slot_number_2, spike_position_2);

if (FindCollidingSpikesCoordinates(1, 2, 2, 6) > 1) then
Exit();
if (FindCollidingSpikesCoordinates(2, 2, 3, 6) > 1) then
Exit();
if (FindCollidingSpikesCoordinates(3, 2, 4, 6) > 1) then
Exit();
//===========
if (FindCollidingSpikesCoordinates(1, 5, 5, 1) > 1) then
Exit();
//===========
if (FindCollidingSpikesCoordinates(1, 4, 5, 2) > 1) then
Exit();
if (FindCollidingSpikesCoordinates(1, 4, 6, 6) > 1) then
Exit();
if (FindCollidingSpikesCoordinates(5, 2, 6, 6) > 1) then
Exit();
//===========
if (FindCollidingSpikesCoordinates(1, 3, 2, 5) > 1) then
Exit();
if (FindCollidingSpikesCoordinates(1, 3, 6, 1) > 1) then
Exit();
if (FindCollidingSpikesCoordinates(2, 5, 6, 1) > 1) then
Exit();
//===========
if (FindCollidingSpikesCoordinates(2, 4, 7, 6) > 1) then
Exit();
if (FindCollidingSpikesCoordinates(2, 4, 6, 2) > 1) then
Exit();
if (FindCollidingSpikesCoordinates(6, 2, 7, 6) > 1) then
Exit();
//===========
if (FindCollidingSpikesCoordinates(2, 3, 3, 5) > 1) then
Exit();
if (FindCollidingSpikesCoordinates(2, 3, 7, 1) > 1) then
Exit();
if (FindCollidingSpikesCoordinates(3, 5, 7, 1) > 1) then
Exit();
//===========
if (FindCollidingSpikesCoordinates(4, 3, 9, 1) > 1) then
Exit();
//===========
if (FindCollidingSpikesCoordinates(3, 4, 8, 6) > 1) then
Exit();
if (FindCollidingSpikesCoordinates(3, 4, 7, 2) > 1) then
Exit();
if (FindCollidingSpikesCoordinates(7, 2, 8, 6) > 1) then
Exit();
//===========
if (FindCollidingSpikesCoordinates(3, 3, 4, 5) > 1) then
Exit();
if (FindCollidingSpikesCoordinates(3, 3, 8, 1) > 1) then
Exit();
if (FindCollidingSpikesCoordinates(4, 5, 8, 1) > 1) then
Exit();
//===========
if (FindCollidingSpikesCoordinates(4, 4, 8, 2) > 1) then
Exit();
if (FindCollidingSpikesCoordinates(4, 4, 9, 6) > 1) then
Exit();
if (FindCollidingSpikesCoordinates(8, 2, 9, 6) > 1) then
Exit();
//===========
if (FindCollidingSpikesCoordinates(5, 4, 10, 6) > 1) then
Exit();
//===========
if (FindCollidingSpikesCoordinates(5, 3, 6, 5) > 1) then
Exit();
if (FindCollidingSpikesCoordinates(5, 3, 10, 1) > 1) then
Exit();
if (FindCollidingSpikesCoordinates(6, 5, 10, 1) > 1) then
Exit();
//===========
if (FindCollidingSpikesCoordinates(6, 4, 10, 2) > 1) then
Exit();
if (FindCollidingSpikesCoordinates(6, 4, 11, 6) > 1) then
Exit();
if (FindCollidingSpikesCoordinates(10, 2, 11, 6) > 1) then
Exit();
//===========
if (FindCollidingSpikesCoordinates(10, 3, 11, 5) > 1) then
Exit();
//===========
if (FindCollidingSpikesCoordinates(11, 3, 12, 5) > 1) then
Exit();
//===========
if (FindCollidingSpikesCoordinates(12, 3, 13, 5) > 1) then
Exit();
//===========
if (FindCollidingSpikesCoordinates(13, 2, 9, 4) > 1) then
Exit();
//===========
if (FindCollidingSpikesCoordinates(6, 3, 7, 5) > 1) then
Exit();
if (FindCollidingSpikesCoordinates(6, 3, 11, 1) > 1) then
Exit();
if (FindCollidingSpikesCoordinates(7, 5, 11, 1) > 1) then
Exit();
//===========
if (FindCollidingSpikesCoordinates(7, 4, 11, 2) > 1) then
Exit();
if (FindCollidingSpikesCoordinates(7, 4, 12, 6) > 1) then
Exit();
if (FindCollidingSpikesCoordinates(11, 2, 12, 6) > 1) then
Exit();
//===========
if (FindCollidingSpikesCoordinates(7, 3, 8, 5) > 1) then
Exit();
if (FindCollidingSpikesCoordinates(7, 3, 12, 1) > 1) then
Exit();
if (FindCollidingSpikesCoordinates(8, 5, 12, 1) > 1) then
Exit();
//===========
if (FindCollidingSpikesCoordinates(8, 4, 12, 2) > 1) then
Exit();
if (FindCollidingSpikesCoordinates(8, 4, 13, 6) > 1) then
Exit();
if (FindCollidingSpikesCoordinates(13, 6, 12, 2) > 1) then
Exit();
//===========
if (FindCollidingSpikesCoordinates(8, 3, 9, 5) > 1) then
Exit();
if (FindCollidingSpikesCoordinates(8, 3, 13, 1) > 1) then
Exit();
if (FindCollidingSpikesCoordinates(9, 5, 13, 1) > 1) then
Exit();
//===========



number_of_filled_slots := 0;

for n := 0 to 12 do
if(slot_content[n] <> 0) then
inc(number_of_filled_slots);



if(number_of_filled_slots = 13) then
begin


RotateToNearest60angleAnimationTimer.Enabled := false;
MoveToNearestSlotAnimationTimer.Enabled := false;

current_piece := 0;
current_slot := 0;


// https://wiki.freepascal.org/Format_function
// https://www.thoughtco.com/add-leading-zeroes-number-delphi-format-1057555
// Use a straightforward function to change how your number displays. Use format to make the conversion by supplying a value for length (the total length of the final output) and the number you want to pad:
// str := Format('%.*d',[length, number])
// To pad the number 7 with two leading zeroes, plug those values into the code:
// str := Format('%.*d',[3, 7]);
// The result is 007 with the value returned as a string.

if (CompareStr(date_and_time_string, '') = 0) then
begin
current_date := Now();
date_and_time_string := Format('%.*d',[4, YearOf(current_date)]) + '-' + Format('%.*d',[2, MonthOf(current_date)])  + '-' + Format('%.*d',[2, DayOf(current_date)])  + '   ' + Format('%.*d',[2, HourOf(current_date)]) + ':' + Format('%.*d',[2, MinuteOf(current_date)]) ;
DateLabel.Caption := date_and_time_string;
end;

OutputImage.BringToFront();
OutputLabel.BringToFront();
OutputLabel.Caption := 'Congratulations. You have solved the puzzle.'; //'Now you can save your solved puzzle.';
OutputLabel.Visible := true;
DateLabel.Visible := true;

SaveSolution();

end; // if(number_of_filled_slots = 13)



end;



procedure TPuzzleGameForm.UpdateSavedPuzzleFile(new_filename: TFileName; old_filename: TFileName);
begin

// https://www.freepascal.org/docs-html/rtl/dateutils/comparedatetime.html
// function CompareDateTime(const A: TDateTime; const B: TDateTime):TValueRelationship;
// CompareDateTime compares two timestamps A and B and returns the following results:
// < 0 if A is earlier in date/time than B.
// = 0 if A and B are the same date/time.
// > 0 if A is later in date/time than B.

puzzle_solutions_saved_file_age := 0;

if((FileExists(new_filename)) and (FileExists(old_filename))) then
begin
puzzle_solutions_saved_file_age :=  CompareDateTime( DateOf(FileDateToDateTime(FileAge(new_filename))), DateOf(FileDateToDateTime(FileAge(old_filename))) );
if(  puzzle_solutions_saved_file_age = 0) then
puzzle_solutions_saved_file_age := CompareTime( FileDateToDateTime(FileAge(new_filename)), FileDateToDateTime(FileAge(old_filename)) );
end;


  if((not FileExists(old_filename)) or ( puzzle_solutions_saved_file_age > 0))then
  begin
  DeleteFile(old_filename);
  CopyFile(new_filename, old_filename);
//  MessageDlgEx(PCHAR(new_filename + LineEnding + 'file updated to newer version.'), mtInformation, [mbOk], PuzzleGameForm)
//  MessageDlgEx(PCHAR('Saved puzzles file location:' + LineEnding + old_filename), mtInformation, [mbOk], PuzzleGameForm)
  end;


end;



procedure TPuzzleGameForm.LoadPlayerNames();
var
  n: Integer;
begin

PlayerSelectComboBox.Items.Clear();
PlayerSelectComboBox.Items.Add('Add new player');
PlayerSelectComboBox.Items.Add('Delete player');
PlayerSelectComboBox.Items.Add('Player');
PlayerSelectComboBox.ItemIndex := 2; // Player

try
player_names_memo.Lines.LoadFromFile(player_names_full_filename);

for n := 1 to player_names_memo.Lines.Count-1 do
begin
  PlayerSelectComboBox.Items.Add(player_names_memo.Lines[n]);
  puzzle_solutions_filename := player_names_memo.Lines[n] + '.txt';
  puzzle_solutions_full_filename := puzzle_solutions_filepath + puzzle_solutions_filename;
  UpdateSavedPuzzleFile(resources_filepath + puzzle_solutions_filename, puzzle_solutions_full_filename);
end; // for n:= 0 to player_names_memo.Lines.Count-1 do

PlayerSelectComboBox.ItemIndex := StrToIntDef(player_names_memo.Lines[0], 0) + 2;

//-------------------------------
if ((PlayerSelectComboBox.ItemIndex - 2) > 0) then
begin
puzzle_solutions_filename := player_names_memo.Lines[PlayerSelectComboBox.ItemIndex - 2] + '.txt';
puzzle_solutions_full_filename := puzzle_solutions_filepath + puzzle_solutions_filename;
end
else
begin
puzzle_solutions_filename := 'Player.txt';
puzzle_solutions_full_filename := puzzle_solutions_filepath + puzzle_solutions_filename;
end;

//ShowMessage(puzzle_solutions_filename);

if(not FileExists(puzzle_solutions_full_filename)) then
MessageDlgEx(PCHAR('Error: file not found:' + LineEnding + puzzle_solutions_full_filename), mtError, [mbOk], PuzzleGameForm)
//-------------------------------


except
//
end;

end;


procedure TPuzzleGameForm.FormCreate(Sender: TObject);
var
  n: Integer;
{$IFDEF DARWIN}
     AppMenu: TMenuItem;
{$ENDIF}

begin

{$IFDEF DARWIN}
AppMenu := TMenuItem.Create(Self); // Application menu
AppMenu.Caption := #$EF#$A3#$BF;   // Unicode Apple logo char
//MainMenu.Items.Insert(0, AppMenu);
MainMenu.Items.Insert(0, AppMenu);
{$ENDIF}


{$IF Defined(LINUX)}
OutputLabel.FontEx.Height := 40;
{$IFEND}



//PlayerSelectComboBox.Top := -100;
PlayerNameEdit.Text := '';
PlayerNameEdit.Visible := false;
AddDeletePlayerButton.Visible := false;


player_names_memo := TMemo.Create(nil);






  DebugLabel.Visible := false;
  FixButton.Visible := false;

  OutputImage.Visible := false;
  OutputLabel.Visible := false;
  DateLabel.Visible := false;
  ErrorCircleImage.Visible := false;


  player_names_filename := 'puzzle_game_players.txt';


  {$IF Defined(DARWIN)}
  resources_filepath := ExtractFilePath(ExcludeTrailingPathDelimiter(ExtractFilePath(ParamStr(0)))) + 'Resources/';
  {$ELSEIF Defined(WINDOWS)}
  resources_filepath := '';
  {$ELSEIF Defined(LINUX)}
  resources_filepath := './';
  {$ELSE}
  resources_filepath := './';
  {$IFEND}





  {$IF Defined (DARWIN)} // macOS
  puzzle_solutions_filepath := GetUserDir();
  puzzle_solutions_filepath := puzzle_solutions_filepath + 'Library/Application Support/Cognaxon/Kwazy_Quilt_Puzzle_No_7114/';
  {$ELSEIF Defined (WINDOWS)}

  // https://www.freepascal.org/docs-html/rtl/sysutils/getappconfigdir.html
  // C:\Users\mantas\AppData\Roaming\Cognaxon\Kwazy_Quilt_Puzzle_No_7114
  // C:\Users\mantas\AppData\Local\Kwazy_Quilt_Puzzle_No_7114\Cognaxon\Kwazy_Quilt_Puzzle_No_7114

  //puzzle_solutions_filepath := GetAppConfigDir(True);
  puzzle_solutions_filepath := GetAppConfigDir(False);
  puzzle_solutions_filepath := ExtractFilePath(ExcludeTrailingPathDelimiter(puzzle_solutions_filepath)); //parentDirPath
  puzzle_solutions_filepath := puzzle_solutions_filepath + 'Cognaxon\Kwazy_Quilt_Puzzle_No_7114\';

//  puzzle_solutions_full_filename := ExcludeTrailingPathDelimiter(ExtractFilePath(ParamStr(0))) + PathDelim + puzzle_solutions_filename;

  {$ELSE}
//          puzzle_solutions_full_filename := ChangeFileExt( ParamStr(0), '.ini' );
//   puzzle_solutions_filepath := ExcludeTrailingPathDelimiter(ExtractFilePath(ParamStr(0)));
     puzzle_solutions_filepath := GetUserDir() + 'Cognaxon/Kwazy_Quilt_Puzzle_No_7114/';
//   puzzle_solutions_full_filename := ExcludeTrailingPathDelimiter(ExtractFilePath(ParamStr(0))) + PathDelim + puzzle_solutions_filename;
  {$ENDIF}

//  ShowMessage(puzzle_solutions_filepath);

  puzzle_solutions_filepath := ExcludeTrailingPathDelimiter(puzzle_solutions_filepath) + PathDelim;
  player_names_filepath := puzzle_solutions_filepath;

  if(ForceDirectories(puzzle_solutions_filepath)) then
  begin
  player_names_full_filename := player_names_filepath + player_names_filename;
  puzzle_solutions_full_filename := puzzle_solutions_filepath + puzzle_solutions_filename;
  end;

  //ShowMessage(DateTimeToStr(FileDateToDateTime(FileAge(puzzle_solutions_filename))) + LineEnding + DateTimeToStr(FileDateToDateTime(FileAge(puzzle_solutions_full_filename))) );


  UpdateSavedPuzzleFile(resources_filepath + player_names_filename, player_names_full_filename);


  if (not FileExists(player_names_full_filename)) then
  begin
  player_names_memo.Lines.Clear;
  player_names_memo.Lines.Add('0');
  player_names_memo.Lines.SaveToFile(player_names_full_filename);
  end;


  puzzle_solutions_filename := 'Player.txt';
  puzzle_solutions_full_filename := puzzle_solutions_filepath + puzzle_solutions_filename;

  UpdateSavedPuzzleFile(resources_filepath + puzzle_solutions_filename, puzzle_solutions_full_filename);

  if (not FileExists(puzzle_solutions_full_filename)) then
  begin
  file_handle := FileCreate(puzzle_solutions_full_filename);
  FileClose(file_handle);
  end;


  LoadPlayerNames();



  current_slot := 0;
  error_spike_angle := 0.0;

  slideshow_mode := false;
  PuzzleGameForm.KeyPreview := true; // this enables the form to receive keypress events

//  board_border_color := TColor($012188);
  board_border_color := TColor($566a85); // <<<-----  R and B colors are inverted RGB becomes BRG

  board_border_pen_width := 9;
  error_circle_pen_width := 10;
  error_circle_pen_width_div_2 := error_circle_pen_width div 2;


  PieceRotationTrackBar.Visible := false;

  board_offset_x := 20;
  board_offset_y := 30;
  board_border_radius := 0.0;



  mousetop := 0;
  mouseleft := 0;

  saved_puzzle_number := 0;

  saved_puzzle_memo := TMemo.Create(nil);
  fixed_puzzle_memo := TMemo.Create(nil);

  current_piece := 0;
  mouse_button_pressed := false;

  number_of_animation_steps := 10.0;




  current_rotation_angle := 0;
  final_rotation_angle := 0;
  rotation_increment := 0;
  angle_difference := 0;
  rotation_increment_default := 5;


  distance_x := 0;
  distance_y := 0;
  distance_r := 0;
  rotation_mode := false;
  mouse_rotation_angle_difference := 0.0;
  mouse_rotation_angle := 0.0;
  mouse_rotation_angle_original := 0.0;


  piece_half_size := PIECE_SIZE div 2;
  piece_quarter_size := PIECE_SIZE div 4;
//  piece_quarter_size := PIECE_SIZE div 2;

  current_piece_marking_ellipse_radius := PIECE_SIZE div 16;
  current_piece_marking_ellipse_diameter := current_piece_marking_ellipse_radius * 2;

  ErrorCircleImage.Width := current_piece_marking_ellipse_diameter + error_circle_pen_width;
  ErrorCircleImage.Height := current_piece_marking_ellipse_diameter + error_circle_pen_width;

  Piece01.Width := PIECE_SIZE;
  Piece01.Height:= PIECE_SIZE;
  Piece02.Width := PIECE_SIZE;
  Piece02.Height:= PIECE_SIZE;
  Piece03.Width := PIECE_SIZE;
  Piece03.Height:= PIECE_SIZE;
  Piece04.Width := PIECE_SIZE;
  Piece04.Height:= PIECE_SIZE;
  Piece05.Width := PIECE_SIZE;
  Piece05.Height:= PIECE_SIZE;
  Piece06.Width := PIECE_SIZE;
  Piece06.Height:= PIECE_SIZE;
  Piece07.Width := PIECE_SIZE;
  Piece07.Height:= PIECE_SIZE;
  Piece08.Width := PIECE_SIZE;
  Piece08.Height:= PIECE_SIZE;
  Piece09.Width := PIECE_SIZE;
  Piece09.Height:= PIECE_SIZE;
  Piece10.Width := PIECE_SIZE;
  Piece10.Height:= PIECE_SIZE;
  Piece11.Width := PIECE_SIZE;
  Piece11.Height:= PIECE_SIZE;
  Piece12.Width := PIECE_SIZE;
  Piece12.Height:= PIECE_SIZE;
  Piece13.Width := PIECE_SIZE;
  Piece13.Height:= PIECE_SIZE;



  board_border_radius := PIECE_SIZE * 0.32;


  current_piece_marking_ellipse_rect := TRect.Create(piece_half_size - current_piece_marking_ellipse_radius, piece_half_size - current_piece_marking_ellipse_radius, piece_half_size + current_piece_marking_ellipse_radius, piece_half_size + current_piece_marking_ellipse_radius);



   piece_slot_address[0] := 0;
   piece_slot_address[1] := 0;
   piece_slot_address[2] := 0;
   piece_slot_address[3] := 0;
   piece_slot_address[4] := 0;
   piece_slot_address[5] := 0;
   piece_slot_address[6] := 0;
   piece_slot_address[7] := 0;
   piece_slot_address[8] := 0;
   piece_slot_address[9] := 0;
   piece_slot_address[10] := 0;
   piece_slot_address[11] := 0;
   piece_slot_address[12] := 0;


  //with the tool provided in lazarus\tools\ called lazres, you can add any icon/image or any other file, into a resource file.
   Screen.Cursors[1] :=  LoadCursorFromLazarusResource('HAND_GRABBER');
   Screen.Cursors[2] :=  LoadCursorFromLazarusResource('HAND_GRABBER_FIST');

   Piece01.Cursor := 1;
   Piece02.Cursor := 1;
   Piece03.Cursor := 1;
   Piece04.Cursor := 1;
   Piece05.Cursor := 1;
   Piece06.Cursor := 1;
   Piece07.Cursor := 1;
   Piece08.Cursor := 1;
   Piece09.Cursor := 1;
   Piece10.Cursor := 1;
   Piece11.Cursor := 1;
   Piece12.Cursor := 1;
   Piece13.Cursor := 1;


  pieces_top := 460;

//  x_distance_between_slots := Round(PIECE_SIZE*0.66);
//  y_distance_between_slots := Round(PIECE_SIZE*0.5);

  x_distance_between_slots := Round(PIECE_SIZE*0.68);
  y_distance_between_slots := Round(PIECE_SIZE*0.60);



  distance_between_pieces := Round(PIECE_SIZE*1.0);


  Board.Caption := '';
  Piece01.Caption := '';
  Piece02.Caption := '';
  Piece03.Caption := '';
  Piece04.Caption := '';
  Piece05.Caption := '';
  Piece06.Caption := '';
  Piece07.Caption := '';
  Piece08.Caption := '';
  Piece09.Caption := '';
  Piece10.Caption := '';
  Piece11.Caption := '';
  Piece12.Caption := '';
  Piece13.Caption := '';
  ErrorCircleImage.Caption := '';





  slot_left[0] := x_distance_between_slots div 2 + board_offset_x;
  slot_left[1] := x_distance_between_slots div 2 + x_distance_between_slots + board_offset_x;
  slot_left[2] := x_distance_between_slots div 2 + x_distance_between_slots*2 + board_offset_x;
  slot_left[3] := x_distance_between_slots div 2 + x_distance_between_slots*3 + board_offset_x;
  slot_left[4] := 0 + board_offset_x;
  slot_left[5] := x_distance_between_slots + board_offset_x;
  slot_left[6] := x_distance_between_slots*2 + board_offset_x;
  slot_left[7] := x_distance_between_slots*3 + board_offset_x;
  slot_left[8] := x_distance_between_slots*4 + board_offset_x;
  slot_left[9] := x_distance_between_slots div 2 + board_offset_x;
  slot_left[10] := x_distance_between_slots div 2 + x_distance_between_slots + board_offset_x;
  slot_left[11] := x_distance_between_slots div 2 + x_distance_between_slots*2 + board_offset_x;
  slot_left[12] := x_distance_between_slots div 2 + x_distance_between_slots*3 + board_offset_x;


  slot_top[0] := 0 + board_offset_y;
  slot_top[1] := 0 + board_offset_y;
  slot_top[2] := 0 + board_offset_y;
  slot_top[3] := 0 + board_offset_y;
  slot_top[4] := y_distance_between_slots + board_offset_y;
  slot_top[5] := y_distance_between_slots + board_offset_y;
  slot_top[6] := y_distance_between_slots + board_offset_y;
  slot_top[7] := y_distance_between_slots + board_offset_y;
  slot_top[8] := y_distance_between_slots + board_offset_y;
  slot_top[9] := y_distance_between_slots*2 + board_offset_y;
  slot_top[10] := y_distance_between_slots*2 + board_offset_y;
  slot_top[11] := y_distance_between_slots*2 + board_offset_y;
  slot_top[12] := y_distance_between_slots*2 + board_offset_y;



  slot_x_center[0] := slot_left[0] + piece_half_size;
  slot_x_center[1] := slot_left[1] + piece_half_size;
  slot_x_center[2] := slot_left[2] + piece_half_size;
  slot_x_center[3] := slot_left[3] + piece_half_size;
  slot_x_center[4] := slot_left[4] + piece_half_size;
  slot_x_center[5] := slot_left[5] + piece_half_size;
  slot_x_center[6] := slot_left[6] + piece_half_size;
  slot_x_center[7] := slot_left[7] + piece_half_size;
  slot_x_center[8] := slot_left[8] + piece_half_size;
  slot_x_center[9] := slot_left[9] + piece_half_size;
  slot_x_center[10] := slot_left[10] + piece_half_size;
  slot_x_center[11] := slot_left[11] + piece_half_size;
  slot_x_center[12] := slot_left[12] + piece_half_size;


  slot_y_center[0] := slot_top[0] + piece_half_size;
  slot_y_center[1] := slot_top[1] + piece_half_size;
  slot_y_center[2] := slot_top[2] + piece_half_size;
  slot_y_center[3] := slot_top[3] + piece_half_size;
  slot_y_center[4] := slot_top[4] + piece_half_size;
  slot_y_center[5] := slot_top[5] + piece_half_size;
  slot_y_center[6] := slot_top[6] + piece_half_size;
  slot_y_center[7] := slot_top[7] + piece_half_size;
  slot_y_center[8] := slot_top[8] + piece_half_size;
  slot_y_center[9] := slot_top[9] + piece_half_size;
  slot_y_center[10] := slot_top[10] + piece_half_size;
  slot_y_center[11] := slot_top[11] + piece_half_size;
  slot_y_center[12] := slot_top[12] + piece_half_size;





//=========================

board_border_x_center[0] := slot_x_center[4];
board_border_x_center[1] := slot_x_center[5];
board_border_x_center[2] := slot_x_center[6];
board_border_x_center[3] := slot_x_center[7];
board_border_x_center[4] := slot_x_center[8];

board_border_x_center[5] := slot_x_center[5] - 2*x_distance_between_slots;
board_border_x_center[6] := slot_x_center[8] + x_distance_between_slots;

board_border_x_center[7] := slot_x_center[0] - x_distance_between_slots;
board_border_x_center[8] := slot_x_center[0] - x_distance_between_slots;

board_border_x_center[9] := slot_x_center[3] + x_distance_between_slots;
board_border_x_center[10] := slot_x_center[3] + x_distance_between_slots;



board_border_y_center[0] := slot_y_center[4] - 2*y_distance_between_slots;
board_border_y_center[1] := slot_y_center[5] - 2*y_distance_between_slots;
board_border_y_center[2] := slot_y_center[6] - 2*y_distance_between_slots;
board_border_y_center[3] := slot_y_center[7] - 2*y_distance_between_slots;
board_border_y_center[4] := slot_y_center[8] - 2*y_distance_between_slots;

board_border_y_center[5] := slot_y_center[5];
board_border_y_center[6] := slot_y_center[8];

board_border_y_center[7] := slot_y_center[0];
board_border_y_center[8] := slot_y_center[0] + 2*y_distance_between_slots;

board_border_y_center[9] := slot_y_center[3];
board_border_y_center[10] := slot_y_center[3] + 2*y_distance_between_slots;;



board_border_x_center[11] := slot_x_center[4];
board_border_x_center[12] := slot_x_center[5];
board_border_x_center[13] := slot_x_center[6];
board_border_x_center[14] := slot_x_center[7];
board_border_x_center[15] := slot_x_center[8];

board_border_y_center[11] := slot_y_center[4] + 2*y_distance_between_slots;
board_border_y_center[12] := slot_y_center[5] + 2*y_distance_between_slots;
board_border_y_center[13] := slot_y_center[6] + 2*y_distance_between_slots;
board_border_y_center[14] := slot_y_center[7] + 2*y_distance_between_slots;
board_border_y_center[15] := slot_y_center[8] + 2*y_distance_between_slots;

//=========================








    StartNewGame();



Board.Width := 1000;
Board.Height := 1000;


board_image := TBGRABitmap.Create(Board.Width, Board.Height);
//board_image.Canvas.Pen.Color := clRed;
//board_image.Canvas.Ellipse(current_piece_marking_ellipse_rect);


// https://forum.lazarus.freepascal.org/index.php?topic=45210.0
//board_image.Fill... // all drawing stuff into persistent Bitmap, anywhere in the code

//board_image.Canvas.Brush.Style := bsClear;
//board_image.Canvas.Brush.Color := clNone;

board_image.Canvas.Pen.Color := clGray;
//Bitmap.Canvas.Pen.Style := psClear;

board_image.Canvas.Pen.Width := 2;



png := TPortableNetworkGraphic.Create;
try
   png.LoadFromLazarusResource('PART01');
   piece_image_01 := TBGRABitmap.Create(png.Width, png.Height);
//   piece_image_01.ResampleFilter := rfBestQuality; // does not help
//   piece_image_01.CanvasDrawModeFP := dmDrawWithTransparency; // does not help
   piece_image_01.Canvas.Draw(0,0, png);
//   BGRAReplace (piece_image_01, piece_image_01.resample (PIECE_SIZE, PIECE_SIZE) ); //   rmFineResample is default
// https://wiki.freepascal.org/BGRABitmap
{$IF Defined(LINUX)}
//   BGRAReplace(piece_image_01,piece_image_01.FilterBlurRadial(1, rbFast));
//   BGRAReplace(piece_image_01,piece_image_01.FilterSmooth());
{$IFEND}

   png.LoadFromLazarusResource('PART02');
   piece_image_02 := TBGRABitmap.Create(png.Width, png.Height);
   piece_image_02.Canvas.Draw(0,0, png);
//   BGRAReplace (piece_image_02, piece_image_02.resample (PIECE_SIZE, PIECE_SIZE) ); //   rmFineResample is default
{$IF Defined(LINUX)}
//   BGRAReplace(piece_image_02,piece_image_02.FilterBlurRadial(1, rbFast));
{$IFEND}

   png.LoadFromLazarusResource('PART03');
   piece_image_03 := TBGRABitmap.Create(png.Width, png.Height);
   piece_image_03.Canvas.Draw(0,0, png);
//   BGRAReplace (piece_image_03, piece_image_03.resample (PIECE_SIZE, PIECE_SIZE) ); //   rmFineResample is default
{$IF Defined(LINUX)}
//   BGRAReplace(piece_image_03,piece_image_03.FilterBlurRadial(1, rbFast));
{$IFEND}

   png.LoadFromLazarusResource('PART04');
   piece_image_04 := TBGRABitmap.Create(png.Width, png.Height);
   piece_image_04.Canvas.Draw(0,0, png);
//   BGRAReplace (piece_image_04, piece_image_04.resample (PIECE_SIZE, PIECE_SIZE) ); //   rmFineResample is default
{$IF Defined(LINUX)}
//   BGRAReplace(piece_image_04,piece_image_04.FilterBlurRadial(1, rbFast));
{$IFEND}

   png.LoadFromLazarusResource('PART05');
   piece_image_05 := TBGRABitmap.Create(png.Width, png.Height);
   piece_image_05.Canvas.Draw(0,0, png);
//   BGRAReplace (piece_image_05, piece_image_05.resample (PIECE_SIZE, PIECE_SIZE) ); //   rmFineResample is default
{$IF Defined(LINUX)}
//   BGRAReplace(piece_image_05,piece_image_05.FilterBlurRadial(1, rbFast));
{$IFEND}

   png.LoadFromLazarusResource('PART06');
   piece_image_06 := TBGRABitmap.Create(png.Width, png.Height);
   piece_image_06.Canvas.Draw(0,0, png);
//   BGRAReplace (piece_image_06, piece_image_06.resample (PIECE_SIZE, PIECE_SIZE) ); //   rmFineResample is default
{$IF Defined(LINUX)}
//   BGRAReplace(piece_image_06,piece_image_06.FilterBlurRadial(1, rbFast));
{$IFEND}

   png.LoadFromLazarusResource('PART07');
   piece_image_07 := TBGRABitmap.Create(png.Width, png.Height);
   piece_image_07.Canvas.Draw(0,0, png);
//   BGRAReplace (piece_image_07, piece_image_07.resample (PIECE_SIZE, PIECE_SIZE) ); //   rmFineResample is default
{$IF Defined(LINUX)}
//   BGRAReplace(piece_image_07,piece_image_07.FilterBlurRadial(1, rbFast));
{$IFEND}

   png.LoadFromLazarusResource('PART08');
   piece_image_08 := TBGRABitmap.Create(png.Width, png.Height);
   piece_image_08.Canvas.Draw(0,0, png);
//   BGRAReplace (piece_image_08, piece_image_08.resample (PIECE_SIZE, PIECE_SIZE) ); //   rmFineResample is default
{$IF Defined(LINUX)}
//   BGRAReplace(piece_image_08,piece_image_08.FilterBlurRadial(1, rbFast));
{$IFEND}

   png.LoadFromLazarusResource('PART09');
   piece_image_09 := TBGRABitmap.Create(png.Width, png.Height);
   piece_image_09.Canvas.Draw(0,0, png);
//   BGRAReplace (piece_image_09, piece_image_09.resample (PIECE_SIZE, PIECE_SIZE) ); //   rmFineResample is default
{$IF Defined(LINUX)}
//   BGRAReplace(piece_image_09,piece_image_09.FilterBlurRadial(1, rbFast));
{$IFEND}

   png.LoadFromLazarusResource('PART10');
   piece_image_10 := TBGRABitmap.Create(png.Width, png.Height);
   piece_image_10.Canvas.Draw(0,0, png);
//   BGRAReplace (piece_image_10, piece_image_10.resample (PIECE_SIZE, PIECE_SIZE) ); //   rmFineResample is default
{$IF Defined(LINUX)}
//   BGRAReplace(piece_image_10,piece_image_10.FilterBlurRadial(1, rbFast));
{$IFEND}

   png.LoadFromLazarusResource('PART11');
   piece_image_11 := TBGRABitmap.Create(png.Width, png.Height);
   piece_image_11.Canvas.Draw(0,0, png);
//   BGRAReplace (piece_image_11, piece_image_11.resample (PIECE_SIZE, PIECE_SIZE) ); //   rmFineResample is default
{$IF Defined(LINUX)}
//   BGRAReplace(piece_image_11,piece_image_11.FilterBlurRadial(1, rbFast));
{$IFEND}

   png.LoadFromLazarusResource('PART12');
   piece_image_12 := TBGRABitmap.Create(png.Width, png.Height);
   piece_image_12.Canvas.Draw(0,0, png);
//   BGRAReplace (piece_image_12, piece_image_12.resample (PIECE_SIZE, PIECE_SIZE) ); //   rmFineResample is default
{$IF Defined(LINUX)}
//   BGRAReplace(piece_image_12,piece_image_12.FilterBlurRadial(1, rbFast));
{$IFEND}

   png.LoadFromLazarusResource('PART12');
   piece_image_13 := TBGRABitmap.Create(png.Width, png.Height);
   piece_image_13.Canvas.Draw(0,0, png);
//   BGRAReplace (piece_image_13, piece_image_13.resample (PIECE_SIZE, PIECE_SIZE) ); //   rmFineResample is default
{$IF Defined(LINUX)}
//   BGRAReplace(piece_image_13,piece_image_13.FilterBlurRadial(1, rbFast));
{$IFEND}

finally
   Png.Free;
end;


OutputImage.Picture.LoadFromLazarusResource('SLIDESHOW_IMAGE');


end;


procedure TPuzzleGameForm.ClearBoard();
var
 n: Integer;
begin




for n := 0 to 12 do
slot_content[n] := 0;

for n := 0 to 77 do // 6 *13 = 78
board_spike_table[n] := 0;


for n := 0 to 77 do // 6 *13 = 78
board_colliding_spikes_table[n] := 0;



piece_rotation_angle[0] := 0;
piece_rotation_angle[1] := 0;
piece_rotation_angle[2] := 0;
piece_rotation_angle[3] := 0;
piece_rotation_angle[4] := 0;
piece_rotation_angle[5] := 0;
piece_rotation_angle[6] := 0;
piece_rotation_angle[7] := 0;
piece_rotation_angle[8] := 0;
piece_rotation_angle[9] := 0;
piece_rotation_angle[10] := 0;
piece_rotation_angle[11] := 0;
piece_rotation_angle[12] := 0;


slot_content[0] := 0;
slot_content[1] := 0;
slot_content[2] := 0;
slot_content[3] := 0;
slot_content[4] := 0;
slot_content[5] := 0;
slot_content[6] := 0;
slot_content[7] := 0;
slot_content[8] := 0;
slot_content[9] := 0;
slot_content[10] := 0;
slot_content[11] := 0;
slot_content[12] := 0;

end;

procedure TPuzzleGameForm.StartNewGame();
var
 n: Integer;
begin

ClearBoard();

for n := 1 to 13 do
PlacePieceToStartPosition(n);




end;

procedure TPuzzleGameForm.PlacePieceToStartPosition(piece_number: Integer);
begin

    if (piece_number = 1) then
    begin
    Piece01.Left := 0;
    Piece01.Top := pieces_top;
    piece_is_flipped[0] := false;
    piece_slot_address[0] := 0;
//    piece_rotation_angle[0] := 0;
//    ConvertPieceSlotPositionIntoSlotContent(piece_slot_address[0], 1)
    end
    else if (piece_number = 2) then
    begin
    Piece02.Left := distance_between_pieces;
    Piece02.Top := pieces_top;
    piece_is_flipped[1] := false;
    piece_slot_address[1] := 0;
//    piece_rotation_angle[1] := 0;
//    ConvertPieceSlotPositionIntoSlotContent(piece_slot_address[1], 2)
    end
    else if (piece_number = 3) then
    begin
    Piece03.Left := distance_between_pieces*2;
    Piece03.Top := pieces_top;
    piece_is_flipped[2] := false;
    piece_slot_address[2] := 0;
//    piece_rotation_angle[2] := 0;
//    ConvertPieceSlotPositionIntoSlotContent(piece_slot_address[2], 3)
    end
    else if (piece_number = 4) then
    begin
    Piece04.Left := distance_between_pieces*3;
    Piece04.Top := pieces_top;
    piece_is_flipped[3] := false;
    piece_slot_address[3] := 0;
//    piece_rotation_angle[3] := 0;
//    ConvertPieceSlotPositionIntoSlotContent(piece_slot_address[3], 4)
    end
    else if (piece_number = 5) then
    begin
    Piece05.Left := distance_between_pieces*4;
    Piece05.Top := pieces_top;
    piece_is_flipped[4] := false;
    piece_slot_address[4] := 0;
//    piece_rotation_angle[4] := 0;
//    ConvertPieceSlotPositionIntoSlotContent(piece_slot_address[4], 5)
    end
    else if (piece_number = 6) then
    begin
    Piece06.Left := distance_between_pieces*5;
    Piece06.Top := pieces_top;
    piece_is_flipped[5] := false;
    piece_slot_address[5] := 0;
//    piece_rotation_angle[5] := 0;
//    ConvertPieceSlotPositionIntoSlotContent(piece_slot_address[5], 6)
    end
    else if (piece_number = 7) then
    begin
    Piece07.Left := distance_between_pieces*6;
    Piece07.Top := pieces_top;
    piece_is_flipped[6] := false;
    piece_slot_address[6] := 0;
//    piece_rotation_angle[6] := 0;
//    ConvertPieceSlotPositionIntoSlotContent(piece_slot_address[6], 7)
    end
    else if (piece_number = 8) then
    begin
    Piece08.Left := 0;
    Piece08.Top := pieces_top+distance_between_pieces;
    piece_is_flipped[7] := false;
    piece_slot_address[7] := 0;
//    piece_rotation_angle[7] := 0;
//    ConvertPieceSlotPositionIntoSlotContent(piece_slot_address[7], 8)
    end
    else if (piece_number = 9) then
    begin
    Piece09.Left := distance_between_pieces;
    Piece09.Top := pieces_top+distance_between_pieces;
    piece_is_flipped[8] := false;
    piece_slot_address[8] := 0;
//    piece_rotation_angle[8] := 0;
//    ConvertPieceSlotPositionIntoSlotContent(piece_slot_address[8], 9)
    end
    else if (piece_number = 10) then
    begin
    Piece10.Left := distance_between_pieces*2;
    Piece10.Top := pieces_top+distance_between_pieces;
    piece_is_flipped[9] := false;
    piece_slot_address[9] := 0;
//    piece_rotation_angle[9] := 0;
//    ConvertPieceSlotPositionIntoSlotContent(piece_slot_address[9], 10)
    end
    else if (piece_number = 11) then
    begin
    Piece11.Left := distance_between_pieces*3;
    Piece11.Top := pieces_top+distance_between_pieces;
    piece_is_flipped[10] := false;
    piece_slot_address[10] := 0;
//    piece_rotation_angle[10] := 0;
//    ConvertPieceSlotPositionIntoSlotContent(piece_slot_address[10], 11)
    end
    else if (piece_number = 12) then
    begin
    Piece12.Left := distance_between_pieces*4;
    Piece12.Top := pieces_top+distance_between_pieces;
    piece_is_flipped[11] := false;
    piece_slot_address[11] := 0;
//    piece_rotation_angle[11] := 0;
//    ConvertPieceSlotPositionIntoSlotContent(piece_slot_address[11], 12)
    end
    else if (piece_number = 13) then
    begin
    Piece13.Left := distance_between_pieces*5;
    Piece13.Top := pieces_top+distance_between_pieces;
    piece_is_flipped[12] := false;
    piece_slot_address[12] := 0;
//    piece_rotation_angle[12] := 0;
//    ConvertPieceSlotPositionIntoSlotContent(piece_slot_address[12], 13)
    end;


end;

procedure TPuzzleGameForm.RotateToNearest60angleAnimationTimerStartTimer(Sender: TObject);
begin

//    rotation_increment_default := 5;
rotation_increment_default := 1;
date_and_time_string := '';


    rotation_increment := final_rotation_angle - current_rotation_angle;


    if((final_rotation_angle = 0) and (rotation_increment < 30)) then
    rotation_increment := -rotation_increment_default
    else if((final_rotation_angle = 0) and (rotation_increment > -30)) then
    rotation_increment := rotation_increment_default

    else if((final_rotation_angle = 360) and (rotation_increment < 30)) then
    rotation_increment := rotation_increment_default
    else if((final_rotation_angle = 360) and (rotation_increment > -30)) then
    rotation_increment := -rotation_increment_default

    else if(rotation_increment > 0) then
    rotation_increment := rotation_increment_default
    else
    rotation_increment := -rotation_increment_default;





end;

procedure TPuzzleGameForm.RotateToNearest60angleAnimationTimerTimer(Sender: TObject);
var
   finish_rotation: Boolean;
begin

    finish_rotation := false;
    current_rotation_angle := current_rotation_angle + rotation_increment;

    if(current_rotation_angle >= 360) then
    begin
    current_rotation_angle := current_rotation_angle - 360;
    finish_rotation := true;
    end
    else if(current_rotation_angle < 0) then
    begin
    current_rotation_angle := current_rotation_angle + 360;
    finish_rotation := true;
    end;


    angle_difference := current_rotation_angle - final_rotation_angle;

    if ((finish_rotation = true) or (abs(angle_difference) < (rotation_increment_default+2))) then
    begin

    RotateToNearest60angleAnimationTimer.Enabled := false;
    piece_rotation_angle[current_piece-1] := final_rotation_angle;
    PlacePieceIntoBoardToFindCollisions(current_piece, current_slot);
    date_and_time_string := '';

    end; //if (current_rotation_angle = final_rotation_angle) then



    current_rotation_angle := final_rotation_angle;

    RedrawCurrentPiece();


//DebugLabel.Caption := 'rotation_increment = ' + IntToStr(rotation_increment) + ', current_rotation_angle = ' + IntToStr(current_rotation_angle) + ', final_rotation_angle = ' + IntToStr(final_rotation_angle);


end;




procedure TPuzzleGameForm.ShowSolutionsTimerTimer(Sender: TObject);
begin

LoadNextSolution(1);

end;

procedure TPuzzleGameForm.MoveToNearestSlotAnimationTimerStartTimer(Sender: TObject);
begin


date_and_time_string := '';


  if(current_piece = 1) then
  begin
   x_animation_increment := (slot_left[current_slot-1] - Piece01.Left) / number_of_animation_steps;
   y_animation_increment := (slot_top[current_slot-1] - Piece01.Top) / number_of_animation_steps;
   current_x_position := Piece01.Left;
   current_y_position := Piece01.Top;
  end
  else if(current_piece = 2) then
  begin
   x_animation_increment := (slot_left[current_slot-1] - Piece02.Left) / number_of_animation_steps;
   y_animation_increment := (slot_top[current_slot-1] - Piece02.Top) / number_of_animation_steps;
   current_x_position := Piece02.Left;
   current_y_position := Piece02.Top;
  end
  else if(current_piece = 3) then
  begin
   x_animation_increment := (slot_left[current_slot-1] - Piece03.Left) / number_of_animation_steps;
   y_animation_increment := (slot_top[current_slot-1] - Piece03.Top) / number_of_animation_steps;
   current_x_position := Piece03.Left;
   current_y_position := Piece03.Top;
  end
  else if(current_piece = 4) then
  begin
   x_animation_increment := (slot_left[current_slot-1] - Piece04.Left) / number_of_animation_steps;
   y_animation_increment := (slot_top[current_slot-1] - Piece04.Top) / number_of_animation_steps;
   current_x_position := Piece04.Left;
   current_y_position := Piece04.Top;
  end
  else if(current_piece = 5) then
  begin
   x_animation_increment := (slot_left[current_slot-1] - Piece05.Left) / number_of_animation_steps;
   y_animation_increment := (slot_top[current_slot-1] - Piece05.Top) / number_of_animation_steps;
   current_x_position := Piece05.Left;
   current_y_position := Piece05.Top;
  end
  else if(current_piece = 6) then
  begin
   x_animation_increment := (slot_left[current_slot-1] - Piece06.Left) / number_of_animation_steps;
   y_animation_increment := (slot_top[current_slot-1] - Piece06.Top) / number_of_animation_steps;
   current_x_position := Piece06.Left;
   current_y_position := Piece06.Top;
  end
  else if(current_piece = 7) then
  begin
   x_animation_increment := (slot_left[current_slot-1] - Piece07.Left) / number_of_animation_steps;
   y_animation_increment := (slot_top[current_slot-1] - Piece07.Top) / number_of_animation_steps;
   current_x_position := Piece07.Left;
   current_y_position := Piece07.Top;
  end
  else if(current_piece = 8) then
  begin
   x_animation_increment := (slot_left[current_slot-1] - Piece08.Left) / number_of_animation_steps;
   y_animation_increment := (slot_top[current_slot-1] - Piece08.Top) / number_of_animation_steps;
   current_x_position := Piece08.Left;
   current_y_position := Piece08.Top;
  end
  else if(current_piece = 9) then
  begin
   x_animation_increment := (slot_left[current_slot-1] - Piece09.Left) / number_of_animation_steps;
   y_animation_increment := (slot_top[current_slot-1] - Piece09.Top) / number_of_animation_steps;
   current_x_position := Piece09.Left;
   current_y_position := Piece09.Top;
  end
  else if(current_piece = 10) then
  begin
   x_animation_increment := (slot_left[current_slot-1] - Piece10.Left) / number_of_animation_steps;
   y_animation_increment := (slot_top[current_slot-1] - Piece10.Top) / number_of_animation_steps;
   current_x_position := Piece10.Left;
   current_y_position := Piece10.Top;
  end
  else if(current_piece = 11) then
  begin
   x_animation_increment := (slot_left[current_slot-1] - Piece11.Left) / number_of_animation_steps;
   y_animation_increment := (slot_top[current_slot-1] - Piece11.Top) / number_of_animation_steps;
   current_x_position := Piece11.Left;
   current_y_position := Piece11.Top;
  end
  else if(current_piece = 12) then
  begin
   x_animation_increment := (slot_left[current_slot-1] - Piece12.Left) / number_of_animation_steps;
   y_animation_increment := (slot_top[current_slot-1] - Piece12.Top) / number_of_animation_steps;
   current_x_position := Piece12.Left;
   current_y_position := Piece12.Top;
  end
  else if(current_piece = 13) then
  begin
   x_animation_increment := (slot_left[current_slot-1] - Piece13.Left) / number_of_animation_steps;
   y_animation_increment := (slot_top[current_slot-1] - Piece13.Top) / number_of_animation_steps;
   current_x_position := Piece13.Left;
   current_y_position := Piece13.Top;
  end;




end;

procedure TPuzzleGameForm.MoveToNearestSlotAnimationTimerTimer(Sender: TObject);
begin



  if(current_piece = 1) then
  begin
   current_x_position := current_x_position + x_animation_increment;
   current_y_position := current_y_position + y_animation_increment;
   Piece01.Left := Round(current_x_position);
   Piece01.Top := Round(current_y_position);

   if (abs(current_x_position - slot_left[current_slot-1]) < 3) and (abs(current_y_position - slot_top[current_slot-1]) < 3) then
   begin
      MoveToNearestSlotAnimationTimer.Enabled := false;
      date_and_time_string := '';
      Piece01.Left := slot_left[current_slot-1];
      Piece01.Top := slot_top[current_slot-1];
      PlacePieceIntoBoardToFindCollisions(1, current_slot);
   end;

  end // if(current_piece = 1)
  else if(current_piece = 2) then
  begin
   current_x_position := current_x_position + x_animation_increment;
   current_y_position := current_y_position + y_animation_increment;
   Piece02.Left := Round(current_x_position);
   Piece02.Top := Round(current_y_position);

   if (abs(current_x_position - slot_left[current_slot-1]) < 3) and (abs(current_y_position - slot_top[current_slot-1]) < 3) then
   begin
      MoveToNearestSlotAnimationTimer.Enabled := false;
      date_and_time_string := '';
      Piece02.Left := slot_left[current_slot-1];
      Piece02.Top := slot_top[current_slot-1];
      PlacePieceIntoBoardToFindCollisions(2, current_slot);
   end;

  end // if(current_piece = 2)
  else if(current_piece = 3) then
  begin
   current_x_position := current_x_position + x_animation_increment;
   current_y_position := current_y_position + y_animation_increment;
   Piece03.Left := Round(current_x_position);
   Piece03.Top := Round(current_y_position);

   if (abs(current_x_position - slot_left[current_slot-1]) < 3) and (abs(current_y_position - slot_top[current_slot-1]) < 3) then
   begin
      MoveToNearestSlotAnimationTimer.Enabled := false;
      date_and_time_string := '';
      Piece03.Left := slot_left[current_slot-1];
      Piece03.Top := slot_top[current_slot-1];
      PlacePieceIntoBoardToFindCollisions(3, current_slot);
   end;

  end // if(current_piece = 3)
  else if(current_piece = 4) then
  begin
   current_x_position := current_x_position + x_animation_increment;
   current_y_position := current_y_position + y_animation_increment;
   Piece04.Left := Round(current_x_position);
   Piece04.Top := Round(current_y_position);

   if (abs(current_x_position - slot_left[current_slot-1]) < 3) and (abs(current_y_position - slot_top[current_slot-1]) < 3) then
   begin
      MoveToNearestSlotAnimationTimer.Enabled := false;
      date_and_time_string := '';
      Piece04.Left := slot_left[current_slot-1];
      Piece04.Top := slot_top[current_slot-1];
      PlacePieceIntoBoardToFindCollisions(4, current_slot);
   end;

  end // if(current_piece = 4)
  else if(current_piece = 5) then
  begin
   current_x_position := current_x_position + x_animation_increment;
   current_y_position := current_y_position + y_animation_increment;
   Piece05.Left := Round(current_x_position);
   Piece05.Top := Round(current_y_position);

   if (abs(current_x_position - slot_left[current_slot-1]) < 3) and (abs(current_y_position - slot_top[current_slot-1]) < 3) then
   begin
      MoveToNearestSlotAnimationTimer.Enabled := false;
      date_and_time_string := '';
      Piece05.Left := slot_left[current_slot-1];
      Piece05.Top := slot_top[current_slot-1];
      PlacePieceIntoBoardToFindCollisions(5, current_slot);
   end;

  end // if(current_piece = 5)
  else if(current_piece = 6) then
  begin
   current_x_position := current_x_position + x_animation_increment;
   current_y_position := current_y_position + y_animation_increment;
   Piece06.Left := Round(current_x_position);
   Piece06.Top := Round(current_y_position);

   if (abs(current_x_position - slot_left[current_slot-1]) < 3) and (abs(current_y_position - slot_top[current_slot-1]) < 3) then
   begin
      MoveToNearestSlotAnimationTimer.Enabled := false;
      date_and_time_string := '';
      Piece06.Left := slot_left[current_slot-1];
      Piece06.Top := slot_top[current_slot-1];
      PlacePieceIntoBoardToFindCollisions(6, current_slot);
   end;

  end // if(current_piece = 6)
  else if(current_piece = 7) then
  begin
   current_x_position := current_x_position + x_animation_increment;
   current_y_position := current_y_position + y_animation_increment;
   Piece07.Left := Round(current_x_position);
   Piece07.Top := Round(current_y_position);

   if (abs(current_x_position - slot_left[current_slot-1]) < 3) and (abs(current_y_position - slot_top[current_slot-1]) < 3) then
   begin
      MoveToNearestSlotAnimationTimer.Enabled := false;
      date_and_time_string := '';
      Piece07.Left := slot_left[current_slot-1];
      Piece07.Top := slot_top[current_slot-1];
      PlacePieceIntoBoardToFindCollisions(7, current_slot);
   end;

  end // if(current_piece = 7)
  else if(current_piece = 8) then
  begin
   current_x_position := current_x_position + x_animation_increment;
   current_y_position := current_y_position + y_animation_increment;
   Piece08.Left := Round(current_x_position);
   Piece08.Top := Round(current_y_position);

   if (abs(current_x_position - slot_left[current_slot-1]) < 3) and (abs(current_y_position - slot_top[current_slot-1]) < 3) then
   begin
      MoveToNearestSlotAnimationTimer.Enabled := false;
      date_and_time_string := '';
      Piece08.Left := slot_left[current_slot-1];
      Piece08.Top := slot_top[current_slot-1];
      PlacePieceIntoBoardToFindCollisions(8, current_slot);
   end;

  end // if(current_piece = 8)
  else if(current_piece = 9) then
  begin
   current_x_position := current_x_position + x_animation_increment;
   current_y_position := current_y_position + y_animation_increment;
   Piece09.Left := Round(current_x_position);
   Piece09.Top := Round(current_y_position);

   if (abs(current_x_position - slot_left[current_slot-1]) < 3) and (abs(current_y_position - slot_top[current_slot-1]) < 3) then
   begin
      MoveToNearestSlotAnimationTimer.Enabled := false;
      date_and_time_string := '';
      Piece09.Left := slot_left[current_slot-1];
      Piece09.Top := slot_top[current_slot-1];
      PlacePieceIntoBoardToFindCollisions(9, current_slot);
   end;

  end // if(current_piece = 9)
  else if(current_piece = 10) then
  begin
   current_x_position := current_x_position + x_animation_increment;
   current_y_position := current_y_position + y_animation_increment;
   Piece10.Left := Round(current_x_position);
   Piece10.Top := Round(current_y_position);

   if (abs(current_x_position - slot_left[current_slot-1]) < 3) and (abs(current_y_position - slot_top[current_slot-1]) < 3) then
   begin
      MoveToNearestSlotAnimationTimer.Enabled := false;
      date_and_time_string := '';
      Piece10.Left := slot_left[current_slot-1];
      Piece10.Top := slot_top[current_slot-1];
      PlacePieceIntoBoardToFindCollisions(10, current_slot);
   end;

  end // if(current_piece = 10)
  else if(current_piece = 11) then
  begin
   current_x_position := current_x_position + x_animation_increment;
   current_y_position := current_y_position + y_animation_increment;
   Piece11.Left := Round(current_x_position);
   Piece11.Top := Round(current_y_position);

   if (abs(current_x_position - slot_left[current_slot-1]) < 3) and (abs(current_y_position - slot_top[current_slot-1]) < 3) then
   begin
      MoveToNearestSlotAnimationTimer.Enabled := false;
      date_and_time_string := '';
      Piece11.Left := slot_left[current_slot-1];
      Piece11.Top := slot_top[current_slot-1];
      PlacePieceIntoBoardToFindCollisions(11, current_slot);
   end;

  end // if(current_piece = 11)
  else if(current_piece = 12) then
  begin
   current_x_position := current_x_position + x_animation_increment;
   current_y_position := current_y_position + y_animation_increment;
   Piece12.Left := Round(current_x_position);
   Piece12.Top := Round(current_y_position);

   if (abs(current_x_position - slot_left[current_slot-1]) < 3) and (abs(current_y_position - slot_top[current_slot-1]) < 3) then
   begin
      MoveToNearestSlotAnimationTimer.Enabled := false;
      date_and_time_string := '';
      Piece12.Left := slot_left[current_slot-1];
      Piece12.Top := slot_top[current_slot-1];
      PlacePieceIntoBoardToFindCollisions(12, current_slot);
   end;

  end // if(current_piece = 12)
  else if(current_piece = 13) then
  begin
   current_x_position := current_x_position + x_animation_increment;
   current_y_position := current_y_position + y_animation_increment;
   Piece13.Left := Round(current_x_position);
   Piece13.Top := Round(current_y_position);

   if (abs(current_x_position - slot_left[current_slot-1]) < 3) and (abs(current_y_position - slot_top[current_slot-1]) < 3) then
   begin
      MoveToNearestSlotAnimationTimer.Enabled := false;
      date_and_time_string := '';
      Piece13.Left := slot_left[current_slot-1];
      Piece13.Top := slot_top[current_slot-1];
      PlacePieceIntoBoardToFindCollisions(13, current_slot);
   end;

  end; // if(current_piece = 13)





end;




procedure TPuzzleGameForm.Piece11Click(Sender: TObject);
begin

  clicked_X := Mouse.CursorPos.X - Piece11.Left;
  clicked_Y := Mouse.CursorPos.Y - Piece11.Top;
  Piece11.Cursor := 2;

end;




procedure TPuzzleGameForm.Piece01MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin

if((slideshow_mode = true) or (PlayerSelectComboBox.ItemIndex < 2)) then
Exit;

  MoveToNearestSlotAnimationTimer.Enabled := false;
  RotateToNearest60angleAnimationTimer.Enabled := false;
  ErrorCircleImage.Visible := false;

  current_piece := 1;
  current_slot := piece_slot_address[current_piece-1];
  clicked_X := Mouse.CursorPos.X - Piece01.Left;
  clicked_Y := Mouse.CursorPos.Y - Piece01.Top;
  Piece01.Cursor := 2;
  Piece01.BringToFront();

  PieceRotationTrackBar.OnChange := nil;
  PieceRotationTrackBar.Position := piece_rotation_angle[0];
  PieceRotationTrackBar.OnChange := @PieceRotationTrackBarChange;

  current_rotation_angle := piece_rotation_angle[0];

  distance_x := Mouse.CursorPos.X - PuzzleGameForm.Left - Piece01.Left - piece_half_size - mouseleft - 7; // cursor image size is 32x32, compensate for hotspot
  distance_y := Mouse.CursorPos.Y - PuzzleGameForm.Top - Piece01.Top - piece_half_size - mousetop - 7; // cursor image size is 32x32, compensate for hotspot
  if (piece_is_flipped[0] = true) then
  distance_x := - distance_x;


  distance_r := Round(Sqrt(distance_x*distance_x + distance_y*distance_y));

  if ( distance_r > piece_quarter_size) then
  begin
  rotation_mode := true;
  if (distance_x = 0) and (distance_y > 0) then
  mouse_rotation_angle_original := 90
  else if (distance_x = 0) and (distance_y < 0) then
  mouse_rotation_angle_original := -90
  else
  mouse_rotation_angle_original := radtodeg(ArcTan2(distance_y,distance_x));

  mouse_rotation_angle_original := mouse_rotation_angle_original - piece_rotation_angle[0];
  if(mouse_rotation_angle_original > 180) then
  mouse_rotation_angle_original := mouse_rotation_angle_original - 360;
  end// if(rotation_mode = true)
  else
  rotation_mode := false;

//    DebugLabel.Visible := true;
//    DebugLabel.Caption := IntToStr(distance_r) + ', ' + IntToStr(distance_x) + ', ' + IntToStr(distance_y) + ', ' + IntToStr(mouseleft) + ', ' + IntToStr(mousetop);
//    DebugLabel.Caption := FloatToStr(mouse_rotation_angle_original);

  RedrawAllPieces();

end;


procedure TPuzzleGameForm.Piece01MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin

  if((slideshow_mode = true) or (PlayerSelectComboBox.ItemIndex < 2)) then
  Exit;

    if ((MoveToNearestSlotAnimationTimer.Enabled = true) or (RotateToNearest60angleAnimationTimer.Enabled = true)) then
    Exit();


  // https://www.freepascal.org/docs-html/rtl/classes/tshiftstate.html
  // ssLeft -- Left mouse button pressed.
    if ((Shift = [ssLeft]) and not mouse_button_pressed) then
    begin
      mouse_button_pressed := true;

    end;

    if not (Shift = [ssLeft]) then
    begin
          mouse_button_pressed := false;
    end;


    if( mouse_button_pressed ) then
    begin
     if(rotation_mode = false) then
     begin
      Piece01.Top :=  Mouse.CursorPos.Y - clicked_Y;
      Piece01.Left := Mouse.CursorPos.X - clicked_X;
     end // if(rotation_mode = false)
     else if(rotation_mode = true) then
     begin

     distance_x := Mouse.CursorPos.X - PuzzleGameForm.Left - Piece01.Left - piece_half_size - mouseleft - 7; // cursor image size is 32x32, compensate for hotspot
     distance_y := Mouse.CursorPos.Y - PuzzleGameForm.Top - Piece01.Top - piece_half_size - mousetop - 7; // cursor image size is 32x32, compensate for hotspot
     if (piece_is_flipped[0] = true) then
     distance_x := - distance_x;

     distance_r := Round(Sqrt(distance_x*distance_x + distance_y*distance_y));

     if (distance_x = 0) and (distance_y > 0) then
     mouse_rotation_angle := 90
     else if (distance_x = 0) and (distance_y < 0) then
     mouse_rotation_angle := -90
     else
     mouse_rotation_angle := radtodeg(ArcTan2(distance_y,distance_x));

//       DebugLabel.Visible := true;
//       DebugLabel.Caption := IntToStr(distance_r) + ', ' + IntToStr(distance_x) + ', ' + IntToStr(distance_y) + ', ' + IntToStr(mouseleft) + ', ' + IntToStr(mousetop);
   //    DebugLabel.Caption := FloatToStr(mouse_rotation_angle);

    mouse_rotation_angle_difference := mouse_rotation_angle - mouse_rotation_angle_original;
     if(mouse_rotation_angle_difference > 180) then
     mouse_rotation_angle_difference := mouse_rotation_angle_difference - 360;


    current_rotation_angle := Round(mouse_rotation_angle_difference);
    RedrawCurrentPiece;
    Exit;
    end;// if(rotation_mode = true)

    end; // if( mouse_button_pressed )



end;

procedure TPuzzleGameForm.Piece01MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin

    if((slideshow_mode = true) or (PlayerSelectComboBox.ItemIndex < 2)) then
    Exit;

    Piece01.Cursor := 1;

    if ((MoveToNearestSlotAnimationTimer.Enabled = true) or (RotateToNearest60angleAnimationTimer.Enabled = true)) then
    Exit();

    if(rotation_mode = false) then
    begin
      current_slot := 0;
      ClearSlot(piece_slot_address[0]);
      piece_slot_address[0] := 0;

      if ((abs(slot_left[0] - Piece01.Left) < piece_half_size) and (abs(slot_top[0] - Piece01.Top ) < piece_half_size)) then
      begin
      current_slot := 1;

      if ((slot_content[0] <> 0) and (slot_content[0] <> 1)) then
      PlacePieceToStartPosition(slot_content[0]);
      RedrawCurrentPiece;
      slot_content[0] := 1;

      piece_slot_address[0] := 1;
      MoveToNearestSlotAnimationTimer.Enabled := true;
      end
      else if ((abs(slot_left[1] - Piece01.Left) < piece_half_size) and (abs(slot_top[1] - Piece01.Top ) < piece_half_size)) then
      begin
      current_slot := 2;

      if ((slot_content[1] <> 0) and (slot_content[1] <> 1)) then
      PlacePieceToStartPosition(slot_content[1]);
      RedrawCurrentPiece;
      slot_content[1] := 1;

      piece_slot_address[0] := 2;
      MoveToNearestSlotAnimationTimer.Enabled := true;
      end
      else if ((abs(slot_left[2] - Piece01.Left) < piece_half_size) and (abs(slot_top[2] - Piece01.Top ) < piece_half_size)) then
      begin
      current_slot := 3;

      if ((slot_content[2] <> 0)  and (slot_content[2] <> 1))then
      PlacePieceToStartPosition(slot_content[2]);
      RedrawCurrentPiece;
      slot_content[2] := 1;

      piece_slot_address[0] := 3;
      MoveToNearestSlotAnimationTimer.Enabled := true;
      end
      else if ((abs(slot_left[3] - Piece01.Left) < piece_half_size) and (abs(slot_top[3] - Piece01.Top ) < piece_half_size)) then
      begin
      current_slot := 4;

      if ((slot_content[3] <> 0) and (slot_content[3] <> 1)) then
      PlacePieceToStartPosition(slot_content[3]);
      RedrawCurrentPiece();
      slot_content[3] := 1;

      piece_slot_address[0] := 4;
      MoveToNearestSlotAnimationTimer.Enabled := true;
      end
      else if ((abs(slot_left[4] - Piece01.Left) < piece_half_size) and (abs(slot_top[4] - Piece01.Top ) < piece_half_size)) then
      begin
      current_slot := 5;

      if ((slot_content[4] <> 0)  and (slot_content[4] <> 1))then
      PlacePieceToStartPosition(slot_content[4]);
      RedrawCurrentPiece();
      slot_content[4] := 1;

      piece_slot_address[0] := 5;
      MoveToNearestSlotAnimationTimer.Enabled := true;
      end
      else if ((abs(slot_left[5] - Piece01.Left) < piece_half_size) and (abs(slot_top[5] - Piece01.Top ) < piece_half_size)) then
      begin
      current_slot := 6;

      if ((slot_content[5] <> 0) and (slot_content[5] <> 1)) then
      PlacePieceToStartPosition(slot_content[5]);
      RedrawCurrentPiece();
      slot_content[5] := 1;

      piece_slot_address[0] := 6;
      MoveToNearestSlotAnimationTimer.Enabled := true;
      end
      else if ((abs(slot_left[6] - Piece01.Left) < piece_half_size) and (abs(slot_top[6] - Piece01.Top ) < piece_half_size)) then
      begin
      current_slot := 7;

      if ((slot_content[6] <> 0) and (slot_content[6] <> 1)) then
      PlacePieceToStartPosition(slot_content[6]);
      RedrawCurrentPiece();
      slot_content[6] := 1;

      piece_slot_address[0] := 7;
      MoveToNearestSlotAnimationTimer.Enabled := true;
      end
      else if ((abs(slot_left[7] - Piece01.Left) < piece_half_size) and (abs(slot_top[7] - Piece01.Top ) < piece_half_size)) then
      begin
      current_slot := 8;

      if ((slot_content[7] <> 0) and (slot_content[7] <> 1)) then
      PlacePieceToStartPosition(slot_content[7]);
      RedrawCurrentPiece();
      slot_content[7] := 1;

      piece_slot_address[0] := 8;
      MoveToNearestSlotAnimationTimer.Enabled := true;
      end
      else if ((abs(slot_left[8] - Piece01.Left) < piece_half_size) and (abs(slot_top[8] - Piece01.Top ) < piece_half_size)) then
      begin
      current_slot := 9;

      if ((slot_content[8] <> 0) and (slot_content[8] <> 1)) then
      PlacePieceToStartPosition(slot_content[8]);
      RedrawCurrentPiece();
      slot_content[8] := 1;

      piece_slot_address[0] := 9;
      MoveToNearestSlotAnimationTimer.Enabled := true;
      end
      else if ((abs(slot_left[9] - Piece01.Left) < piece_half_size) and (abs(slot_top[9] - Piece01.Top ) < piece_half_size)) then
      begin
      current_slot := 10;

      if ((slot_content[9] <> 0) and (slot_content[9] <> 1)) then
      PlacePieceToStartPosition(slot_content[9]);
      RedrawCurrentPiece();
      slot_content[9] := 1;

      piece_slot_address[0] := 10;
      MoveToNearestSlotAnimationTimer.Enabled := true;
      end
      else if ((abs(slot_left[10] - Piece01.Left) < piece_half_size) and (abs(slot_top[10] - Piece01.Top ) < piece_half_size)) then
      begin
      current_slot := 11;

      if ((slot_content[10] <> 0) and (slot_content[10] <> 1)) then
      PlacePieceToStartPosition(slot_content[10]);
      RedrawCurrentPiece();
      slot_content[10] := 1;

      piece_slot_address[0] := 11;
      MoveToNearestSlotAnimationTimer.Enabled := true;
      end
      else if ((abs(slot_left[11] - Piece01.Left) < piece_half_size) and (abs(slot_top[11] - Piece01.Top ) < piece_half_size)) then
      begin
      current_slot := 12;

      if ((slot_content[11] <> 0) and (slot_content[11] <> 1)) then
      PlacePieceToStartPosition(slot_content[11]);
      RedrawCurrentPiece();
      slot_content[11] := 1;

      piece_slot_address[0] := 12;
      MoveToNearestSlotAnimationTimer.Enabled := true;
      end
      else if ((abs(slot_left[12] - Piece01.Left) < piece_half_size) and (abs(slot_top[12] - Piece01.Top ) < piece_half_size)) then
      begin
      current_slot := 13;

      if ((slot_content[12] <> 0) and (slot_content[12] <> 1)) then
      PlacePieceToStartPosition(slot_content[12]);
      RedrawCurrentPiece();
      slot_content[12] := 1;

      piece_slot_address[0] := 13;
      MoveToNearestSlotAnimationTimer.Enabled := true;
      end;
    end // if(rotation_mode = false)
    else if(rotation_mode = true) then
    begin

    current_rotation_angle := Round(mouse_rotation_angle_difference);
    angle_6th_part := mouse_rotation_angle_difference / 60.0;
    final_rotation_angle := Round(angle_6th_part) * 60;
    piece_rotation_angle[0] := final_rotation_angle;
    RotateToNearest60angleAnimationTimer.Enabled := true;

    end; // else if(rotation_mode = true)

    RedrawCurrentPiece();

end;

procedure TPuzzleGameForm.Piece02MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin

if((slideshow_mode = true) or (PlayerSelectComboBox.ItemIndex < 2)) then
Exit;

  MoveToNearestSlotAnimationTimer.Enabled := false;
  RotateToNearest60angleAnimationTimer.Enabled := false;
  ErrorCircleImage.Visible := false;

  current_piece := 2;
  current_slot := piece_slot_address[current_piece-1];
  clicked_X := Mouse.CursorPos.X - Piece02.Left;
  clicked_Y := Mouse.CursorPos.Y - Piece02.Top;
  Piece02.Cursor := 2;
  Piece02.BringToFront();

  PieceRotationTrackBar.OnChange := nil;
  PieceRotationTrackBar.Position := piece_rotation_angle[1];
  PieceRotationTrackBar.OnChange := @PieceRotationTrackBarChange;

  current_rotation_angle := piece_rotation_angle[1];

  distance_x := Mouse.CursorPos.X - PuzzleGameForm.Left - Piece02.Left - piece_half_size - mouseleft - 7; // cursor image size is 32x32, compensate for hotspot
  distance_y := Mouse.CursorPos.Y - PuzzleGameForm.Top - Piece02.Top - piece_half_size - mousetop - 7; // cursor image size is 32x32, compensate for hotspot
  if (piece_is_flipped[1] = true) then
  distance_x := - distance_x;


  distance_r := Round(Sqrt(distance_x*distance_x + distance_y*distance_y));

  if ( distance_r > piece_quarter_size) then
  begin
  rotation_mode := true;
  if (distance_x = 0) and (distance_y > 0) then
  mouse_rotation_angle_original := 90
  else if (distance_x = 0) and (distance_y < 0) then
  mouse_rotation_angle_original := -90
  else
  mouse_rotation_angle_original := radtodeg(ArcTan2(distance_y,distance_x));

  mouse_rotation_angle_original := mouse_rotation_angle_original - piece_rotation_angle[1];
  if(mouse_rotation_angle_original > 180) then
  mouse_rotation_angle_original := mouse_rotation_angle_original - 360;
  end// if(rotation_mode = true)
  else
  rotation_mode := false;

//    DebugLabel.Visible := true;
//    DebugLabel.Caption := IntToStr(distance_r) + ', ' + IntToStr(distance_x) + ', ' + IntToStr(distance_y) + ', ' + IntToStr(mouseleft) + ', ' + IntToStr(mousetop);
//    DebugLabel.Caption := FloatToStr(mouse_rotation_angle_original);

  RedrawAllPieces();

end;

procedure TPuzzleGameForm.Piece02MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin

  if((slideshow_mode = true) or (PlayerSelectComboBox.ItemIndex < 2)) then
  Exit;

  if ((MoveToNearestSlotAnimationTimer.Enabled = true) or (RotateToNearest60angleAnimationTimer.Enabled = true)) then
  Exit();


// https://www.freepascal.org/docs-html/rtl/classes/tshiftstate.html
// ssLeft -- Left mouse button pressed.
  if ((Shift = [ssLeft]) and not mouse_button_pressed) then
  begin
    mouse_button_pressed := true;

  end;

  if not (Shift = [ssLeft]) then
  begin
        mouse_button_pressed := false;
  end;


  if( mouse_button_pressed ) then
  begin
   if(rotation_mode = false) then
   begin
    Piece02.Top :=  Mouse.CursorPos.Y - clicked_Y;
    Piece02.Left := Mouse.CursorPos.X - clicked_X;
   end // if(rotation_mode = false)
   else if(rotation_mode = true) then
   begin

   distance_x := Mouse.CursorPos.X - PuzzleGameForm.Left - Piece02.Left - piece_half_size - mouseleft - 7; // cursor image size is 32x32, compensate for hotspot
   distance_y := Mouse.CursorPos.Y - PuzzleGameForm.Top - Piece02.Top - piece_half_size - mousetop - 7; // cursor image size is 32x32, compensate for hotspot
   if (piece_is_flipped[1] = true) then
   distance_x := - distance_x;


   distance_r := Round(Sqrt(distance_x*distance_x + distance_y*distance_y));

   if (distance_x = 0) and (distance_y > 0) then
   mouse_rotation_angle := 90
   else if (distance_x = 0) and (distance_y < 0) then
   mouse_rotation_angle := -90
   else
   mouse_rotation_angle := radtodeg(ArcTan2(distance_y,distance_x));

 //    DebugLabel.Visible := true;
 //    DebugLabel.Caption := IntToStr(distance_r) + ', ' + IntToStr(distance_x) + ', ' + IntToStr(distance_y) + ', ' + IntToStr(mouseleft) + ', ' + IntToStr(mousetop);
 //    DebugLabel.Caption := FloatToStr(mouse_rotation_angle);

  mouse_rotation_angle_difference := mouse_rotation_angle - mouse_rotation_angle_original;
   if(mouse_rotation_angle_difference > 180) then
   mouse_rotation_angle_difference := mouse_rotation_angle_difference - 360;


  current_rotation_angle := Round(mouse_rotation_angle_difference);
  RedrawCurrentPiece();
  Exit;
  end;// if(rotation_mode = true)

  end; // if( mouse_button_pressed )


end;

procedure TPuzzleGameForm.Piece02MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin

  if((slideshow_mode = true) or (PlayerSelectComboBox.ItemIndex < 2)) then
  Exit;

Piece02.Cursor := 1;

if ((MoveToNearestSlotAnimationTimer.Enabled = true) or (RotateToNearest60angleAnimationTimer.Enabled = true)) then
Exit();

if(rotation_mode = false) then
begin
  current_slot := 0;
  ClearSlot(piece_slot_address[1]);
  piece_slot_address[1] := 0;


  if ((abs(slot_left[0] - Piece02.Left) < piece_half_size) and (abs(slot_top[0] - Piece02.Top ) < piece_half_size)) then
  begin
      current_slot := 1;

  if ((slot_content[0] <> 0) and (slot_content[0] <> 2)) then
  PlacePieceToStartPosition(slot_content[0]);
  RedrawCurrentPiece();
  slot_content[0] := 2;

  piece_slot_address[1] := 1;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[1] - Piece02.Left) < piece_half_size) and (abs(slot_top[1] - Piece02.Top ) < piece_half_size)) then
  begin
      current_slot := 2;

  if ((slot_content[1] <> 0) and (slot_content[1] <> 2)) then
  PlacePieceToStartPosition(slot_content[1]);
  RedrawCurrentPiece();
  slot_content[1] := 2;

  piece_slot_address[1] := 2;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[2] - Piece02.Left) < piece_half_size) and (abs(slot_top[2] - Piece02.Top ) < piece_half_size)) then
  begin
      current_slot := 3;

  if ((slot_content[2] <> 0) and (slot_content[2] <> 2)) then
  PlacePieceToStartPosition(slot_content[2]);
  RedrawCurrentPiece();
  slot_content[2] := 2;

  piece_slot_address[1] := 3;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[3] - Piece02.Left) < piece_half_size) and (abs(slot_top[3] - Piece02.Top ) < piece_half_size)) then
  begin
      current_slot := 4;

  if ((slot_content[3] <> 0) and (slot_content[3] <> 2)) then
  PlacePieceToStartPosition(slot_content[3]);
  RedrawCurrentPiece();
  slot_content[3] := 2;

  piece_slot_address[1] := 4;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[4] - Piece02.Left) < piece_half_size) and (abs(slot_top[4] - Piece02.Top ) < piece_half_size)) then
  begin
      current_slot := 5;

  if ((slot_content[4] <> 0) and (slot_content[4] <> 2)) then
  PlacePieceToStartPosition(slot_content[4]);
  RedrawCurrentPiece();
  slot_content[4] := 2;

  piece_slot_address[1] := 5;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[5] - Piece02.Left) < piece_half_size) and (abs(slot_top[5] - Piece02.Top ) < piece_half_size)) then
  begin
      current_slot := 6;

  if ((slot_content[5] <> 0) and (slot_content[5] <> 2)) then
  PlacePieceToStartPosition(slot_content[5]);
  RedrawCurrentPiece();
  slot_content[5] := 2;

  piece_slot_address[1] := 6;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[6] - Piece02.Left) < piece_half_size) and (abs(slot_top[6] - Piece02.Top ) < piece_half_size)) then
  begin
      current_slot := 7;

  if ((slot_content[6] <> 0) and (slot_content[6] <> 2)) then
  PlacePieceToStartPosition(slot_content[6]);
  RedrawCurrentPiece();
  slot_content[6] := 2;

  piece_slot_address[1] := 7;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[7] - Piece02.Left) < piece_half_size) and (abs(slot_top[7] - Piece02.Top ) < piece_half_size)) then
  begin
      current_slot := 8;

  if ((slot_content[7] <> 0) and (slot_content[7] <> 2)) then
  PlacePieceToStartPosition(slot_content[7]);
  RedrawCurrentPiece();
  slot_content[7] := 2;

  piece_slot_address[1] := 8;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[8] - Piece02.Left) < piece_half_size) and (abs(slot_top[8] - Piece02.Top ) < piece_half_size)) then
  begin
      current_slot := 9;

  if ((slot_content[8] <> 0) and (slot_content[8] <> 2)) then
  PlacePieceToStartPosition(slot_content[8]);
  RedrawCurrentPiece();
  slot_content[8] := 2;

  piece_slot_address[1] := 9;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[9] - Piece02.Left) < piece_half_size) and (abs(slot_top[9] - Piece02.Top ) < piece_half_size)) then
  begin
      current_slot := 10;

  if ((slot_content[9] <> 0) and (slot_content[9] <> 2)) then
  PlacePieceToStartPosition(slot_content[9]);
  RedrawCurrentPiece();
  slot_content[9] := 2;

  piece_slot_address[1] := 10;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[10] - Piece02.Left) < piece_half_size) and (abs(slot_top[10] - Piece02.Top ) < piece_half_size)) then
  begin
      current_slot := 11;

  if ((slot_content[10] <> 0) and (slot_content[10] <> 2)) then
  PlacePieceToStartPosition(slot_content[10]);
  RedrawCurrentPiece();
  slot_content[10] := 2;

  piece_slot_address[1] := 11;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[11] - Piece02.Left) < piece_half_size) and (abs(slot_top[11] - Piece02.Top ) < piece_half_size)) then
  begin
      current_slot := 12;

  if ((slot_content[11] <> 0) and (slot_content[11] <> 2)) then
  PlacePieceToStartPosition(slot_content[11]);
  RedrawCurrentPiece();
  slot_content[11] := 2;

  piece_slot_address[1] := 12;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[12] - Piece02.Left) < piece_half_size) and (abs(slot_top[12] - Piece02.Top ) < piece_half_size)) then
  begin
      current_slot := 13;

  if ((slot_content[12] <> 0) and (slot_content[12] <> 2)) then
  PlacePieceToStartPosition(slot_content[12]);
  RedrawCurrentPiece();
  slot_content[12] := 2;

  piece_slot_address[1] := 13;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end;
end // if(rotation_mode = false)
else if(rotation_mode = true) then
begin

current_rotation_angle := Round(mouse_rotation_angle_difference);
angle_6th_part := mouse_rotation_angle_difference / 60.0;
final_rotation_angle := Round(angle_6th_part) * 60;
piece_rotation_angle[1] := final_rotation_angle;
RotateToNearest60angleAnimationTimer.Enabled := true;

end; // else if(rotation_mode = true)

RedrawCurrentPiece();


end;

procedure TPuzzleGameForm.Piece03MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin

if((slideshow_mode = true) or (PlayerSelectComboBox.ItemIndex < 2)) then
Exit;

  MoveToNearestSlotAnimationTimer.Enabled := false;
  RotateToNearest60angleAnimationTimer.Enabled := false;
  ErrorCircleImage.Visible := false;

  current_piece := 3;
  current_slot := piece_slot_address[current_piece-1];
  clicked_X := Mouse.CursorPos.X - Piece03.Left;
  clicked_Y := Mouse.CursorPos.Y - Piece03.Top;
  Piece03.Cursor := 2;
  Piece03.BringToFront();

  PieceRotationTrackBar.OnChange := nil;
  PieceRotationTrackBar.Position := piece_rotation_angle[2];
  PieceRotationTrackBar.OnChange := @PieceRotationTrackBarChange;

  current_rotation_angle := piece_rotation_angle[2];

  distance_x := Mouse.CursorPos.X - PuzzleGameForm.Left - Piece03.Left - piece_half_size - mouseleft - 7; // cursor image size is 32x32, compensate for hotspot
  distance_y := Mouse.CursorPos.Y - PuzzleGameForm.Top - Piece03.Top - piece_half_size - mousetop - 7; // cursor image size is 32x32, compensate for hotspot
  if (piece_is_flipped[2] = true) then
  distance_x := - distance_x;


  distance_r := Round(Sqrt(distance_x*distance_x + distance_y*distance_y));

  if ( distance_r > piece_quarter_size) then
  begin
  rotation_mode := true;
  if (distance_x = 0) and (distance_y > 0) then
  mouse_rotation_angle_original := 90
  else if (distance_x = 0) and (distance_y < 0) then
  mouse_rotation_angle_original := -90
  else
  mouse_rotation_angle_original := radtodeg(ArcTan2(distance_y,distance_x));

  mouse_rotation_angle_original := mouse_rotation_angle_original - piece_rotation_angle[2];
  if(mouse_rotation_angle_original > 180) then
  mouse_rotation_angle_original := mouse_rotation_angle_original - 360;
  end// if(rotation_mode = true)
  else
  rotation_mode := false;

//    DebugLabel.Visible := true;
//    DebugLabel.Caption := IntToStr(distance_r) + ', ' + IntToStr(distance_x) + ', ' + IntToStr(distance_y) + ', ' + IntToStr(mouseleft) + ', ' + IntToStr(mousetop);
//    DebugLabel.Caption := FloatToStr(mouse_rotation_angle_original);

  RedrawAllPieces();

end;

procedure TPuzzleGameForm.Piece03MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin

  if((slideshow_mode = true) or (PlayerSelectComboBox.ItemIndex < 2)) then
  Exit;

  if ((MoveToNearestSlotAnimationTimer.Enabled = true) or (RotateToNearest60angleAnimationTimer.Enabled = true)) then
  Exit();


// https://www.freepascal.org/docs-html/rtl/classes/tshiftstate.html
// ssLeft -- Left mouse button pressed.
  if ((Shift = [ssLeft]) and not mouse_button_pressed) then
  begin
    mouse_button_pressed := true;

  end;

  if not (Shift = [ssLeft]) then
  begin
        mouse_button_pressed := false;
  end;


  if( mouse_button_pressed ) then
  begin
   if(rotation_mode = false) then
   begin
    Piece03.Top :=  Mouse.CursorPos.Y - clicked_Y;
    Piece03.Left := Mouse.CursorPos.X - clicked_X;
   end // if(rotation_mode = false)
   else if(rotation_mode = true) then
   begin

   distance_x := Mouse.CursorPos.X - PuzzleGameForm.Left - Piece03.Left - piece_half_size - mouseleft - 7; // cursor image size is 32x32, compensate for hotspot
   distance_y := Mouse.CursorPos.Y - PuzzleGameForm.Top - Piece03.Top - piece_half_size - mousetop - 7; // cursor image size is 32x32, compensate for hotspot
   if (piece_is_flipped[2] = true) then
   distance_x := - distance_x;


   distance_r := Round(Sqrt(distance_x*distance_x + distance_y*distance_y));

   if (distance_x = 0) and (distance_y > 0) then
   mouse_rotation_angle := 90
   else if (distance_x = 0) and (distance_y < 0) then
   mouse_rotation_angle := -90
   else
   mouse_rotation_angle := radtodeg(ArcTan2(distance_y,distance_x));

 //    DebugLabel.Visible := true;
 //    DebugLabel.Caption := IntToStr(distance_r) + ', ' + IntToStr(distance_x) + ', ' + IntToStr(distance_y) + ', ' + IntToStr(mouseleft) + ', ' + IntToStr(mousetop);
 //    DebugLabel.Caption := FloatToStr(mouse_rotation_angle);

  mouse_rotation_angle_difference := mouse_rotation_angle - mouse_rotation_angle_original;
   if(mouse_rotation_angle_difference > 180) then
   mouse_rotation_angle_difference := mouse_rotation_angle_difference - 360;


  current_rotation_angle := Round(mouse_rotation_angle_difference);
  RedrawCurrentPiece();
  Exit;
  end;// if(rotation_mode = true)

  end; // if( mouse_button_pressed )





end;

procedure TPuzzleGameForm.Piece03MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin

  if((slideshow_mode = true) or (PlayerSelectComboBox.ItemIndex < 2)) then
  Exit;

Piece03.Cursor := 1;

if ((MoveToNearestSlotAnimationTimer.Enabled = true) or (RotateToNearest60angleAnimationTimer.Enabled = true)) then
Exit();

if(rotation_mode = false) then
begin
  current_slot := 0;
  ClearSlot(piece_slot_address[2]);
  piece_slot_address[2] := 0;


  if ((abs(slot_left[0] - Piece03.Left) < piece_half_size) and (abs(slot_top[0] - Piece03.Top ) < piece_half_size)) then
  begin
      current_slot := 1;

  if ((slot_content[0] <> 0) and (slot_content[0] <> 3)) then
  PlacePieceToStartPosition(slot_content[0]);
  RedrawCurrentPiece();
  slot_content[0] := 3;

  piece_slot_address[2] := 1;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[1] - Piece03.Left) < piece_half_size) and (abs(slot_top[1] - Piece03.Top ) < piece_half_size)) then
  begin
      current_slot := 2;

  if ((slot_content[1] <> 0) and (slot_content[1] <> 3)) then
  PlacePieceToStartPosition(slot_content[1]);
  RedrawCurrentPiece();
  slot_content[1] := 3;

  piece_slot_address[2] := 2;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[2] - Piece03.Left) < piece_half_size) and (abs(slot_top[2] - Piece03.Top ) < piece_half_size)) then
  begin
      current_slot := 3;

  if ((slot_content[2] <> 0) and (slot_content[2] <> 3)) then
  PlacePieceToStartPosition(slot_content[2]);
  RedrawCurrentPiece();
  slot_content[2] := 3;

  piece_slot_address[2] := 3;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[3] - Piece03.Left) < piece_half_size) and (abs(slot_top[3] - Piece03.Top ) < piece_half_size)) then
  begin
      current_slot := 4;

  if ((slot_content[3] <> 0) and (slot_content[3] <> 3)) then
  PlacePieceToStartPosition(slot_content[3]);
  RedrawCurrentPiece();
  slot_content[3] := 3;

  piece_slot_address[2] := 4;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[4] - Piece03.Left) < piece_half_size) and (abs(slot_top[4] - Piece03.Top ) < piece_half_size)) then
  begin
      current_slot := 5;

  if ((slot_content[4] <> 0) and (slot_content[4] <> 3)) then
  PlacePieceToStartPosition(slot_content[4]);
  RedrawCurrentPiece();
  slot_content[4] := 3;

  piece_slot_address[2] := 5;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[5] - Piece03.Left) < piece_half_size) and (abs(slot_top[5] - Piece03.Top ) < piece_half_size)) then
  begin
      current_slot := 6;

  if ((slot_content[5] <> 0) and (slot_content[5] <> 3)) then
  PlacePieceToStartPosition(slot_content[5]);
  RedrawCurrentPiece();
  slot_content[5] := 3;

  piece_slot_address[2] := 6;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[6] - Piece03.Left) < piece_half_size) and (abs(slot_top[6] - Piece03.Top ) < piece_half_size)) then
  begin
      current_slot := 7;

  if ((slot_content[6] <> 0) and (slot_content[6] <> 3)) then
  PlacePieceToStartPosition(slot_content[6]);
  RedrawCurrentPiece();
  slot_content[6] := 3;

  piece_slot_address[2] := 7;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[7] - Piece03.Left) < piece_half_size) and (abs(slot_top[7] - Piece03.Top ) < piece_half_size)) then
  begin
      current_slot := 8;

  if ((slot_content[7] <> 0) and (slot_content[7] <> 3)) then
  PlacePieceToStartPosition(slot_content[7]);
  RedrawCurrentPiece();
  slot_content[7] := 3;

  piece_slot_address[2] := 8;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[8] - Piece03.Left) < piece_half_size) and (abs(slot_top[8] - Piece03.Top ) < piece_half_size)) then
  begin
      current_slot := 9;

  if ((slot_content[8] <> 0) and (slot_content[8] <> 3)) then
  PlacePieceToStartPosition(slot_content[8]);
  RedrawCurrentPiece();
  slot_content[8] := 3;

  piece_slot_address[2] := 9;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[9] - Piece03.Left) < piece_half_size) and (abs(slot_top[9] - Piece03.Top ) < piece_half_size)) then
  begin
      current_slot := 10;

  if ((slot_content[9] <> 0) and (slot_content[9] <> 3)) then
  PlacePieceToStartPosition(slot_content[9]);
  RedrawCurrentPiece();
  slot_content[9] := 3;

  piece_slot_address[2] := 10;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[10] - Piece03.Left) < piece_half_size) and (abs(slot_top[10] - Piece03.Top ) < piece_half_size)) then
  begin
      current_slot := 11;

  if ((slot_content[10] <> 0) and (slot_content[10] <> 3)) then
  PlacePieceToStartPosition(slot_content[10]);
  RedrawCurrentPiece();
  slot_content[10] := 3;

  piece_slot_address[2] := 11;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[11] - Piece03.Left) < piece_half_size) and (abs(slot_top[11] - Piece03.Top ) < piece_half_size)) then
  begin
      current_slot := 12;

  if ((slot_content[11] <> 0) and (slot_content[11] <> 3)) then
  PlacePieceToStartPosition(slot_content[11]);
  RedrawCurrentPiece();
  slot_content[11] := 3;

  piece_slot_address[2] := 12;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[12] - Piece03.Left) < piece_half_size) and (abs(slot_top[12] - Piece03.Top ) < piece_half_size)) then
  begin
      current_slot := 13;

  if ((slot_content[12] <> 0) and (slot_content[12] <> 3)) then
  PlacePieceToStartPosition(slot_content[12]);
  RedrawCurrentPiece();
  slot_content[12] := 3;

  piece_slot_address[2] := 13;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end;
end // if(rotation_mode = false)
else if(rotation_mode = true) then
begin

current_rotation_angle := Round(mouse_rotation_angle_difference);
angle_6th_part := mouse_rotation_angle_difference / 60.0;
final_rotation_angle := Round(angle_6th_part) * 60;
piece_rotation_angle[2] := final_rotation_angle;
RotateToNearest60angleAnimationTimer.Enabled := true;

end; // else if(rotation_mode = true)

RedrawCurrentPiece();


end;

procedure TPuzzleGameForm.Piece04MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin

if((slideshow_mode = true) or (PlayerSelectComboBox.ItemIndex < 2)) then
Exit;

  MoveToNearestSlotAnimationTimer.Enabled := false;
  RotateToNearest60angleAnimationTimer.Enabled := false;
  ErrorCircleImage.Visible := false;

  current_piece := 4;
  current_slot := piece_slot_address[current_piece-1];
  clicked_X := Mouse.CursorPos.X - Piece04.Left;
  clicked_Y := Mouse.CursorPos.Y - Piece04.Top;
  Piece04.Cursor := 2;
  Piece04.BringToFront();

  PieceRotationTrackBar.OnChange := nil;
  PieceRotationTrackBar.Position := piece_rotation_angle[3];
  PieceRotationTrackBar.OnChange := @PieceRotationTrackBarChange;

  current_rotation_angle := piece_rotation_angle[3];

  distance_x := Mouse.CursorPos.X - PuzzleGameForm.Left - Piece04.Left - piece_half_size - mouseleft - 7; // cursor image size is 32x32, compensate for hotspot
  distance_y := Mouse.CursorPos.Y - PuzzleGameForm.Top - Piece04.Top - piece_half_size - mousetop - 7; // cursor image size is 32x32, compensate for hotspot
  if (piece_is_flipped[3] = true) then
  distance_x := - distance_x;


  distance_r := Round(Sqrt(distance_x*distance_x + distance_y*distance_y));

  if ( distance_r > piece_quarter_size) then
  begin
  rotation_mode := true;
  if (distance_x = 0) and (distance_y > 0) then
  mouse_rotation_angle_original := 90
  else if (distance_x = 0) and (distance_y < 0) then
  mouse_rotation_angle_original := -90
  else
  mouse_rotation_angle_original := radtodeg(ArcTan2(distance_y,distance_x));

  mouse_rotation_angle_original := mouse_rotation_angle_original - piece_rotation_angle[3];
  if(mouse_rotation_angle_original > 180) then
  mouse_rotation_angle_original := mouse_rotation_angle_original - 360;
  end// if(rotation_mode = true)
  else
  rotation_mode := false;

//    DebugLabel.Visible := true;
//    DebugLabel.Caption := IntToStr(distance_r) + ', ' + IntToStr(distance_x) + ', ' + IntToStr(distance_y) + ', ' + IntToStr(mouseleft) + ', ' + IntToStr(mousetop);
//    DebugLabel.Caption := FloatToStr(mouse_rotation_angle_original);

  RedrawAllPieces();

end;

procedure TPuzzleGameForm.Piece04MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin

  if((slideshow_mode = true) or (PlayerSelectComboBox.ItemIndex < 2)) then
  Exit;

  if ((MoveToNearestSlotAnimationTimer.Enabled = true) or (RotateToNearest60angleAnimationTimer.Enabled = true)) then
  Exit();


// https://www.freepascal.org/docs-html/rtl/classes/tshiftstate.html
// ssLeft -- Left mouse button pressed.
  if ((Shift = [ssLeft]) and not mouse_button_pressed) then
  begin
    mouse_button_pressed := true;

  end;

  if not (Shift = [ssLeft]) then
  begin
        mouse_button_pressed := false;
  end;


  if( mouse_button_pressed ) then
  begin
   if(rotation_mode = false) then
   begin
    Piece04.Top :=  Mouse.CursorPos.Y - clicked_Y;
    Piece04.Left := Mouse.CursorPos.X - clicked_X;
   end // if(rotation_mode = false)
   else if(rotation_mode = true) then
   begin

   distance_x := Mouse.CursorPos.X - PuzzleGameForm.Left - Piece04.Left - piece_half_size - mouseleft - 7; // cursor image size is 32x32, compensate for hotspot
   distance_y := Mouse.CursorPos.Y - PuzzleGameForm.Top - Piece04.Top - piece_half_size - mousetop - 7; // cursor image size is 32x32, compensate for hotspot
   if (piece_is_flipped[3] = true) then
   distance_x := - distance_x;


   distance_r := Round(Sqrt(distance_x*distance_x + distance_y*distance_y));

   if (distance_x = 0) and (distance_y > 0) then
   mouse_rotation_angle := 90
   else if (distance_x = 0) and (distance_y < 0) then
   mouse_rotation_angle := -90
   else
   mouse_rotation_angle := radtodeg(ArcTan2(distance_y,distance_x));

 //    DebugLabel.Visible := true;
 //    DebugLabel.Caption := IntToStr(distance_r) + ', ' + IntToStr(distance_x) + ', ' + IntToStr(distance_y) + ', ' + IntToStr(mouseleft) + ', ' + IntToStr(mousetop);
 //    DebugLabel.Caption := FloatToStr(mouse_rotation_angle);

  mouse_rotation_angle_difference := mouse_rotation_angle - mouse_rotation_angle_original;
   if(mouse_rotation_angle_difference > 180) then
   mouse_rotation_angle_difference := mouse_rotation_angle_difference - 360;


  current_rotation_angle := Round(mouse_rotation_angle_difference);
  RedrawCurrentPiece();
  Exit;
  end;// if(rotation_mode = true)

  end; // if( mouse_button_pressed )





end;

procedure TPuzzleGameForm.Piece04MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin

  if((slideshow_mode = true) or (PlayerSelectComboBox.ItemIndex < 2)) then
  Exit;

Piece04.Cursor := 1;

if ((MoveToNearestSlotAnimationTimer.Enabled = true) or (RotateToNearest60angleAnimationTimer.Enabled = true)) then
Exit();

if(rotation_mode = false) then
begin
  current_slot := 0;
  ClearSlot(piece_slot_address[3]);
  piece_slot_address[3] := 0;


  if ((abs(slot_left[0] - Piece04.Left) < piece_half_size) and (abs(slot_top[0] - Piece04.Top ) < piece_half_size)) then
  begin
      current_slot := 1;

  if ((slot_content[0] <> 0) and (slot_content[0] <> 4)) then
  PlacePieceToStartPosition(slot_content[0]);
  RedrawCurrentPiece();
  slot_content[0] := 4;

  piece_slot_address[3] := 1;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[1] - Piece04.Left) < piece_half_size) and (abs(slot_top[1] - Piece04.Top ) < piece_half_size)) then
  begin
      current_slot := 2;

  if ((slot_content[1] <> 0) and (slot_content[1] <> 4)) then
  PlacePieceToStartPosition(slot_content[1]);
  RedrawCurrentPiece();
  slot_content[1] := 4;

  piece_slot_address[3] := 2;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[2] - Piece04.Left) < piece_half_size) and (abs(slot_top[2] - Piece04.Top ) < piece_half_size)) then
  begin
      current_slot := 3;

  if ((slot_content[2] <> 0) and (slot_content[2] <> 4)) then
  PlacePieceToStartPosition(slot_content[2]);
  RedrawCurrentPiece();
  slot_content[2] := 4;

  piece_slot_address[3] := 3;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[3] - Piece04.Left) < piece_half_size) and (abs(slot_top[3] - Piece04.Top ) < piece_half_size)) then
  begin
      current_slot := 4;

  if ((slot_content[3] <> 0) and (slot_content[3] <> 4)) then
  PlacePieceToStartPosition(slot_content[3]);
  RedrawCurrentPiece();
  slot_content[3] := 4;

  piece_slot_address[3] := 4;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[4] - Piece04.Left) < piece_half_size) and (abs(slot_top[4] - Piece04.Top ) < piece_half_size)) then
  begin
      current_slot := 5;

  if ((slot_content[4] <> 0) and (slot_content[4] <> 4)) then
  PlacePieceToStartPosition(slot_content[4]);
  RedrawCurrentPiece();
  slot_content[4] := 4;

  piece_slot_address[3] := 5;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[5] - Piece04.Left) < piece_half_size) and (abs(slot_top[5] - Piece04.Top ) < piece_half_size)) then
  begin
      current_slot := 6;

  if ((slot_content[5] <> 0) and (slot_content[5] <> 4)) then
  PlacePieceToStartPosition(slot_content[5]);
  RedrawCurrentPiece();
  slot_content[5] := 4;

  piece_slot_address[3] := 6;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[6] - Piece04.Left) < piece_half_size) and (abs(slot_top[6] - Piece04.Top ) < piece_half_size)) then
  begin
      current_slot := 7;

  if ((slot_content[6] <> 0) and (slot_content[6] <> 4)) then
  PlacePieceToStartPosition(slot_content[6]);
  RedrawCurrentPiece();
  slot_content[6] := 4;

  piece_slot_address[3] := 7;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[7] - Piece04.Left) < piece_half_size) and (abs(slot_top[7] - Piece04.Top ) < piece_half_size)) then
  begin
      current_slot := 8;

  if ((slot_content[7] <> 0) and (slot_content[7] <> 4)) then
  PlacePieceToStartPosition(slot_content[7]);
  RedrawCurrentPiece();
  slot_content[7] := 4;

  piece_slot_address[3] := 8;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[8] - Piece04.Left) < piece_half_size) and (abs(slot_top[8] - Piece04.Top ) < piece_half_size)) then
  begin
      current_slot := 9;

  if ((slot_content[8] <> 0) and (slot_content[8] <> 4)) then
  PlacePieceToStartPosition(slot_content[8]);
  RedrawCurrentPiece();
  slot_content[8] := 4;

  piece_slot_address[3] := 9;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[9] - Piece04.Left) < piece_half_size) and (abs(slot_top[9] - Piece04.Top ) < piece_half_size)) then
  begin
      current_slot := 10;

  if ((slot_content[9] <> 0) and (slot_content[9] <> 4)) then
  PlacePieceToStartPosition(slot_content[9]);
  RedrawCurrentPiece();
  slot_content[9] := 4;

  piece_slot_address[3] := 10;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[10] - Piece04.Left) < piece_half_size) and (abs(slot_top[10] - Piece04.Top ) < piece_half_size)) then
  begin
      current_slot := 11;

  if ((slot_content[10] <> 0) and (slot_content[10] <> 4)) then
  PlacePieceToStartPosition(slot_content[10]);
  RedrawCurrentPiece();
  slot_content[10] := 4;

  piece_slot_address[3] := 11;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[11] - Piece04.Left) < piece_half_size) and (abs(slot_top[11] - Piece04.Top ) < piece_half_size)) then
  begin
      current_slot := 12;

  if ((slot_content[11] <> 0) and (slot_content[11] <> 4)) then
  PlacePieceToStartPosition(slot_content[11]);
  RedrawCurrentPiece();
  slot_content[11] := 4;

  piece_slot_address[3] := 12;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[12] - Piece04.Left) < piece_half_size) and (abs(slot_top[12] - Piece04.Top ) < piece_half_size)) then
  begin
      current_slot := 13;

  if ((slot_content[12] <> 0) and (slot_content[12] <> 4)) then
  PlacePieceToStartPosition(slot_content[12]);
  RedrawCurrentPiece();
  slot_content[12] := 4;

  piece_slot_address[3] := 13;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end;
end // if(rotation_mode = false)
else if(rotation_mode = true) then
begin

current_rotation_angle := Round(mouse_rotation_angle_difference);
angle_6th_part := mouse_rotation_angle_difference / 60.0;
final_rotation_angle := Round(angle_6th_part) * 60;
piece_rotation_angle[3] := final_rotation_angle;
RotateToNearest60angleAnimationTimer.Enabled := true;

end; // else if(rotation_mode = true)

RedrawCurrentPiece();


end;

procedure TPuzzleGameForm.Piece05MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin

if((slideshow_mode = true) or (PlayerSelectComboBox.ItemIndex < 2)) then
Exit;

  MoveToNearestSlotAnimationTimer.Enabled := false;
  RotateToNearest60angleAnimationTimer.Enabled := false;
  ErrorCircleImage.Visible := false;

  current_piece := 5;
  current_slot := piece_slot_address[current_piece-1];
  clicked_X := Mouse.CursorPos.X - Piece05.Left;
  clicked_Y := Mouse.CursorPos.Y - Piece05.Top;
  Piece05.Cursor := 2;
  Piece05.BringToFront();

  PieceRotationTrackBar.OnChange := nil;
  PieceRotationTrackBar.Position := piece_rotation_angle[4];
  PieceRotationTrackBar.OnChange := @PieceRotationTrackBarChange;

  current_rotation_angle := piece_rotation_angle[4];

  distance_x := Mouse.CursorPos.X - PuzzleGameForm.Left - Piece05.Left - piece_half_size - mouseleft - 7; // cursor image size is 32x32, compensate for hotspot
  distance_y := Mouse.CursorPos.Y - PuzzleGameForm.Top - Piece05.Top - piece_half_size - mousetop - 7; // cursor image size is 32x32, compensate for hotspot
  if (piece_is_flipped[4] = true) then
  distance_x := - distance_x;


  distance_r := Round(Sqrt(distance_x*distance_x + distance_y*distance_y));

  if ( distance_r > piece_quarter_size) then
  begin
  rotation_mode := true;
  if (distance_x = 0) and (distance_y > 0) then
  mouse_rotation_angle_original := 90
  else if (distance_x = 0) and (distance_y < 0) then
  mouse_rotation_angle_original := -90
  else
  mouse_rotation_angle_original := radtodeg(ArcTan2(distance_y,distance_x));

  mouse_rotation_angle_original := mouse_rotation_angle_original - piece_rotation_angle[4];
  if(mouse_rotation_angle_original > 180) then
  mouse_rotation_angle_original := mouse_rotation_angle_original - 360;
  end// if(rotation_mode = true)
  else
  rotation_mode := false;

//    DebugLabel.Visible := true;
//    DebugLabel.Caption := IntToStr(distance_r) + ', ' + IntToStr(distance_x) + ', ' + IntToStr(distance_y) + ', ' + IntToStr(mouseleft) + ', ' + IntToStr(mousetop);
//    DebugLabel.Caption := FloatToStr(mouse_rotation_angle_original);

  RedrawAllPieces();

end;

procedure TPuzzleGameForm.Piece05MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin

  if((slideshow_mode = true) or (PlayerSelectComboBox.ItemIndex < 2)) then
  Exit;

  if ((MoveToNearestSlotAnimationTimer.Enabled = true) or (RotateToNearest60angleAnimationTimer.Enabled = true)) then
  Exit();


// https://www.freepascal.org/docs-html/rtl/classes/tshiftstate.html
// ssLeft -- Left mouse button pressed.
  if ((Shift = [ssLeft]) and not mouse_button_pressed) then
  begin
    mouse_button_pressed := true;

  end;

  if not (Shift = [ssLeft]) then
  begin
        mouse_button_pressed := false;
  end;


  if( mouse_button_pressed ) then
  begin
   if(rotation_mode = false) then
   begin
    Piece05.Top :=  Mouse.CursorPos.Y - clicked_Y;
    Piece05.Left := Mouse.CursorPos.X - clicked_X;
   end // if(rotation_mode = false)
   else if(rotation_mode = true) then
   begin

   distance_x := Mouse.CursorPos.X - PuzzleGameForm.Left - Piece05.Left - piece_half_size - mouseleft - 7; // cursor image size is 32x32, compensate for hotspot
   distance_y := Mouse.CursorPos.Y - PuzzleGameForm.Top - Piece05.Top - piece_half_size - mousetop - 7; // cursor image size is 32x32, compensate for hotspot
   if (piece_is_flipped[4] = true) then
   distance_x := - distance_x;


   distance_r := Round(Sqrt(distance_x*distance_x + distance_y*distance_y));

   if (distance_x = 0) and (distance_y > 0) then
   mouse_rotation_angle := 90
   else if (distance_x = 0) and (distance_y < 0) then
   mouse_rotation_angle := -90
   else
   mouse_rotation_angle := radtodeg(ArcTan2(distance_y,distance_x));

 //    DebugLabel.Visible := true;
 //    DebugLabel.Caption := IntToStr(distance_r) + ', ' + IntToStr(distance_x) + ', ' + IntToStr(distance_y) + ', ' + IntToStr(mouseleft) + ', ' + IntToStr(mousetop);
 //    DebugLabel.Caption := FloatToStr(mouse_rotation_angle);

  mouse_rotation_angle_difference := mouse_rotation_angle - mouse_rotation_angle_original;
   if(mouse_rotation_angle_difference > 180) then
   mouse_rotation_angle_difference := mouse_rotation_angle_difference - 360;


  current_rotation_angle := Round(mouse_rotation_angle_difference);
  RedrawCurrentPiece();
  Exit;
  end;// if(rotation_mode = true)

  end; // if( mouse_button_pressed )




end;

procedure TPuzzleGameForm.Piece05MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin

  if((slideshow_mode = true) or (PlayerSelectComboBox.ItemIndex < 2)) then
  Exit;

Piece05.Cursor := 1;

if ((MoveToNearestSlotAnimationTimer.Enabled = true) or (RotateToNearest60angleAnimationTimer.Enabled = true)) then
Exit();

if(rotation_mode = false) then
begin
  current_slot := 0;
  ClearSlot(piece_slot_address[4]);
  piece_slot_address[4] := 0;


  if ((abs(slot_left[0] - Piece05.Left) < piece_half_size) and (abs(slot_top[0] - Piece05.Top ) < piece_half_size)) then
  begin
      current_slot := 1;

  if ((slot_content[0] <> 0) and (slot_content[0] <> 5)) then
  PlacePieceToStartPosition(slot_content[0]);
  RedrawCurrentPiece();
  slot_content[0] := 5;

  piece_slot_address[4] := 1;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[1] - Piece05.Left) < piece_half_size) and (abs(slot_top[1] - Piece05.Top ) < piece_half_size)) then
  begin
      current_slot := 2;

  if ((slot_content[1] <> 0) and (slot_content[1] <> 5)) then
  PlacePieceToStartPosition(slot_content[1]);
  RedrawCurrentPiece();
  slot_content[1] := 5;

  piece_slot_address[4] := 2;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[2] - Piece05.Left) < piece_half_size) and (abs(slot_top[2] - Piece05.Top ) < piece_half_size)) then
  begin
      current_slot := 3;

  if ((slot_content[2] <> 0) and (slot_content[2] <> 5)) then
  PlacePieceToStartPosition(slot_content[2]);
  RedrawCurrentPiece();
  slot_content[2] := 5;

  piece_slot_address[4] := 3;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[3] - Piece05.Left) < piece_half_size) and (abs(slot_top[3] - Piece05.Top ) < piece_half_size)) then
  begin
      current_slot := 4;

  if ((slot_content[3] <> 0) and (slot_content[3] <> 5)) then
  PlacePieceToStartPosition(slot_content[3]);
  RedrawCurrentPiece();
  slot_content[3] := 5;

  piece_slot_address[4] := 4;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[4] - Piece05.Left) < piece_half_size) and (abs(slot_top[4] - Piece05.Top ) < piece_half_size)) then
  begin
      current_slot := 5;

  if ((slot_content[4] <> 0) and (slot_content[4] <> 5)) then
  PlacePieceToStartPosition(slot_content[4]);
  RedrawCurrentPiece();
  slot_content[4] := 5;

  piece_slot_address[4] := 5;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[5] - Piece05.Left) < piece_half_size) and (abs(slot_top[5] - Piece05.Top ) < piece_half_size)) then
  begin
      current_slot := 6;

  if ((slot_content[5] <> 0) and (slot_content[5] <> 5)) then
  PlacePieceToStartPosition(slot_content[5]);
  RedrawCurrentPiece();
  slot_content[5] := 5;

  piece_slot_address[4] := 6;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[6] - Piece05.Left) < piece_half_size) and (abs(slot_top[6] - Piece05.Top ) < piece_half_size)) then
  begin
      current_slot := 7;

  if ((slot_content[6] <> 0) and (slot_content[6] <> 5)) then
  PlacePieceToStartPosition(slot_content[6]);
  RedrawCurrentPiece();
  slot_content[6] := 5;

  piece_slot_address[4] := 7;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[7] - Piece05.Left) < piece_half_size) and (abs(slot_top[7] - Piece05.Top ) < piece_half_size)) then
  begin
      current_slot := 8;

  if ((slot_content[7] <> 0) and (slot_content[7] <> 5)) then
  PlacePieceToStartPosition(slot_content[7]);
  RedrawCurrentPiece();
  slot_content[7] := 5;

  piece_slot_address[4] := 8;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[8] - Piece05.Left) < piece_half_size) and (abs(slot_top[8] - Piece05.Top ) < piece_half_size)) then
  begin
      current_slot := 9;

  if ((slot_content[8] <> 0) and (slot_content[8] <> 5)) then
  PlacePieceToStartPosition(slot_content[8]);
  RedrawCurrentPiece();
  slot_content[8] := 5;

  piece_slot_address[4] := 9;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[9] - Piece05.Left) < piece_half_size) and (abs(slot_top[9] - Piece05.Top ) < piece_half_size)) then
  begin
      current_slot := 10;

  if ((slot_content[9] <> 0) and (slot_content[9] <> 5)) then
  PlacePieceToStartPosition(slot_content[9]);
  RedrawCurrentPiece();
  slot_content[9] := 5;

  piece_slot_address[4] := 10;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[10] - Piece05.Left) < piece_half_size) and (abs(slot_top[10] - Piece05.Top ) < piece_half_size)) then
  begin
      current_slot := 11;

  if ((slot_content[10] <> 0) and (slot_content[10] <> 5)) then
  PlacePieceToStartPosition(slot_content[10]);
  RedrawCurrentPiece();
  slot_content[10] := 5;

  piece_slot_address[4] := 11;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[11] - Piece05.Left) < piece_half_size) and (abs(slot_top[11] - Piece05.Top ) < piece_half_size)) then
  begin
      current_slot := 12;

  if ((slot_content[11] <> 0) and (slot_content[11] <> 5)) then
  PlacePieceToStartPosition(slot_content[11]);
  RedrawCurrentPiece();
  slot_content[11] := 5;

  piece_slot_address[4] := 12;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[12] - Piece05.Left) < piece_half_size) and (abs(slot_top[12] - Piece05.Top ) < piece_half_size)) then
  begin
      current_slot := 13;

  if ((slot_content[12] <> 0) and (slot_content[12] <> 5)) then
  PlacePieceToStartPosition(slot_content[12]);
  RedrawCurrentPiece();
  slot_content[12] := 5;

  piece_slot_address[4] := 13;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end;
end // if(rotation_mode = false)
else if(rotation_mode = true) then
begin

current_rotation_angle := Round(mouse_rotation_angle_difference);
angle_6th_part := mouse_rotation_angle_difference / 60.0;
final_rotation_angle := Round(angle_6th_part) * 60;
piece_rotation_angle[4] := final_rotation_angle;
RotateToNearest60angleAnimationTimer.Enabled := true;

end; // else if(rotation_mode = true)

RedrawCurrentPiece();


end;

procedure TPuzzleGameForm.Piece06MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin

if((slideshow_mode = true) or (PlayerSelectComboBox.ItemIndex < 2)) then
Exit;

  MoveToNearestSlotAnimationTimer.Enabled := false;
  RotateToNearest60angleAnimationTimer.Enabled := false;
  ErrorCircleImage.Visible := false;

  current_piece := 6;
  current_slot := piece_slot_address[current_piece-1];
  clicked_X := Mouse.CursorPos.X - Piece06.Left;
  clicked_Y := Mouse.CursorPos.Y - Piece06.Top;
  Piece06.Cursor := 2;
  Piece06.BringToFront();

  PieceRotationTrackBar.OnChange := nil;
  PieceRotationTrackBar.Position := piece_rotation_angle[5];
  PieceRotationTrackBar.OnChange := @PieceRotationTrackBarChange;

  current_rotation_angle := piece_rotation_angle[5];

  distance_x := Mouse.CursorPos.X - PuzzleGameForm.Left - Piece06.Left - piece_half_size - mouseleft - 7; // cursor image size is 32x32, compensate for hotspot
  distance_y := Mouse.CursorPos.Y - PuzzleGameForm.Top - Piece06.Top - piece_half_size - mousetop - 7; // cursor image size is 32x32, compensate for hotspot
  if (piece_is_flipped[5] = true) then
  distance_x := - distance_x;


  distance_r := Round(Sqrt(distance_x*distance_x + distance_y*distance_y));

  if ( distance_r > piece_quarter_size) then
  begin
  rotation_mode := true;
  if (distance_x = 0) and (distance_y > 0) then
  mouse_rotation_angle_original := 90
  else if (distance_x = 0) and (distance_y < 0) then
  mouse_rotation_angle_original := -90
  else
  mouse_rotation_angle_original := radtodeg(ArcTan2(distance_y,distance_x));

  mouse_rotation_angle_original := mouse_rotation_angle_original - piece_rotation_angle[5];
  if(mouse_rotation_angle_original > 180) then
  mouse_rotation_angle_original := mouse_rotation_angle_original - 360;
  end// if(rotation_mode = true)
  else
  rotation_mode := false;

//    DebugLabel.Visible := true;
//    DebugLabel.Caption := IntToStr(distance_r) + ', ' + IntToStr(distance_x) + ', ' + IntToStr(distance_y) + ', ' + IntToStr(mouseleft) + ', ' + IntToStr(mousetop);
//    DebugLabel.Caption := FloatToStr(mouse_rotation_angle_original);

  RedrawAllPieces();

end;

procedure TPuzzleGameForm.Piece06MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin

  if((slideshow_mode = true) or (PlayerSelectComboBox.ItemIndex < 2)) then
  Exit;

  if ((MoveToNearestSlotAnimationTimer.Enabled = true) or (RotateToNearest60angleAnimationTimer.Enabled = true)) then
  Exit();


// https://www.freepascal.org/docs-html/rtl/classes/tshiftstate.html
// ssLeft -- Left mouse button pressed.
  if ((Shift = [ssLeft]) and not mouse_button_pressed) then
  begin
    mouse_button_pressed := true;

  end;

  if not (Shift = [ssLeft]) then
  begin
        mouse_button_pressed := false;
  end;


  if( mouse_button_pressed ) then
  begin
   if(rotation_mode = false) then
   begin
    Piece06.Top :=  Mouse.CursorPos.Y - clicked_Y;
    Piece06.Left := Mouse.CursorPos.X - clicked_X;
   end // if(rotation_mode = false)
   else if(rotation_mode = true) then
   begin

   distance_x := Mouse.CursorPos.X - PuzzleGameForm.Left - Piece06.Left - piece_half_size - mouseleft - 7; // cursor image size is 32x32, compensate for hotspot
   distance_y := Mouse.CursorPos.Y - PuzzleGameForm.Top - Piece06.Top - piece_half_size - mousetop - 7; // cursor image size is 32x32, compensate for hotspot
   if (piece_is_flipped[5] = true) then
   distance_x := - distance_x;


   distance_r := Round(Sqrt(distance_x*distance_x + distance_y*distance_y));

   if (distance_x = 0) and (distance_y > 0) then
   mouse_rotation_angle := 90
   else if (distance_x = 0) and (distance_y < 0) then
   mouse_rotation_angle := -90
   else
   mouse_rotation_angle := radtodeg(ArcTan2(distance_y,distance_x));

 //    DebugLabel.Visible := true;
 //    DebugLabel.Caption := IntToStr(distance_r) + ', ' + IntToStr(distance_x) + ', ' + IntToStr(distance_y) + ', ' + IntToStr(mouseleft) + ', ' + IntToStr(mousetop);
 //    DebugLabel.Caption := FloatToStr(mouse_rotation_angle);

  mouse_rotation_angle_difference := mouse_rotation_angle - mouse_rotation_angle_original;
   if(mouse_rotation_angle_difference > 180) then
   mouse_rotation_angle_difference := mouse_rotation_angle_difference - 360;


  current_rotation_angle := Round(mouse_rotation_angle_difference);
  RedrawCurrentPiece();
  Exit;
  end;// if(rotation_mode = true)

  end; // if( mouse_button_pressed )



end;

procedure TPuzzleGameForm.Piece06MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin

  if((slideshow_mode = true) or (PlayerSelectComboBox.ItemIndex < 2)) then
  Exit;

Piece06.Cursor := 1;

if ((MoveToNearestSlotAnimationTimer.Enabled = true) or (RotateToNearest60angleAnimationTimer.Enabled = true)) then
Exit();

if(rotation_mode = false) then
begin
  current_slot := 0;
  ClearSlot(piece_slot_address[5]);
  piece_slot_address[5] := 0;


  if ((abs(slot_left[0] - Piece06.Left) < piece_half_size) and (abs(slot_top[0] - Piece06.Top ) < piece_half_size)) then
  begin
      current_slot := 1;

  if ((slot_content[0] <> 0) and (slot_content[0] <> 6)) then
  PlacePieceToStartPosition(slot_content[0]);
  RedrawCurrentPiece();
  slot_content[0] := 6;

  piece_slot_address[5] := 1;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[1] - Piece06.Left) < piece_half_size) and (abs(slot_top[1] - Piece06.Top ) < piece_half_size)) then
  begin
      current_slot := 2;

  if ((slot_content[1] <> 0) and (slot_content[1] <> 6)) then
  PlacePieceToStartPosition(slot_content[1]);
  RedrawCurrentPiece();
  slot_content[1] := 6;

  piece_slot_address[5] := 2;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[2] - Piece06.Left) < piece_half_size) and (abs(slot_top[2] - Piece06.Top ) < piece_half_size)) then
  begin
      current_slot := 3;

  if ((slot_content[2] <> 0) and (slot_content[2] <> 6)) then
  PlacePieceToStartPosition(slot_content[2]);
  RedrawCurrentPiece();
  slot_content[2] := 6;

  piece_slot_address[5] := 3;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[3] - Piece06.Left) < piece_half_size) and (abs(slot_top[3] - Piece06.Top ) < piece_half_size)) then
  begin
      current_slot := 4;

  if ((slot_content[3] <> 0) and (slot_content[3] <> 6)) then
  PlacePieceToStartPosition(slot_content[3]);
  RedrawCurrentPiece();
  slot_content[3] := 6;

  piece_slot_address[5] := 4;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[4] - Piece06.Left) < piece_half_size) and (abs(slot_top[4] - Piece06.Top ) < piece_half_size)) then
  begin
      current_slot := 5;

  if ((slot_content[4] <> 0) and (slot_content[4] <> 6)) then
  PlacePieceToStartPosition(slot_content[4]);
  RedrawCurrentPiece();
  slot_content[4] := 6;

  piece_slot_address[5] := 5;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[5] - Piece06.Left) < piece_half_size) and (abs(slot_top[5] - Piece06.Top ) < piece_half_size)) then
  begin
      current_slot := 6;

  if ((slot_content[5] <> 0) and (slot_content[5] <> 6)) then
  PlacePieceToStartPosition(slot_content[5]);
  RedrawCurrentPiece();
  slot_content[5] := 6;

  piece_slot_address[5] := 6;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[6] - Piece06.Left) < piece_half_size) and (abs(slot_top[6] - Piece06.Top ) < piece_half_size)) then
  begin
      current_slot := 7;

  if ((slot_content[6] <> 0) and (slot_content[6] <> 6)) then
  PlacePieceToStartPosition(slot_content[6]);
  RedrawCurrentPiece();
  slot_content[6] := 6;

  piece_slot_address[5] := 7;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[7] - Piece06.Left) < piece_half_size) and (abs(slot_top[7] - Piece06.Top ) < piece_half_size)) then
  begin
      current_slot := 8;

  if ((slot_content[7] <> 0) and (slot_content[7] <> 6)) then
  PlacePieceToStartPosition(slot_content[7]);
  RedrawCurrentPiece();
  slot_content[7] := 6;

  piece_slot_address[5] := 8;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[8] - Piece06.Left) < piece_half_size) and (abs(slot_top[8] - Piece06.Top ) < piece_half_size)) then
  begin
      current_slot := 9;

  if ((slot_content[8] <> 0) and (slot_content[8] <> 6)) then
  PlacePieceToStartPosition(slot_content[8]);
  RedrawCurrentPiece();
  slot_content[8] := 6;

  piece_slot_address[5] := 9;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[9] - Piece06.Left) < piece_half_size) and (abs(slot_top[9] - Piece06.Top ) < piece_half_size)) then
  begin
      current_slot := 10;

  if ((slot_content[9] <> 0) and (slot_content[9] <> 6)) then
  PlacePieceToStartPosition(slot_content[9]);
  RedrawCurrentPiece();
  slot_content[9] := 6;

  piece_slot_address[5] := 10;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[10] - Piece06.Left) < piece_half_size) and (abs(slot_top[10] - Piece06.Top ) < piece_half_size)) then
  begin
      current_slot := 11;

  if ((slot_content[10] <> 0) and (slot_content[10] <> 6)) then
  PlacePieceToStartPosition(slot_content[10]);
  RedrawCurrentPiece();
  slot_content[10] := 6;

  piece_slot_address[5] := 11;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[11] - Piece06.Left) < piece_half_size) and (abs(slot_top[11] - Piece06.Top ) < piece_half_size)) then
  begin
      current_slot := 12;

  if ((slot_content[11] <> 0) and (slot_content[11] <> 6)) then
  PlacePieceToStartPosition(slot_content[11]);
  RedrawCurrentPiece();
  slot_content[11] := 6;

  piece_slot_address[5] := 12;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[12] - Piece06.Left) < piece_half_size) and (abs(slot_top[12] - Piece06.Top ) < piece_half_size)) then
  begin
      current_slot := 13;

  if ((slot_content[12] <> 0) and (slot_content[12] <> 6)) then
  PlacePieceToStartPosition(slot_content[12]);
  RedrawCurrentPiece();
  slot_content[12] := 6;

  piece_slot_address[5] := 13;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end;
end // if(rotation_mode = false)
else if(rotation_mode = true) then
begin

current_rotation_angle := Round(mouse_rotation_angle_difference);
angle_6th_part := mouse_rotation_angle_difference / 60.0;
final_rotation_angle := Round(angle_6th_part) * 60;
piece_rotation_angle[5] := final_rotation_angle;
RotateToNearest60angleAnimationTimer.Enabled := true;

end; // else if(rotation_mode = true)

RedrawCurrentPiece();

end;

procedure TPuzzleGameForm.Piece07MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin

if((slideshow_mode = true) or (PlayerSelectComboBox.ItemIndex < 2)) then
Exit;

  MoveToNearestSlotAnimationTimer.Enabled := false;
  RotateToNearest60angleAnimationTimer.Enabled := false;
  ErrorCircleImage.Visible := false;

  current_piece := 7;
  current_slot := piece_slot_address[current_piece-1];
  clicked_X := Mouse.CursorPos.X - Piece07.Left;
  clicked_Y := Mouse.CursorPos.Y - Piece07.Top;
  Piece07.Cursor := 2;
  Piece07.BringToFront();

  PieceRotationTrackBar.OnChange := nil;
  PieceRotationTrackBar.Position := piece_rotation_angle[6];
  PieceRotationTrackBar.OnChange := @PieceRotationTrackBarChange;

  current_rotation_angle := piece_rotation_angle[6];

  distance_x := Mouse.CursorPos.X - PuzzleGameForm.Left - Piece07.Left - piece_half_size - mouseleft - 7; // cursor image size is 32x32, compensate for hotspot
  distance_y := Mouse.CursorPos.Y - PuzzleGameForm.Top - Piece07.Top - piece_half_size - mousetop - 7; // cursor image size is 32x32, compensate for hotspot
  if (piece_is_flipped[6] = true) then
  distance_x := - distance_x;


  distance_r := Round(Sqrt(distance_x*distance_x + distance_y*distance_y));

  if ( distance_r > piece_quarter_size) then
  begin
  rotation_mode := true;
  if (distance_x = 0) and (distance_y > 0) then
  mouse_rotation_angle_original := 90
  else if (distance_x = 0) and (distance_y < 0) then
  mouse_rotation_angle_original := -90
  else
  mouse_rotation_angle_original := radtodeg(ArcTan2(distance_y,distance_x));

  mouse_rotation_angle_original := mouse_rotation_angle_original - piece_rotation_angle[6];
  if(mouse_rotation_angle_original > 180) then
  mouse_rotation_angle_original := mouse_rotation_angle_original - 360;
  end// if(rotation_mode = true)
  else
  rotation_mode := false;

//    DebugLabel.Visible := true;
//    DebugLabel.Caption := IntToStr(distance_r) + ', ' + IntToStr(distance_x) + ', ' + IntToStr(distance_y) + ', ' + IntToStr(mouseleft) + ', ' + IntToStr(mousetop);
//    DebugLabel.Caption := FloatToStr(mouse_rotation_angle_original);

  RedrawAllPieces();

end;

procedure TPuzzleGameForm.Piece07MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin

  if((slideshow_mode = true) or (PlayerSelectComboBox.ItemIndex < 2)) then
  Exit;

  if ((MoveToNearestSlotAnimationTimer.Enabled = true) or (RotateToNearest60angleAnimationTimer.Enabled = true)) then
  Exit();


// https://www.freepascal.org/docs-html/rtl/classes/tshiftstate.html
// ssLeft -- Left mouse button pressed.
  if ((Shift = [ssLeft]) and not mouse_button_pressed) then
  begin
    mouse_button_pressed := true;

  end;

  if not (Shift = [ssLeft]) then
  begin
        mouse_button_pressed := false;
  end;


  if( mouse_button_pressed ) then
  begin
   if(rotation_mode = false) then
   begin
    Piece07.Top :=  Mouse.CursorPos.Y - clicked_Y;
    Piece07.Left := Mouse.CursorPos.X - clicked_X;
   end // if(rotation_mode = false)
   else if(rotation_mode = true) then
   begin

   distance_x := Mouse.CursorPos.X - PuzzleGameForm.Left - Piece07.Left - piece_half_size - mouseleft - 7; // cursor image size is 32x32, compensate for hotspot
   distance_y := Mouse.CursorPos.Y - PuzzleGameForm.Top - Piece07.Top - piece_half_size - mousetop - 7; // cursor image size is 32x32, compensate for hotspot
   if (piece_is_flipped[6] = true) then
   distance_x := - distance_x;


   distance_r := Round(Sqrt(distance_x*distance_x + distance_y*distance_y));

   if (distance_x = 0) and (distance_y > 0) then
   mouse_rotation_angle := 90
   else if (distance_x = 0) and (distance_y < 0) then
   mouse_rotation_angle := -90
   else
   mouse_rotation_angle := radtodeg(ArcTan2(distance_y,distance_x));

 //    DebugLabel.Visible := true;
 //    DebugLabel.Caption := IntToStr(distance_r) + ', ' + IntToStr(distance_x) + ', ' + IntToStr(distance_y) + ', ' + IntToStr(mouseleft) + ', ' + IntToStr(mousetop);
 //    DebugLabel.Caption := FloatToStr(mouse_rotation_angle);

  mouse_rotation_angle_difference := mouse_rotation_angle - mouse_rotation_angle_original;
   if(mouse_rotation_angle_difference > 180) then
   mouse_rotation_angle_difference := mouse_rotation_angle_difference - 360;


  current_rotation_angle := Round(mouse_rotation_angle_difference);
  RedrawCurrentPiece();
  Exit;
  end;// if(rotation_mode = true)

  end; // if( mouse_button_pressed )





end;

procedure TPuzzleGameForm.Piece07MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin

  if((slideshow_mode = true) or (PlayerSelectComboBox.ItemIndex < 2)) then
  Exit;

Piece07.Cursor := 1;

if ((MoveToNearestSlotAnimationTimer.Enabled = true) or (RotateToNearest60angleAnimationTimer.Enabled = true)) then
Exit();

if(rotation_mode = false) then
begin
  current_slot := 0;
  ClearSlot(piece_slot_address[6]);
  piece_slot_address[6] := 0;


  if ((abs(slot_left[0] - Piece07.Left) < piece_half_size) and (abs(slot_top[0] - Piece07.Top ) < piece_half_size)) then
  begin
      current_slot := 1;

  if ((slot_content[0] <> 0) and (slot_content[0] <> 7)) then
  PlacePieceToStartPosition(slot_content[0]);
  RedrawCurrentPiece();
  slot_content[0] := 7;

  piece_slot_address[6] := 1;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[1] - Piece07.Left) < piece_half_size) and (abs(slot_top[1] - Piece07.Top ) < piece_half_size)) then
  begin
      current_slot := 2;

  if ((slot_content[1] <> 0) and (slot_content[1] <> 7)) then
  PlacePieceToStartPosition(slot_content[1]);
  RedrawCurrentPiece();
  slot_content[1] := 7;

  piece_slot_address[6] := 2;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[2] - Piece07.Left) < piece_half_size) and (abs(slot_top[2] - Piece07.Top ) < piece_half_size)) then
  begin
      current_slot := 3;

  if ((slot_content[2] <> 0) and (slot_content[2] <> 7)) then
  PlacePieceToStartPosition(slot_content[2]);
  RedrawCurrentPiece();
  slot_content[2] := 7;

  piece_slot_address[6] := 3;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[3] - Piece07.Left) < piece_half_size) and (abs(slot_top[3] - Piece07.Top ) < piece_half_size)) then
  begin
      current_slot := 4;

  if ((slot_content[3] <> 0) and (slot_content[3] <> 7)) then
  PlacePieceToStartPosition(slot_content[3]);
  RedrawCurrentPiece();
  slot_content[3] := 7;

  piece_slot_address[6] := 4;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[4] - Piece07.Left) < piece_half_size) and (abs(slot_top[4] - Piece07.Top ) < piece_half_size)) then
  begin
      current_slot := 5;

  if ((slot_content[4] <> 0) and (slot_content[4] <> 7)) then
  PlacePieceToStartPosition(slot_content[4]);
  RedrawCurrentPiece();
  slot_content[4] := 7;

  piece_slot_address[6] := 5;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[5] - Piece07.Left) < piece_half_size) and (abs(slot_top[5] - Piece07.Top ) < piece_half_size)) then
  begin
      current_slot := 6;

  if ((slot_content[5] <> 0) and (slot_content[5] <> 7)) then
  PlacePieceToStartPosition(slot_content[5]);
  RedrawCurrentPiece();
  slot_content[5] := 7;

  piece_slot_address[6] := 6;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[6] - Piece07.Left) < piece_half_size) and (abs(slot_top[6] - Piece07.Top ) < piece_half_size)) then
  begin
      current_slot := 7;

  if ((slot_content[6] <> 0) and (slot_content[6] <> 7)) then
  PlacePieceToStartPosition(slot_content[6]);
  RedrawCurrentPiece();
  slot_content[6] := 7;

  piece_slot_address[6] := 7;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[7] - Piece07.Left) < piece_half_size) and (abs(slot_top[7] - Piece07.Top ) < piece_half_size)) then
  begin
      current_slot := 8;

  if ((slot_content[7] <> 0) and (slot_content[7] <> 7)) then
  PlacePieceToStartPosition(slot_content[7]);
  RedrawCurrentPiece();
  slot_content[7] := 7;

  piece_slot_address[6] := 8;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[8] - Piece07.Left) < piece_half_size) and (abs(slot_top[8] - Piece07.Top ) < piece_half_size)) then
  begin
      current_slot := 9;

  if ((slot_content[8] <> 0) and (slot_content[8] <> 7)) then
  PlacePieceToStartPosition(slot_content[8]);
  RedrawCurrentPiece();
  slot_content[8] := 7;

  piece_slot_address[6] := 9;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[9] - Piece07.Left) < piece_half_size) and (abs(slot_top[9] - Piece07.Top ) < piece_half_size)) then
  begin
      current_slot := 10;

  if ((slot_content[9] <> 0) and (slot_content[9] <> 7)) then
  PlacePieceToStartPosition(slot_content[9]);
  RedrawCurrentPiece();
  slot_content[9] := 7;

  piece_slot_address[6] := 10;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[10] - Piece07.Left) < piece_half_size) and (abs(slot_top[10] - Piece07.Top ) < piece_half_size)) then
  begin
      current_slot := 11;

  if ((slot_content[10] <> 0) and (slot_content[10] <> 7)) then
  PlacePieceToStartPosition(slot_content[10]);
  RedrawCurrentPiece();
  slot_content[10] := 7;

  piece_slot_address[6] := 11;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[11] - Piece07.Left) < piece_half_size) and (abs(slot_top[11] - Piece07.Top ) < piece_half_size)) then
  begin
      current_slot := 12;

  if ((slot_content[11] <> 0) and (slot_content[11] <> 7)) then
  PlacePieceToStartPosition(slot_content[11]);
  RedrawCurrentPiece();
  slot_content[11] := 7;

  piece_slot_address[6] := 12;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[12] - Piece07.Left) < piece_half_size) and (abs(slot_top[12] - Piece07.Top ) < piece_half_size)) then
  begin
      current_slot := 13;

  if ((slot_content[12] <> 0) and (slot_content[12] <> 7)) then
  PlacePieceToStartPosition(slot_content[12]);
  RedrawCurrentPiece();
  slot_content[12] := 7;

  piece_slot_address[6] := 13;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end;
end // if(rotation_mode = false)
else if(rotation_mode = true) then
begin

current_rotation_angle := Round(mouse_rotation_angle_difference);
angle_6th_part := mouse_rotation_angle_difference / 60.0;
final_rotation_angle := Round(angle_6th_part) * 60;
piece_rotation_angle[6] := final_rotation_angle;
RotateToNearest60angleAnimationTimer.Enabled := true;

end; // else if(rotation_mode = true)

RedrawCurrentPiece();

end;

procedure TPuzzleGameForm.Piece08MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin

if((slideshow_mode = true) or (PlayerSelectComboBox.ItemIndex < 2)) then
Exit;

  MoveToNearestSlotAnimationTimer.Enabled := false;
  RotateToNearest60angleAnimationTimer.Enabled := false;
  ErrorCircleImage.Visible := false;

  current_piece := 8;
  current_slot := piece_slot_address[current_piece-1];
  clicked_X := Mouse.CursorPos.X - Piece08.Left;
  clicked_Y := Mouse.CursorPos.Y - Piece08.Top;
  Piece08.Cursor := 2;
  Piece08.BringToFront();

  PieceRotationTrackBar.OnChange := nil;
  PieceRotationTrackBar.Position := piece_rotation_angle[7];
  PieceRotationTrackBar.OnChange := @PieceRotationTrackBarChange;

  current_rotation_angle := piece_rotation_angle[7];

  distance_x := Mouse.CursorPos.X - PuzzleGameForm.Left - Piece08.Left - piece_half_size - mouseleft - 7; // cursor image size is 32x32, compensate for hotspot
  distance_y := Mouse.CursorPos.Y - PuzzleGameForm.Top - Piece08.Top - piece_half_size - mousetop - 7; // cursor image size is 32x32, compensate for hotspot
  if (piece_is_flipped[7] = true) then
  distance_x := - distance_x;


  distance_r := Round(Sqrt(distance_x*distance_x + distance_y*distance_y));

  if ( distance_r > piece_quarter_size) then
  begin
  rotation_mode := true;
  if (distance_x = 0) and (distance_y > 0) then
  mouse_rotation_angle_original := 90
  else if (distance_x = 0) and (distance_y < 0) then
  mouse_rotation_angle_original := -90
  else
  mouse_rotation_angle_original := radtodeg(ArcTan2(distance_y,distance_x));

  mouse_rotation_angle_original := mouse_rotation_angle_original - piece_rotation_angle[7];
  if(mouse_rotation_angle_original > 180) then
  mouse_rotation_angle_original := mouse_rotation_angle_original - 360;
  end// if(rotation_mode = true)
  else
  rotation_mode := false;

//    DebugLabel.Visible := true;
//    DebugLabel.Caption := IntToStr(distance_r) + ', ' + IntToStr(distance_x) + ', ' + IntToStr(distance_y) + ', ' + IntToStr(mouseleft) + ', ' + IntToStr(mousetop);
//    DebugLabel.Caption := FloatToStr(mouse_rotation_angle_original);

  RedrawAllPieces();

end;

procedure TPuzzleGameForm.Piece08MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin

  if((slideshow_mode = true) or (PlayerSelectComboBox.ItemIndex < 2)) then
  Exit;

  if ((MoveToNearestSlotAnimationTimer.Enabled = true) or (RotateToNearest60angleAnimationTimer.Enabled = true)) then
  Exit();


// https://www.freepascal.org/docs-html/rtl/classes/tshiftstate.html
// ssLeft -- Left mouse button pressed.
  if ((Shift = [ssLeft]) and not mouse_button_pressed) then
  begin
    mouse_button_pressed := true;

  end;

  if not (Shift = [ssLeft]) then
  begin
        mouse_button_pressed := false;
  end;


  if( mouse_button_pressed ) then
  begin
   if(rotation_mode = false) then
   begin
    Piece08.Top :=  Mouse.CursorPos.Y - clicked_Y;
    Piece08.Left := Mouse.CursorPos.X - clicked_X;
   end // if(rotation_mode = false)
   else if(rotation_mode = true) then
   begin

   distance_x := Mouse.CursorPos.X - PuzzleGameForm.Left - Piece08.Left - piece_half_size - mouseleft - 7; // cursor image size is 32x32, compensate for hotspot
   distance_y := Mouse.CursorPos.Y - PuzzleGameForm.Top - Piece08.Top - piece_half_size - mousetop - 7; // cursor image size is 32x32, compensate for hotspot
   if (piece_is_flipped[7] = true) then
   distance_x := - distance_x;


   distance_r := Round(Sqrt(distance_x*distance_x + distance_y*distance_y));

   if (distance_x = 0) and (distance_y > 0) then
   mouse_rotation_angle := 90
   else if (distance_x = 0) and (distance_y < 0) then
   mouse_rotation_angle := -90
   else
   mouse_rotation_angle := radtodeg(ArcTan2(distance_y,distance_x));

 //    DebugLabel.Visible := true;
 //    DebugLabel.Caption := IntToStr(distance_r) + ', ' + IntToStr(distance_x) + ', ' + IntToStr(distance_y) + ', ' + IntToStr(mouseleft) + ', ' + IntToStr(mousetop);
 //    DebugLabel.Caption := FloatToStr(mouse_rotation_angle);

  mouse_rotation_angle_difference := mouse_rotation_angle - mouse_rotation_angle_original;
   if(mouse_rotation_angle_difference > 180) then
   mouse_rotation_angle_difference := mouse_rotation_angle_difference - 360;


  current_rotation_angle := Round(mouse_rotation_angle_difference);
  RedrawCurrentPiece();
  Exit;
  end;// if(rotation_mode = true)

  end; // if( mouse_button_pressed )





end;

procedure TPuzzleGameForm.Piece08MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin

  if((slideshow_mode = true) or (PlayerSelectComboBox.ItemIndex < 2)) then
  Exit;

Piece08.Cursor := 1;

if ((MoveToNearestSlotAnimationTimer.Enabled = true) or (RotateToNearest60angleAnimationTimer.Enabled = true)) then
Exit();

if(rotation_mode = false) then
begin
  current_slot := 0;
  ClearSlot(piece_slot_address[7]);
  piece_slot_address[7] := 0;


  if ((abs(slot_left[0] - Piece08.Left) < piece_half_size) and (abs(slot_top[0] - Piece08.Top ) < piece_half_size)) then
  begin
      current_slot := 1;

  if ((slot_content[0] <> 0) and (slot_content[0] <> 8)) then
  PlacePieceToStartPosition(slot_content[0]);
  RedrawCurrentPiece();
  slot_content[0] := 8;

  piece_slot_address[7] := 1;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[1] - Piece08.Left) < piece_half_size) and (abs(slot_top[1] - Piece08.Top ) < piece_half_size)) then
  begin
      current_slot := 2;

  if ((slot_content[1] <> 0) and (slot_content[1] <> 8)) then
  PlacePieceToStartPosition(slot_content[1]);
  RedrawCurrentPiece();
  slot_content[1] := 8;

  piece_slot_address[7] := 2;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[2] - Piece08.Left) < piece_half_size) and (abs(slot_top[2] - Piece08.Top ) < piece_half_size)) then
  begin
      current_slot := 3;

  if ((slot_content[2] <> 0) and (slot_content[2] <> 8)) then
  PlacePieceToStartPosition(slot_content[2]);
  RedrawCurrentPiece();
  slot_content[2] := 8;

  piece_slot_address[7] := 3;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[3] - Piece08.Left) < piece_half_size) and (abs(slot_top[3] - Piece08.Top ) < piece_half_size)) then
  begin
      current_slot := 4;

  if ((slot_content[3] <> 0) and (slot_content[3] <> 8)) then
  PlacePieceToStartPosition(slot_content[3]);
  RedrawCurrentPiece();
  slot_content[3] := 8;

  piece_slot_address[7] := 4;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[4] - Piece08.Left) < piece_half_size) and (abs(slot_top[4] - Piece08.Top ) < piece_half_size)) then
  begin
      current_slot := 5;

  if ((slot_content[4] <> 0) and (slot_content[4] <> 8)) then
  PlacePieceToStartPosition(slot_content[4]);
  RedrawCurrentPiece();
  slot_content[4] := 8;

  piece_slot_address[7] := 5;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[5] - Piece08.Left) < piece_half_size) and (abs(slot_top[5] - Piece08.Top ) < piece_half_size)) then
  begin
      current_slot := 6;

  if ((slot_content[5] <> 0) and (slot_content[5] <> 8)) then
  PlacePieceToStartPosition(slot_content[5]);
  RedrawCurrentPiece();
  slot_content[5] := 8;

  piece_slot_address[7] := 6;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[6] - Piece08.Left) < piece_half_size) and (abs(slot_top[6] - Piece08.Top ) < piece_half_size)) then
  begin
      current_slot := 7;

  if ((slot_content[6] <> 0) and (slot_content[6] <> 8)) then
  PlacePieceToStartPosition(slot_content[6]);
  RedrawCurrentPiece();
  slot_content[6] := 8;

  piece_slot_address[7] := 7;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[7] - Piece08.Left) < piece_half_size) and (abs(slot_top[7] - Piece08.Top ) < piece_half_size)) then
  begin
      current_slot := 8;

  if ((slot_content[7] <> 0) and (slot_content[7] <> 8)) then
  PlacePieceToStartPosition(slot_content[7]);
  RedrawCurrentPiece();
  slot_content[7] := 8;

  piece_slot_address[7] := 8;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[8] - Piece08.Left) < piece_half_size) and (abs(slot_top[8] - Piece08.Top ) < piece_half_size)) then
  begin
      current_slot := 9;

  if ((slot_content[8] <> 0) and (slot_content[8] <> 8)) then
  PlacePieceToStartPosition(slot_content[8]);
  RedrawCurrentPiece();
  slot_content[8] := 8;

  piece_slot_address[7] := 9;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[9] - Piece08.Left) < piece_half_size) and (abs(slot_top[9] - Piece08.Top ) < piece_half_size)) then
  begin
      current_slot := 10;

  if ((slot_content[9] <> 0) and (slot_content[9] <> 8)) then
  PlacePieceToStartPosition(slot_content[9]);
  RedrawCurrentPiece();
  slot_content[9] := 8;

  piece_slot_address[7] := 10;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[10] - Piece08.Left) < piece_half_size) and (abs(slot_top[10] - Piece08.Top ) < piece_half_size)) then
  begin
      current_slot := 11;

  if ((slot_content[10] <> 0) and (slot_content[10] <> 8)) then
  PlacePieceToStartPosition(slot_content[10]);
  RedrawCurrentPiece();
  slot_content[10] := 8;

  piece_slot_address[7] := 11;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[11] - Piece08.Left) < piece_half_size) and (abs(slot_top[11] - Piece08.Top ) < piece_half_size)) then
  begin
      current_slot := 12;

  if ((slot_content[11] <> 0) and (slot_content[11] <> 8)) then
  PlacePieceToStartPosition(slot_content[11]);
  RedrawCurrentPiece();
  slot_content[11] := 8;

  piece_slot_address[7] := 12;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[12] - Piece08.Left) < piece_half_size) and (abs(slot_top[12] - Piece08.Top ) < piece_half_size)) then
  begin
      current_slot := 13;

  if ((slot_content[12] <> 0) and (slot_content[12] <> 8)) then
  PlacePieceToStartPosition(slot_content[12]);
  RedrawCurrentPiece();
  slot_content[12] := 8;

  piece_slot_address[7] := 13;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end;
end // if(rotation_mode = false)
else if(rotation_mode = true) then
begin

current_rotation_angle := Round(mouse_rotation_angle_difference);
angle_6th_part := mouse_rotation_angle_difference / 60.0;
final_rotation_angle := Round(angle_6th_part) * 60;
piece_rotation_angle[7] := final_rotation_angle;
RotateToNearest60angleAnimationTimer.Enabled := true;

end; // else if(rotation_mode = true)

RedrawCurrentPiece();


end;

procedure TPuzzleGameForm.Piece09MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin

if((slideshow_mode = true) or (PlayerSelectComboBox.ItemIndex < 2)) then
Exit;

  MoveToNearestSlotAnimationTimer.Enabled := false;
  RotateToNearest60angleAnimationTimer.Enabled := false;
  ErrorCircleImage.Visible := false;

  current_piece := 9;
  current_slot := piece_slot_address[current_piece-1];
  clicked_X := Mouse.CursorPos.X - Piece09.Left;
  clicked_Y := Mouse.CursorPos.Y - Piece09.Top;
  Piece09.Cursor := 2;
  Piece09.BringToFront();

  PieceRotationTrackBar.OnChange := nil;
  PieceRotationTrackBar.Position := piece_rotation_angle[8];
  PieceRotationTrackBar.OnChange := @PieceRotationTrackBarChange;

  current_rotation_angle := piece_rotation_angle[8];

  distance_x := Mouse.CursorPos.X - PuzzleGameForm.Left - Piece09.Left - piece_half_size - mouseleft - 7; // cursor image size is 32x32, compensate for hotspot
  distance_y := Mouse.CursorPos.Y - PuzzleGameForm.Top - Piece09.Top - piece_half_size - mousetop - 7; // cursor image size is 32x32, compensate for hotspot
  if (piece_is_flipped[8] = true) then
  distance_x := - distance_x;


  distance_r := Round(Sqrt(distance_x*distance_x + distance_y*distance_y));

  if ( distance_r > piece_quarter_size) then
  begin
  rotation_mode := true;
  if (distance_x = 0) and (distance_y > 0) then
  mouse_rotation_angle_original := 90
  else if (distance_x = 0) and (distance_y < 0) then
  mouse_rotation_angle_original := -90
  else
  mouse_rotation_angle_original := radtodeg(ArcTan2(distance_y,distance_x));

  mouse_rotation_angle_original := mouse_rotation_angle_original - piece_rotation_angle[8];
  if(mouse_rotation_angle_original > 180) then
  mouse_rotation_angle_original := mouse_rotation_angle_original - 360;
  end// if(rotation_mode = true)
  else
  rotation_mode := false;

//    DebugLabel.Visible := true;
//    DebugLabel.Caption := IntToStr(distance_r) + ', ' + IntToStr(distance_x) + ', ' + IntToStr(distance_y) + ', ' + IntToStr(mouseleft) + ', ' + IntToStr(mousetop);
//    DebugLabel.Caption := FloatToStr(mouse_rotation_angle_original);

  RedrawAllPieces();

end;

procedure TPuzzleGameForm.Piece09MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin

  if((slideshow_mode = true) or (PlayerSelectComboBox.ItemIndex < 2)) then
  Exit;

  if ((MoveToNearestSlotAnimationTimer.Enabled = true) or (RotateToNearest60angleAnimationTimer.Enabled = true)) then
  Exit();


// https://www.freepascal.org/docs-html/rtl/classes/tshiftstate.html
// ssLeft -- Left mouse button pressed.
  if ((Shift = [ssLeft]) and not mouse_button_pressed) then
  begin
    mouse_button_pressed := true;

  end;

  if not (Shift = [ssLeft]) then
  begin
        mouse_button_pressed := false;
  end;


  if( mouse_button_pressed ) then
  begin
   if(rotation_mode = false) then
   begin
    Piece09.Top :=  Mouse.CursorPos.Y - clicked_Y;
    Piece09.Left := Mouse.CursorPos.X - clicked_X;
   end // if(rotation_mode = false)
   else if(rotation_mode = true) then
   begin

   distance_x := Mouse.CursorPos.X - PuzzleGameForm.Left - Piece09.Left - piece_half_size - mouseleft - 7; // cursor image size is 32x32, compensate for hotspot
   distance_y := Mouse.CursorPos.Y - PuzzleGameForm.Top - Piece09.Top - piece_half_size - mousetop - 7; // cursor image size is 32x32, compensate for hotspot
   if (piece_is_flipped[8] = true) then
   distance_x := - distance_x;


   distance_r := Round(Sqrt(distance_x*distance_x + distance_y*distance_y));

   if (distance_x = 0) and (distance_y > 0) then
   mouse_rotation_angle := 90
   else if (distance_x = 0) and (distance_y < 0) then
   mouse_rotation_angle := -90
   else
   mouse_rotation_angle := radtodeg(ArcTan2(distance_y,distance_x));

 //    DebugLabel.Visible := true;
 //    DebugLabel.Caption := IntToStr(distance_r) + ', ' + IntToStr(distance_x) + ', ' + IntToStr(distance_y) + ', ' + IntToStr(mouseleft) + ', ' + IntToStr(mousetop);
 //    DebugLabel.Caption := FloatToStr(mouse_rotation_angle);

  mouse_rotation_angle_difference := mouse_rotation_angle - mouse_rotation_angle_original;
   if(mouse_rotation_angle_difference > 180) then
   mouse_rotation_angle_difference := mouse_rotation_angle_difference - 360;


  current_rotation_angle := Round(mouse_rotation_angle_difference);
  RedrawCurrentPiece();
  Exit;
  end;// if(rotation_mode = true)

  end; // if( mouse_button_pressed )




end;

procedure TPuzzleGameForm.Piece09MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin

  if((slideshow_mode = true) or (PlayerSelectComboBox.ItemIndex < 2)) then
  Exit;

Piece09.Cursor := 1;

if ((MoveToNearestSlotAnimationTimer.Enabled = true) or (RotateToNearest60angleAnimationTimer.Enabled = true)) then
Exit();

if(rotation_mode = false) then
begin
  current_slot := 0;
  ClearSlot(piece_slot_address[8]);
  piece_slot_address[8] := 0;


  if ((abs(slot_left[0] - Piece09.Left) < piece_half_size) and (abs(slot_top[0] - Piece09.Top ) < piece_half_size)) then
  begin
      current_slot := 1;

  if ((slot_content[0] <> 0) and (slot_content[0] <> 9)) then
  PlacePieceToStartPosition(slot_content[0]);
  RedrawCurrentPiece();
  slot_content[0] := 9;

  piece_slot_address[8] := 1;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[1] - Piece09.Left) < piece_half_size) and (abs(slot_top[1] - Piece09.Top ) < piece_half_size)) then
  begin
      current_slot := 2;

  if ((slot_content[1] <> 0) and (slot_content[1] <> 9)) then
  PlacePieceToStartPosition(slot_content[1]);
  RedrawCurrentPiece();
  slot_content[1] := 9;

  piece_slot_address[8] := 2;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[2] - Piece09.Left) < piece_half_size) and (abs(slot_top[2] - Piece09.Top ) < piece_half_size)) then
  begin
      current_slot := 3;

  if ((slot_content[2] <> 0) and (slot_content[2] <> 9)) then
  PlacePieceToStartPosition(slot_content[2]);
  RedrawCurrentPiece();
  slot_content[2] := 9;

  piece_slot_address[8] := 3;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[3] - Piece09.Left) < piece_half_size) and (abs(slot_top[3] - Piece09.Top ) < piece_half_size)) then
  begin
      current_slot := 4;

  if ((slot_content[3] <> 0) and (slot_content[3] <> 9)) then
  PlacePieceToStartPosition(slot_content[3]);
  RedrawCurrentPiece();
  slot_content[3] := 9;

  piece_slot_address[8] := 4;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[4] - Piece09.Left) < piece_half_size) and (abs(slot_top[4] - Piece09.Top ) < piece_half_size)) then
  begin
      current_slot := 5;

  if ((slot_content[4] <> 0) and (slot_content[4] <> 9)) then
  PlacePieceToStartPosition(slot_content[4]);
  RedrawCurrentPiece();
  slot_content[4] := 9;

  piece_slot_address[8] := 5;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[5] - Piece09.Left) < piece_half_size) and (abs(slot_top[5] - Piece09.Top ) < piece_half_size)) then
  begin
      current_slot := 6;

  if ((slot_content[5] <> 0) and (slot_content[5] <> 9)) then
  PlacePieceToStartPosition(slot_content[5]);
  RedrawCurrentPiece();
  slot_content[5] := 9;

  piece_slot_address[8] := 6;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[6] - Piece09.Left) < piece_half_size) and (abs(slot_top[6] - Piece09.Top ) < piece_half_size)) then
  begin
      current_slot := 7;

  if ((slot_content[6] <> 0) and (slot_content[6] <> 9)) then
  PlacePieceToStartPosition(slot_content[6]);
  RedrawCurrentPiece();
  slot_content[6] := 9;

  piece_slot_address[8] := 7;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[7] - Piece09.Left) < piece_half_size) and (abs(slot_top[7] - Piece09.Top ) < piece_half_size)) then
  begin
      current_slot := 8;

  if ((slot_content[7] <> 0) and (slot_content[7] <> 9)) then
  PlacePieceToStartPosition(slot_content[7]);
  RedrawCurrentPiece();
  slot_content[7] := 9;

  piece_slot_address[8] := 8;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[8] - Piece09.Left) < piece_half_size) and (abs(slot_top[8] - Piece09.Top ) < piece_half_size)) then
  begin
      current_slot := 9;

  if ((slot_content[8] <> 0) and (slot_content[8] <> 9)) then
  PlacePieceToStartPosition(slot_content[8]);
  RedrawCurrentPiece();
  slot_content[8] := 9;

  piece_slot_address[8] := 9;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[9] - Piece09.Left) < piece_half_size) and (abs(slot_top[9] - Piece09.Top ) < piece_half_size)) then
  begin
      current_slot := 10;

  if ((slot_content[9] <> 0) and (slot_content[9] <> 9)) then
  PlacePieceToStartPosition(slot_content[9]);
  RedrawCurrentPiece();
  slot_content[9] := 9;

  piece_slot_address[8] := 10;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[10] - Piece09.Left) < piece_half_size) and (abs(slot_top[10] - Piece09.Top ) < piece_half_size)) then
  begin
      current_slot := 11;

  if ((slot_content[10] <> 0) and (slot_content[10] <> 9)) then
  PlacePieceToStartPosition(slot_content[10]);
  RedrawCurrentPiece();
  slot_content[10] := 9;

  piece_slot_address[8] := 11;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[11] - Piece09.Left) < piece_half_size) and (abs(slot_top[11] - Piece09.Top ) < piece_half_size)) then
  begin
      current_slot := 12;

  if ((slot_content[11] <> 0) and (slot_content[11] <> 9)) then
  PlacePieceToStartPosition(slot_content[11]);
  RedrawCurrentPiece();
  slot_content[11] := 9;

  piece_slot_address[8] := 12;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[12] - Piece09.Left) < piece_half_size) and (abs(slot_top[12] - Piece09.Top ) < piece_half_size)) then
  begin
      current_slot := 13;

  if ((slot_content[12] <> 0) and (slot_content[12] <> 9)) then
  PlacePieceToStartPosition(slot_content[12]);
  RedrawCurrentPiece();
  slot_content[12] := 9;

  piece_slot_address[8] := 13;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end;
end // if(rotation_mode = false)
else if(rotation_mode = true) then
begin

current_rotation_angle := Round(mouse_rotation_angle_difference);
angle_6th_part := mouse_rotation_angle_difference / 60.0;
final_rotation_angle := Round(angle_6th_part) * 60;
piece_rotation_angle[8] := final_rotation_angle;
RotateToNearest60angleAnimationTimer.Enabled := true;

end; // else if(rotation_mode = true)

RedrawCurrentPiece();

end;

procedure TPuzzleGameForm.Piece10Click(Sender: TObject);
begin

end;

procedure TPuzzleGameForm.Piece10MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin

if((slideshow_mode = true) or (PlayerSelectComboBox.ItemIndex < 2)) then
Exit;

  MoveToNearestSlotAnimationTimer.Enabled := false;
  RotateToNearest60angleAnimationTimer.Enabled := false;
  ErrorCircleImage.Visible := false;

  current_piece := 10;
  current_slot := piece_slot_address[current_piece-1];
  clicked_X := Mouse.CursorPos.X - Piece10.Left;
  clicked_Y := Mouse.CursorPos.Y - Piece10.Top;
  Piece10.Cursor := 2;
  Piece10.BringToFront();

  PieceRotationTrackBar.OnChange := nil;
  PieceRotationTrackBar.Position := piece_rotation_angle[9];
  PieceRotationTrackBar.OnChange := @PieceRotationTrackBarChange;

  current_rotation_angle := piece_rotation_angle[9];

  distance_x := Mouse.CursorPos.X - PuzzleGameForm.Left - Piece10.Left - piece_half_size - mouseleft - 7; // cursor image size is 32x32, compensate for hotspot
  distance_y := Mouse.CursorPos.Y - PuzzleGameForm.Top - Piece10.Top - piece_half_size - mousetop - 7; // cursor image size is 32x32, compensate for hotspot
  if (piece_is_flipped[9] = true) then
  distance_x := - distance_x;


  distance_r := Round(Sqrt(distance_x*distance_x + distance_y*distance_y));

  if ( distance_r > piece_quarter_size) then
  begin
  rotation_mode := true;
  if (distance_x = 0) and (distance_y > 0) then
  mouse_rotation_angle_original := 90
  else if (distance_x = 0) and (distance_y < 0) then
  mouse_rotation_angle_original := -90
  else
  mouse_rotation_angle_original := radtodeg(ArcTan2(distance_y,distance_x));

  mouse_rotation_angle_original := mouse_rotation_angle_original - piece_rotation_angle[9];
  if(mouse_rotation_angle_original > 180) then
  mouse_rotation_angle_original := mouse_rotation_angle_original - 360;
  end// if(rotation_mode = true)
  else
  rotation_mode := false;

//    DebugLabel.Visible := true;
//    DebugLabel.Caption := IntToStr(distance_r) + ', ' + IntToStr(distance_x) + ', ' + IntToStr(distance_y) + ', ' + IntToStr(mouseleft) + ', ' + IntToStr(mousetop);
//    DebugLabel.Caption := FloatToStr(mouse_rotation_angle_original);

  RedrawAllPieces();

end;

procedure TPuzzleGameForm.Piece10MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin

  if((slideshow_mode = true) or (PlayerSelectComboBox.ItemIndex < 2)) then
  Exit;

  if ((MoveToNearestSlotAnimationTimer.Enabled = true) or (RotateToNearest60angleAnimationTimer.Enabled = true)) then
  Exit();


// https://www.freepascal.org/docs-html/rtl/classes/tshiftstate.html
// ssLeft -- Left mouse button pressed.
  if ((Shift = [ssLeft]) and not mouse_button_pressed) then
  begin
    mouse_button_pressed := true;

  end;

  if not (Shift = [ssLeft]) then
  begin
        mouse_button_pressed := false;
  end;


  if( mouse_button_pressed ) then
  begin
   if(rotation_mode = false) then
   begin
    Piece10.Top :=  Mouse.CursorPos.Y - clicked_Y;
    Piece10.Left := Mouse.CursorPos.X - clicked_X;
   end // if(rotation_mode = false)
   else if(rotation_mode = true) then
   begin

   distance_x := Mouse.CursorPos.X - PuzzleGameForm.Left - Piece10.Left - piece_half_size - mouseleft - 7; // cursor image size is 32x32, compensate for hotspot
   distance_y := Mouse.CursorPos.Y - PuzzleGameForm.Top - Piece10.Top - piece_half_size - mousetop - 7; // cursor image size is 32x32, compensate for hotspot
   if (piece_is_flipped[9] = true) then
   distance_x := - distance_x;


   distance_r := Round(Sqrt(distance_x*distance_x + distance_y*distance_y));

   if (distance_x = 0) and (distance_y > 0) then
   mouse_rotation_angle := 90
   else if (distance_x = 0) and (distance_y < 0) then
   mouse_rotation_angle := -90
   else
   mouse_rotation_angle := radtodeg(ArcTan2(distance_y,distance_x));

 //    DebugLabel.Visible := true;
 //    DebugLabel.Caption := IntToStr(distance_r) + ', ' + IntToStr(distance_x) + ', ' + IntToStr(distance_y) + ', ' + IntToStr(mouseleft) + ', ' + IntToStr(mousetop);
 //    DebugLabel.Caption := FloatToStr(mouse_rotation_angle);

  mouse_rotation_angle_difference := mouse_rotation_angle - mouse_rotation_angle_original;
   if(mouse_rotation_angle_difference > 180) then
   mouse_rotation_angle_difference := mouse_rotation_angle_difference - 360;


  current_rotation_angle := Round(mouse_rotation_angle_difference);
  RedrawCurrentPiece();
  Exit;
  end;// if(rotation_mode = true)

  end; // if( mouse_button_pressed )





end;

procedure TPuzzleGameForm.Piece10MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin

  if((slideshow_mode = true) or (PlayerSelectComboBox.ItemIndex < 2)) then
  Exit;

Piece10.Cursor := 1;

if ((MoveToNearestSlotAnimationTimer.Enabled = true) or (RotateToNearest60angleAnimationTimer.Enabled = true)) then
Exit();

if(rotation_mode = false) then
begin
  current_slot := 0;
  ClearSlot(piece_slot_address[9]);
  piece_slot_address[9] := 0;


  if ((abs(slot_left[0] - Piece10.Left) < piece_half_size) and (abs(slot_top[0] - Piece10.Top ) < piece_half_size)) then
  begin
      current_slot := 1;

  if ((slot_content[0] <> 0) and (slot_content[0] <> 10)) then
  PlacePieceToStartPosition(slot_content[0]);
  RedrawCurrentPiece();
  slot_content[0] := 10;

  piece_slot_address[9] := 1;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[1] - Piece10.Left) < piece_half_size) and (abs(slot_top[1] - Piece10.Top ) < piece_half_size)) then
  begin
      current_slot := 2;

  if ((slot_content[1] <> 0) and (slot_content[1] <> 10)) then
  PlacePieceToStartPosition(slot_content[1]);
  RedrawCurrentPiece();
  slot_content[1] := 10;

  piece_slot_address[9] := 2;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[2] - Piece10.Left) < piece_half_size) and (abs(slot_top[2] - Piece10.Top ) < piece_half_size)) then
  begin
      current_slot := 3;

  if ((slot_content[2] <> 0) and (slot_content[2] <> 10)) then
  PlacePieceToStartPosition(slot_content[2]);
  RedrawCurrentPiece();
  slot_content[2] := 10;

  piece_slot_address[9] := 3;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[3] - Piece10.Left) < piece_half_size) and (abs(slot_top[3] - Piece10.Top ) < piece_half_size)) then
  begin
      current_slot := 4;

  if ((slot_content[3] <> 0) and (slot_content[3] <> 10)) then
  PlacePieceToStartPosition(slot_content[3]);
  RedrawCurrentPiece();
  slot_content[3] := 10;

  piece_slot_address[9] := 4;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[4] - Piece10.Left) < piece_half_size) and (abs(slot_top[4] - Piece10.Top ) < piece_half_size)) then
  begin
      current_slot := 5;

  if ((slot_content[4] <> 0) and (slot_content[4] <> 10)) then
  PlacePieceToStartPosition(slot_content[4]);
  RedrawCurrentPiece();
  slot_content[4] := 10;

  piece_slot_address[9] := 5;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[5] - Piece10.Left) < piece_half_size) and (abs(slot_top[5] - Piece10.Top ) < piece_half_size)) then
  begin
      current_slot := 6;

  if ((slot_content[5] <> 0) and (slot_content[5] <> 10)) then
  PlacePieceToStartPosition(slot_content[5]);
  RedrawCurrentPiece();
  slot_content[5] := 10;

  piece_slot_address[9] := 6;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[6] - Piece10.Left) < piece_half_size) and (abs(slot_top[6] - Piece10.Top ) < piece_half_size)) then
  begin
      current_slot := 7;

  if ((slot_content[6] <> 0) and (slot_content[6] <> 10)) then
  PlacePieceToStartPosition(slot_content[6]);
  RedrawCurrentPiece();
  slot_content[6] := 10;

  piece_slot_address[9] := 7;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[7] - Piece10.Left) < piece_half_size) and (abs(slot_top[7] - Piece10.Top ) < piece_half_size)) then
  begin
      current_slot := 8;

  if ((slot_content[7] <> 0) and (slot_content[7] <> 10)) then
  PlacePieceToStartPosition(slot_content[7]);
  RedrawCurrentPiece();
  slot_content[7] := 10;

  piece_slot_address[9] := 8;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[8] - Piece10.Left) < piece_half_size) and (abs(slot_top[8] - Piece10.Top ) < piece_half_size)) then
  begin
      current_slot := 9;

  if ((slot_content[8] <> 0) and (slot_content[8] <> 10)) then
  PlacePieceToStartPosition(slot_content[8]);
  RedrawCurrentPiece();
  slot_content[8] := 10;

  piece_slot_address[9] := 9;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[9] - Piece10.Left) < piece_half_size) and (abs(slot_top[9] - Piece10.Top ) < piece_half_size)) then
  begin
      current_slot := 10;

  if ((slot_content[9] <> 0) and (slot_content[9] <> 10)) then
  PlacePieceToStartPosition(slot_content[9]);
  RedrawCurrentPiece();
  slot_content[9] := 10;

  piece_slot_address[9] := 10;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[10] - Piece10.Left) < piece_half_size) and (abs(slot_top[10] - Piece10.Top ) < piece_half_size)) then
  begin
      current_slot := 11;

  if ((slot_content[10] <> 0) and (slot_content[10] <> 10)) then
  PlacePieceToStartPosition(slot_content[10]);
  RedrawCurrentPiece();
  slot_content[10] := 10;

  piece_slot_address[9] := 11;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[11] - Piece10.Left) < piece_half_size) and (abs(slot_top[11] - Piece10.Top ) < piece_half_size)) then
  begin
      current_slot := 12;

  if ((slot_content[11] <> 0) and (slot_content[11] <> 10)) then
  PlacePieceToStartPosition(slot_content[11]);
  RedrawCurrentPiece();
  slot_content[11] := 10;

  piece_slot_address[9] := 12;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[12] - Piece10.Left) < piece_half_size) and (abs(slot_top[12] - Piece10.Top ) < piece_half_size)) then
  begin
      current_slot := 13;

  if ((slot_content[12] <> 0) and (slot_content[12] <> 10)) then
  PlacePieceToStartPosition(slot_content[12]);
  RedrawCurrentPiece();
  slot_content[12] := 10;

  piece_slot_address[9] := 13;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end;
end // if(rotation_mode = false)
else if(rotation_mode = true) then
begin

current_rotation_angle := Round(mouse_rotation_angle_difference);
angle_6th_part := mouse_rotation_angle_difference / 60.0;
final_rotation_angle := Round(angle_6th_part) * 60;
piece_rotation_angle[9] := final_rotation_angle;
RotateToNearest60angleAnimationTimer.Enabled := true;

end; // else if(rotation_mode = true)

RedrawCurrentPiece();

end;





procedure TPuzzleGameForm.Piece11MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin

if((slideshow_mode = true) or (PlayerSelectComboBox.ItemIndex < 2)) then
Exit;

  MoveToNearestSlotAnimationTimer.Enabled := false;
  RotateToNearest60angleAnimationTimer.Enabled := false;
  ErrorCircleImage.Visible := false;

  current_piece := 11;
  current_slot := piece_slot_address[current_piece-1];
  clicked_X := Mouse.CursorPos.X - Piece11.Left;
  clicked_Y := Mouse.CursorPos.Y - Piece11.Top;
  Piece11.Cursor := 2;
  Piece11.BringToFront();

  PieceRotationTrackBar.OnChange := nil;
  PieceRotationTrackBar.Position := piece_rotation_angle[10];
  PieceRotationTrackBar.OnChange := @PieceRotationTrackBarChange;

  current_rotation_angle := piece_rotation_angle[10];

  distance_x := Mouse.CursorPos.X - PuzzleGameForm.Left - Piece11.Left - piece_half_size - mouseleft - 7; // cursor image size is 32x32, compensate for hotspot
  distance_y := Mouse.CursorPos.Y - PuzzleGameForm.Top - Piece11.Top - piece_half_size - mousetop - 7; // cursor image size is 32x32, compensate for hotspot
  if (piece_is_flipped[10] = true) then
  distance_x := - distance_x;

  distance_r := Round(Sqrt(distance_x*distance_x + distance_y*distance_y));

  if ( distance_r > piece_quarter_size) then
  begin
  rotation_mode := true;
  if (distance_x = 0) and (distance_y > 0) then
  mouse_rotation_angle_original := 90
  else if (distance_x = 0) and (distance_y < 0) then
  mouse_rotation_angle_original := -90
  else
  mouse_rotation_angle_original := radtodeg(ArcTan2(distance_y,distance_x));

  mouse_rotation_angle_original := mouse_rotation_angle_original - piece_rotation_angle[10];
  if(mouse_rotation_angle_original > 180) then
  mouse_rotation_angle_original := mouse_rotation_angle_original - 360;
  end// if(rotation_mode = true)
  else
  rotation_mode := false;

//    DebugLabel.Visible := true;
//    DebugLabel.Caption := IntToStr(distance_r) + ', ' + IntToStr(distance_x) + ', ' + IntToStr(distance_y) + ', ' + IntToStr(mouseleft) + ', ' + IntToStr(mousetop);
//    DebugLabel.Caption := FloatToStr(mouse_rotation_angle_original);

  RedrawAllPieces();

end;

procedure TPuzzleGameForm.Piece11MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin

  if((slideshow_mode = true) or (PlayerSelectComboBox.ItemIndex < 2)) then
  Exit;

  if ((MoveToNearestSlotAnimationTimer.Enabled = true) or (RotateToNearest60angleAnimationTimer.Enabled = true)) then
  Exit();


// https://www.freepascal.org/docs-html/rtl/classes/tshiftstate.html
// ssLeft -- Left mouse button pressed.
  if ((Shift = [ssLeft]) and not mouse_button_pressed) then
  begin
    mouse_button_pressed := true;

  end;

  if not (Shift = [ssLeft]) then
  begin
        mouse_button_pressed := false;
  end;


  if( mouse_button_pressed ) then
  begin
   if(rotation_mode = false) then
   begin
    Piece11.Top :=  Mouse.CursorPos.Y - clicked_Y;
    Piece11.Left := Mouse.CursorPos.X - clicked_X;
   end // if(rotation_mode = false)
   else if(rotation_mode = true) then
   begin

   distance_x := Mouse.CursorPos.X - PuzzleGameForm.Left - Piece11.Left - piece_half_size - mouseleft - 7; // cursor image size is 32x32, compensate for hotspot
   distance_y := Mouse.CursorPos.Y - PuzzleGameForm.Top - Piece11.Top - piece_half_size - mousetop - 7; // cursor image size is 32x32, compensate for hotspot
   if (piece_is_flipped[10] = true) then
   distance_x := - distance_x;

   distance_r := Round(Sqrt(distance_x*distance_x + distance_y*distance_y));

   if (distance_x = 0) and (distance_y > 0) then
   mouse_rotation_angle := 90
   else if (distance_x = 0) and (distance_y < 0) then
   mouse_rotation_angle := -90
   else
   mouse_rotation_angle := radtodeg(ArcTan2(distance_y,distance_x));

 //    DebugLabel.Visible := true;
 //    DebugLabel.Caption := IntToStr(distance_r) + ', ' + IntToStr(distance_x) + ', ' + IntToStr(distance_y) + ', ' + IntToStr(mouseleft) + ', ' + IntToStr(mousetop);
 //    DebugLabel.Caption := FloatToStr(mouse_rotation_angle);

  mouse_rotation_angle_difference := mouse_rotation_angle - mouse_rotation_angle_original;
   if(mouse_rotation_angle_difference > 180) then
   mouse_rotation_angle_difference := mouse_rotation_angle_difference - 360;


  current_rotation_angle := Round(mouse_rotation_angle_difference);
  RedrawCurrentPiece();
  Exit;
  end;// if(rotation_mode = true)

  end; // if( mouse_button_pressed )




end;

procedure TPuzzleGameForm.Piece11MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin

  if((slideshow_mode = true) or (PlayerSelectComboBox.ItemIndex < 2)) then
  Exit;

Piece11.Cursor := 1;

if ((MoveToNearestSlotAnimationTimer.Enabled = true) or (RotateToNearest60angleAnimationTimer.Enabled = true)) then
Exit();

if(rotation_mode = false) then
begin
  current_slot := 0;
  ClearSlot(piece_slot_address[10]);
  piece_slot_address[10] := 0;


  if ((abs(slot_left[0] - Piece11.Left) < piece_half_size) and (abs(slot_top[0] - Piece11.Top ) < piece_half_size)) then
  begin
      current_slot := 1;

  if ((slot_content[0] <> 0) and (slot_content[0] <> 11)) then
  PlacePieceToStartPosition(slot_content[0]);
  RedrawCurrentPiece();
  slot_content[0] := 11;

  piece_slot_address[10] := 1;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[1] - Piece11.Left) < piece_half_size) and (abs(slot_top[1] - Piece11.Top ) < piece_half_size)) then
  begin
      current_slot := 2;

  if ((slot_content[1] <> 0) and (slot_content[1] <> 11)) then
  PlacePieceToStartPosition(slot_content[1]);
  RedrawCurrentPiece();
  slot_content[1] := 11;

  piece_slot_address[10] := 2;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[2] - Piece11.Left) < piece_half_size) and (abs(slot_top[2] - Piece11.Top ) < piece_half_size)) then
  begin
      current_slot := 3;

  if ((slot_content[2] <> 0) and (slot_content[2] <> 11)) then
  PlacePieceToStartPosition(slot_content[2]);
  RedrawCurrentPiece();
  slot_content[2] := 11;

  piece_slot_address[10] := 3;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[3] - Piece11.Left) < piece_half_size) and (abs(slot_top[3] - Piece11.Top ) < piece_half_size)) then
  begin
      current_slot := 4;

  if ((slot_content[3] <> 0) and (slot_content[3] <> 11)) then
  PlacePieceToStartPosition(slot_content[3]);
  RedrawCurrentPiece();
  slot_content[3] := 11;

  piece_slot_address[10] := 4;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[4] - Piece11.Left) < piece_half_size) and (abs(slot_top[4] - Piece11.Top ) < piece_half_size)) then
  begin
      current_slot := 5;

  if ((slot_content[4] <> 0) and (slot_content[4] <> 11)) then
  PlacePieceToStartPosition(slot_content[4]);
  RedrawCurrentPiece();
  slot_content[4] := 11;

  piece_slot_address[10] := 5;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[5] - Piece11.Left) < piece_half_size) and (abs(slot_top[5] - Piece11.Top ) < piece_half_size)) then
  begin
      current_slot := 6;

  if ((slot_content[5] <> 0) and (slot_content[5] <> 11)) then
  PlacePieceToStartPosition(slot_content[5]);
  RedrawCurrentPiece();
  slot_content[5] := 11;

  piece_slot_address[10] := 6;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[6] - Piece11.Left) < piece_half_size) and (abs(slot_top[6] - Piece11.Top ) < piece_half_size)) then
  begin
      current_slot := 7;

  if ((slot_content[6] <> 0) and (slot_content[6] <> 11)) then
  PlacePieceToStartPosition(slot_content[6]);
  RedrawCurrentPiece();
  slot_content[6] := 11;

  piece_slot_address[10] := 7;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[7] - Piece11.Left) < piece_half_size) and (abs(slot_top[7] - Piece11.Top ) < piece_half_size)) then
  begin
      current_slot := 8;

  if ((slot_content[7] <> 0) and (slot_content[7] <> 11)) then
  PlacePieceToStartPosition(slot_content[7]);
  RedrawCurrentPiece();
  slot_content[7] := 11;

  piece_slot_address[10] := 8;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[8] - Piece11.Left) < piece_half_size) and (abs(slot_top[8] - Piece11.Top ) < piece_half_size)) then
  begin
      current_slot := 9;

  if ((slot_content[8] <> 0) and (slot_content[8] <> 11)) then
  PlacePieceToStartPosition(slot_content[8]);
  RedrawCurrentPiece();
  slot_content[8] := 11;

  piece_slot_address[10] := 9;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[9] - Piece11.Left) < piece_half_size) and (abs(slot_top[9] - Piece11.Top ) < piece_half_size)) then
  begin
      current_slot := 10;

  if ((slot_content[9] <> 0) and (slot_content[9] <> 11)) then
  PlacePieceToStartPosition(slot_content[9]);
  RedrawCurrentPiece();
  slot_content[9] := 11;

  piece_slot_address[10] := 10;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[10] - Piece11.Left) < piece_half_size) and (abs(slot_top[10] - Piece11.Top ) < piece_half_size)) then
  begin
      current_slot := 11;

  if ((slot_content[10] <> 0) and (slot_content[10] <> 11)) then
  PlacePieceToStartPosition(slot_content[10]);
  RedrawCurrentPiece();
  slot_content[10] := 11;

  piece_slot_address[10] := 11;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[11] - Piece11.Left) < piece_half_size) and (abs(slot_top[11] - Piece11.Top ) < piece_half_size)) then
  begin
      current_slot := 12;

  if ((slot_content[11] <> 0) and (slot_content[11] <> 11)) then
  PlacePieceToStartPosition(slot_content[11]);
  RedrawCurrentPiece();
  slot_content[11] := 11;

  piece_slot_address[10] := 12;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[12] - Piece11.Left) < piece_half_size) and (abs(slot_top[12] - Piece11.Top ) < piece_half_size)) then
  begin
      current_slot := 13;

  if ((slot_content[12] <> 0) and (slot_content[12] <> 11)) then
  PlacePieceToStartPosition(slot_content[12]);
  RedrawCurrentPiece();
  slot_content[12] := 11;

  piece_slot_address[10] := 13;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end;
end // if(rotation_mode = false)
else if(rotation_mode = true) then
begin

current_rotation_angle := Round(mouse_rotation_angle_difference);
angle_6th_part := mouse_rotation_angle_difference / 60.0;
final_rotation_angle := Round(angle_6th_part) * 60;
piece_rotation_angle[10] := final_rotation_angle;
RotateToNearest60angleAnimationTimer.Enabled := true;

end; // else if(rotation_mode = true)

RedrawCurrentPiece();

end;



procedure TPuzzleGameForm.Piece12MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin

if((slideshow_mode = true) or (PlayerSelectComboBox.ItemIndex < 2)) then
Exit;

  MoveToNearestSlotAnimationTimer.Enabled := false;
  RotateToNearest60angleAnimationTimer.Enabled := false;
  ErrorCircleImage.Visible := false;

  current_piece := 12;
  current_slot := piece_slot_address[current_piece-1];
  clicked_X := Mouse.CursorPos.X - Piece12.Left;
  clicked_Y := Mouse.CursorPos.Y - Piece12.Top;
  Piece12.Cursor := 2;
  Piece12.BringToFront();

  PieceRotationTrackBar.OnChange := nil;
  PieceRotationTrackBar.Position := piece_rotation_angle[11];
  PieceRotationTrackBar.OnChange := @PieceRotationTrackBarChange;

  current_rotation_angle := piece_rotation_angle[11];

  distance_x := Mouse.CursorPos.X - PuzzleGameForm.Left - Piece12.Left - piece_half_size - mouseleft - 7; // cursor image size is 32x32, compensate for hotspot
  distance_y := Mouse.CursorPos.Y - PuzzleGameForm.Top - Piece12.Top - piece_half_size - mousetop - 7; // cursor image size is 32x32, compensate for hotspot
  if (piece_is_flipped[11] = true) then
  distance_x := - distance_x;


  distance_r := Round(Sqrt(distance_x*distance_x + distance_y*distance_y));

  if ( distance_r > piece_quarter_size) then
  begin
  rotation_mode := true;
  if (distance_x = 0) and (distance_y > 0) then
  mouse_rotation_angle_original := 90
  else if (distance_x = 0) and (distance_y < 0) then
  mouse_rotation_angle_original := -90
  else
  mouse_rotation_angle_original := radtodeg(ArcTan2(distance_y,distance_x));

  mouse_rotation_angle_original := mouse_rotation_angle_original - piece_rotation_angle[11];
  if(mouse_rotation_angle_original > 180) then
  mouse_rotation_angle_original := mouse_rotation_angle_original - 360;
  end// if(rotation_mode = true)
  else
  rotation_mode := false;

//    DebugLabel.Visible := true;
//    DebugLabel.Caption := IntToStr(distance_r) + ', ' + IntToStr(distance_x) + ', ' + IntToStr(distance_y) + ', ' + IntToStr(mouseleft) + ', ' + IntToStr(mousetop);
//    DebugLabel.Caption := FloatToStr(mouse_rotation_angle_original);

  RedrawAllPieces();

end;

procedure TPuzzleGameForm.Piece12MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin

  if((slideshow_mode = true) or (PlayerSelectComboBox.ItemIndex < 2)) then
  Exit;

  if ((MoveToNearestSlotAnimationTimer.Enabled = true) or (RotateToNearest60angleAnimationTimer.Enabled = true)) then
  Exit();


// https://www.freepascal.org/docs-html/rtl/classes/tshiftstate.html
// ssLeft -- Left mouse button pressed.
  if ((Shift = [ssLeft]) and not mouse_button_pressed) then
  begin
    mouse_button_pressed := true;

  end;

  if not (Shift = [ssLeft]) then
  begin
        mouse_button_pressed := false;
  end;


  if( mouse_button_pressed ) then
  begin
   if(rotation_mode = false) then
   begin
    Piece12.Top :=  Mouse.CursorPos.Y - clicked_Y;
    Piece12.Left := Mouse.CursorPos.X - clicked_X;
   end // if(rotation_mode = false)
   else if(rotation_mode = true) then
   begin

   distance_x := Mouse.CursorPos.X - PuzzleGameForm.Left - Piece12.Left - piece_half_size - mouseleft - 7; // cursor image size is 32x32, compensate for hotspot
   distance_y := Mouse.CursorPos.Y - PuzzleGameForm.Top - Piece12.Top - piece_half_size - mousetop - 7; // cursor image size is 32x32, compensate for hotspot
   if (piece_is_flipped[11] = true) then
   distance_x := - distance_x;


   distance_r := Round(Sqrt(distance_x*distance_x + distance_y*distance_y));

   if (distance_x = 0) and (distance_y > 0) then
   mouse_rotation_angle := 90
   else if (distance_x = 0) and (distance_y < 0) then
   mouse_rotation_angle := -90
   else
   mouse_rotation_angle := radtodeg(ArcTan2(distance_y,distance_x));

 //    DebugLabel.Visible := true;
 //    DebugLabel.Caption := IntToStr(distance_r) + ', ' + IntToStr(distance_x) + ', ' + IntToStr(distance_y) + ', ' + IntToStr(mouseleft) + ', ' + IntToStr(mousetop);
 //    DebugLabel.Caption := FloatToStr(mouse_rotation_angle);

  mouse_rotation_angle_difference := mouse_rotation_angle - mouse_rotation_angle_original;
   if(mouse_rotation_angle_difference > 180) then
   mouse_rotation_angle_difference := mouse_rotation_angle_difference - 360;


  current_rotation_angle := Round(mouse_rotation_angle_difference);
  RedrawCurrentPiece();
  Exit;
  end;// if(rotation_mode = true)

  end; // if( mouse_button_pressed )




end;



procedure TPuzzleGameForm.Piece12MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin

  if((slideshow_mode = true) or (PlayerSelectComboBox.ItemIndex < 2)) then
  Exit;

Piece12.Cursor := 1;

if ((MoveToNearestSlotAnimationTimer.Enabled = true) or (RotateToNearest60angleAnimationTimer.Enabled = true)) then
Exit();

if(rotation_mode = false) then
begin
  current_slot := 0;
  ClearSlot(piece_slot_address[11]);
  piece_slot_address[11] := 0;


  if ((abs(slot_left[0] - Piece12.Left) < piece_half_size) and (abs(slot_top[0] - Piece12.Top ) < piece_half_size)) then
  begin
      current_slot := 1;

  if ((slot_content[0] <> 0) and (slot_content[0] <> 12)) then
  PlacePieceToStartPosition(slot_content[0]);
  RedrawCurrentPiece();
  slot_content[0] := 12;

  piece_slot_address[11] := 1;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[1] - Piece12.Left) < piece_half_size) and (abs(slot_top[1] - Piece12.Top ) < piece_half_size)) then
  begin
      current_slot := 2;

  if ((slot_content[1] <> 0) and (slot_content[1] <> 12)) then
  PlacePieceToStartPosition(slot_content[1]);
  RedrawCurrentPiece();
  slot_content[1] := 12;

  piece_slot_address[11] := 2;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[2] - Piece12.Left) < piece_half_size) and (abs(slot_top[2] - Piece12.Top ) < piece_half_size)) then
  begin
      current_slot := 3;

  if ((slot_content[2] <> 0) and (slot_content[2] <> 12)) then
  PlacePieceToStartPosition(slot_content[2]);
  RedrawCurrentPiece();
  slot_content[2] := 12;

  piece_slot_address[11] := 3;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[3] - Piece12.Left) < piece_half_size) and (abs(slot_top[3] - Piece12.Top ) < piece_half_size)) then
  begin
      current_slot := 4;

  if ((slot_content[3] <> 0) and (slot_content[3] <> 12)) then
  PlacePieceToStartPosition(slot_content[3]);
  RedrawCurrentPiece();
  slot_content[3] := 12;

  piece_slot_address[11] := 4;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[4] - Piece12.Left) < piece_half_size) and (abs(slot_top[4] - Piece12.Top ) < piece_half_size)) then
  begin
      current_slot := 5;

  if ((slot_content[4] <> 0) and (slot_content[4] <> 12)) then
  PlacePieceToStartPosition(slot_content[4]);
  RedrawCurrentPiece();
  slot_content[4] := 12;

  piece_slot_address[11] := 5;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[5] - Piece12.Left) < piece_half_size) and (abs(slot_top[5] - Piece12.Top ) < piece_half_size)) then
  begin
      current_slot := 6;

  if ((slot_content[5] <> 0) and (slot_content[5] <> 12)) then
  PlacePieceToStartPosition(slot_content[5]);
  RedrawCurrentPiece();
  slot_content[5] := 12;

  piece_slot_address[11] := 6;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[6] - Piece12.Left) < piece_half_size) and (abs(slot_top[6] - Piece12.Top ) < piece_half_size)) then
  begin
      current_slot := 7;

  if ((slot_content[6] <> 0) and (slot_content[6] <> 12)) then
  PlacePieceToStartPosition(slot_content[6]);
  RedrawCurrentPiece();
  slot_content[6] := 12;

  piece_slot_address[11] := 7;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[7] - Piece12.Left) < piece_half_size) and (abs(slot_top[7] - Piece12.Top ) < piece_half_size)) then
  begin
      current_slot := 8;

  if ((slot_content[7] <> 0) and (slot_content[7] <> 12)) then
  PlacePieceToStartPosition(slot_content[7]);
  RedrawCurrentPiece();
  slot_content[7] := 12;

  piece_slot_address[11] := 8;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[8] - Piece12.Left) < piece_half_size) and (abs(slot_top[8] - Piece12.Top ) < piece_half_size)) then
  begin
      current_slot := 9;

  if ((slot_content[8] <> 0) and (slot_content[8] <> 12)) then
  PlacePieceToStartPosition(slot_content[8]);
  RedrawCurrentPiece();
  slot_content[8] := 12;

  piece_slot_address[11] := 9;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[9] - Piece12.Left) < piece_half_size) and (abs(slot_top[9] - Piece12.Top ) < piece_half_size)) then
  begin
      current_slot := 10;

  if ((slot_content[9] <> 0) and (slot_content[9] <> 12)) then
  PlacePieceToStartPosition(slot_content[9]);
  RedrawCurrentPiece();
  slot_content[9] := 12;

  piece_slot_address[11] := 10;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[10] - Piece12.Left) < piece_half_size) and (abs(slot_top[10] - Piece12.Top ) < piece_half_size)) then
  begin
      current_slot := 11;

  if ((slot_content[10] <> 0) and (slot_content[10] <> 12)) then
  PlacePieceToStartPosition(slot_content[10]);
  RedrawCurrentPiece();
  slot_content[10] := 12;

  piece_slot_address[11] := 11;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[11] - Piece12.Left) < piece_half_size) and (abs(slot_top[11] - Piece12.Top ) < piece_half_size)) then
  begin
      current_slot := 12;

  if ((slot_content[11] <> 0) and (slot_content[11] <> 12)) then
  PlacePieceToStartPosition(slot_content[11]);
  RedrawCurrentPiece();
  slot_content[11] := 12;

  piece_slot_address[11] := 12;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[12] - Piece12.Left) < piece_half_size) and (abs(slot_top[12] - Piece12.Top ) < piece_half_size)) then
  begin
      current_slot := 13;

  if ((slot_content[12] <> 0) and (slot_content[12] <> 12)) then
  PlacePieceToStartPosition(slot_content[12]);
  RedrawCurrentPiece();
  slot_content[12] := 12;

  piece_slot_address[11] := 13;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end;
end // if(rotation_mode = false)
else if(rotation_mode = true) then
begin

current_rotation_angle := Round(mouse_rotation_angle_difference);
angle_6th_part := mouse_rotation_angle_difference / 60.0;
final_rotation_angle := Round(angle_6th_part) * 60;
piece_rotation_angle[11] := final_rotation_angle;
RotateToNearest60angleAnimationTimer.Enabled := true;

end; // else if(rotation_mode = true)

RedrawCurrentPiece();

end;




procedure TPuzzleGameForm.Piece13MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin

if((slideshow_mode = true) or (PlayerSelectComboBox.ItemIndex < 2)) then
Exit;

  MoveToNearestSlotAnimationTimer.Enabled := false;
  RotateToNearest60angleAnimationTimer.Enabled := false;
  ErrorCircleImage.Visible := false;

  current_piece := 13;
  current_slot := piece_slot_address[current_piece-1];
  clicked_X := Mouse.CursorPos.X - Piece13.Left;
  clicked_Y := Mouse.CursorPos.Y - Piece13.Top;
  Piece13.Cursor := 2;
  Piece13.BringToFront();

  PieceRotationTrackBar.OnChange := nil;
  PieceRotationTrackBar.Position := piece_rotation_angle[12];
  PieceRotationTrackBar.OnChange := @PieceRotationTrackBarChange;

  current_rotation_angle := piece_rotation_angle[12];

  distance_x := Mouse.CursorPos.X - PuzzleGameForm.Left - Piece13.Left - piece_half_size - mouseleft - 7; // cursor image size is 32x32, compensate for hotspot
  distance_y := Mouse.CursorPos.Y - PuzzleGameForm.Top - Piece13.Top - piece_half_size - mousetop - 7; // cursor image size is 32x32, compensate for hotspot
  if (piece_is_flipped[12] = true) then
  distance_x := - distance_x;

  distance_r := Round(Sqrt(distance_x*distance_x + distance_y*distance_y));

  if ( distance_r > piece_quarter_size) then
  begin
  rotation_mode := true;
  if (distance_x = 0) and (distance_y > 0) then
  mouse_rotation_angle_original := 90
  else if (distance_x = 0) and (distance_y < 0) then
  mouse_rotation_angle_original := -90
  else
  mouse_rotation_angle_original := radtodeg(ArcTan2(distance_y,distance_x));

  mouse_rotation_angle_original := mouse_rotation_angle_original - piece_rotation_angle[12];
  if(mouse_rotation_angle_original > 180) then
  mouse_rotation_angle_original := mouse_rotation_angle_original - 360;
  end// if(rotation_mode = true)
  else
  rotation_mode := false;

//    DebugLabel.Visible := true;
//    DebugLabel.Caption := IntToStr(distance_r) + ', ' + IntToStr(distance_x) + ', ' + IntToStr(distance_y) + ', ' + IntToStr(mouseleft) + ', ' + IntToStr(mousetop);
//    DebugLabel.Caption := FloatToStr(mouse_rotation_angle_original);

  RedrawAllPieces();

end;

procedure TPuzzleGameForm.Piece13MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin

  if((slideshow_mode = true) or (PlayerSelectComboBox.ItemIndex < 2)) then
  Exit;

  if ((MoveToNearestSlotAnimationTimer.Enabled = true) or (RotateToNearest60angleAnimationTimer.Enabled = true)) then
  Exit();


// https://www.freepascal.org/docs-html/rtl/classes/tshiftstate.html
// ssLeft -- Left mouse button pressed.
  if ((Shift = [ssLeft]) and not mouse_button_pressed) then
  begin
    mouse_button_pressed := true;

  end;

  if not (Shift = [ssLeft]) then
  begin
        mouse_button_pressed := false;
  end;


  if( mouse_button_pressed ) then
  begin
   if(rotation_mode = false) then
   begin
    Piece13.Top :=  Mouse.CursorPos.Y - clicked_Y;
    Piece13.Left := Mouse.CursorPos.X - clicked_X;
   end // if(rotation_mode = false)
   else if(rotation_mode = true) then
   begin

   distance_x := Mouse.CursorPos.X - PuzzleGameForm.Left - Piece13.Left - piece_half_size - mouseleft - 7; // cursor image size is 32x32, compensate for hotspot
   distance_y := Mouse.CursorPos.Y - PuzzleGameForm.Top - Piece13.Top - piece_half_size - mousetop - 7; // cursor image size is 32x32, compensate for hotspot
   if (piece_is_flipped[12] = true) then
   distance_x := - distance_x;

   distance_r := Round(Sqrt(distance_x*distance_x + distance_y*distance_y));

   if (distance_x = 0) and (distance_y > 0) then
   mouse_rotation_angle := 90
   else if (distance_x = 0) and (distance_y < 0) then
   mouse_rotation_angle := -90
   else
   mouse_rotation_angle := radtodeg(ArcTan2(distance_y,distance_x));

 //    DebugLabel.Visible := true;
 //    DebugLabel.Caption := IntToStr(distance_r) + ', ' + IntToStr(distance_x) + ', ' + IntToStr(distance_y) + ', ' + IntToStr(mouseleft) + ', ' + IntToStr(mousetop);
 //    DebugLabel.Caption := FloatToStr(mouse_rotation_angle);

  mouse_rotation_angle_difference := mouse_rotation_angle - mouse_rotation_angle_original;
   if(mouse_rotation_angle_difference > 180) then
   mouse_rotation_angle_difference := mouse_rotation_angle_difference - 360;


  current_rotation_angle := Round(mouse_rotation_angle_difference);
  RedrawCurrentPiece();
  Exit;
  end;// if(rotation_mode = true)

  end; // if( mouse_button_pressed )





end;

procedure TPuzzleGameForm.Piece13MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin

  if((slideshow_mode = true) or (PlayerSelectComboBox.ItemIndex < 2)) then
  Exit;

Piece13.Cursor := 1;

if ((MoveToNearestSlotAnimationTimer.Enabled = true) or (RotateToNearest60angleAnimationTimer.Enabled = true)) then
Exit();

if(rotation_mode = false) then
begin
  current_slot := 0;
  ClearSlot(piece_slot_address[12]);
  piece_slot_address[12] := 0;


  if ((abs(slot_left[0] - Piece13.Left) < piece_half_size) and (abs(slot_top[0] - Piece13.Top ) < piece_half_size)) then
  begin
      current_slot := 1;

  if ((slot_content[0] <> 0) and (slot_content[0] <> 13)) then
  PlacePieceToStartPosition(slot_content[0]);
  RedrawCurrentPiece();
  slot_content[0] := 13;

  piece_slot_address[12] := 1;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[1] - Piece13.Left) < piece_half_size) and (abs(slot_top[1] - Piece13.Top ) < piece_half_size)) then
  begin
      current_slot := 2;

  if ((slot_content[1] <> 0) and (slot_content[1] <> 13)) then
  PlacePieceToStartPosition(slot_content[1]);
  RedrawCurrentPiece();
  slot_content[1] := 13;

  piece_slot_address[12] := 2;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[2] - Piece13.Left) < piece_half_size) and (abs(slot_top[2] - Piece13.Top ) < piece_half_size)) then
  begin
      current_slot := 3;

  if ((slot_content[2] <> 0) and (slot_content[2] <> 13)) then
  PlacePieceToStartPosition(slot_content[2]);
  RedrawCurrentPiece();
  slot_content[2] := 13;

  piece_slot_address[12] := 3;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[3] - Piece13.Left) < piece_half_size) and (abs(slot_top[3] - Piece13.Top ) < piece_half_size)) then
  begin
      current_slot := 4;

  if ((slot_content[3] <> 0) and (slot_content[3] <> 13)) then
  PlacePieceToStartPosition(slot_content[3]);
  RedrawCurrentPiece();
  slot_content[3] := 13;

  piece_slot_address[12] := 4;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[4] - Piece13.Left) < piece_half_size) and (abs(slot_top[4] - Piece13.Top ) < piece_half_size)) then
  begin
      current_slot := 5;

  if ((slot_content[4] <> 0) and (slot_content[4] <> 13)) then
  PlacePieceToStartPosition(slot_content[4]);
  RedrawCurrentPiece();
  slot_content[4] := 13;

  piece_slot_address[12] := 5;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[5] - Piece13.Left) < piece_half_size) and (abs(slot_top[5] - Piece13.Top ) < piece_half_size)) then
  begin
      current_slot := 6;

  if ((slot_content[5] <> 0) and (slot_content[5] <> 13)) then
  PlacePieceToStartPosition(slot_content[5]);
  RedrawCurrentPiece();
  slot_content[5] := 13;

  piece_slot_address[12] := 6;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[6] - Piece13.Left) < piece_half_size) and (abs(slot_top[6] - Piece13.Top ) < piece_half_size)) then
  begin
      current_slot := 7;

  if ((slot_content[6] <> 0) and (slot_content[6] <> 13)) then
  PlacePieceToStartPosition(slot_content[6]);
  RedrawCurrentPiece();
  slot_content[6] := 13;

  piece_slot_address[12] := 7;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[7] - Piece13.Left) < piece_half_size) and (abs(slot_top[7] - Piece13.Top ) < piece_half_size)) then
  begin
      current_slot := 8;

  if ((slot_content[7] <> 0) and (slot_content[7] <> 13)) then
  PlacePieceToStartPosition(slot_content[7]);
  RedrawCurrentPiece();
  slot_content[7] := 13;

  piece_slot_address[12] := 8;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[8] - Piece13.Left) < piece_half_size) and (abs(slot_top[8] - Piece13.Top ) < piece_half_size)) then
  begin
      current_slot := 9;

  if ((slot_content[8] <> 0) and (slot_content[8] <> 13)) then
  PlacePieceToStartPosition(slot_content[8]);
  RedrawCurrentPiece();
  slot_content[8] := 13;

  piece_slot_address[12] := 9;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[9] - Piece13.Left) < piece_half_size) and (abs(slot_top[9] - Piece13.Top ) < piece_half_size)) then
  begin
      current_slot := 10;

  if ((slot_content[9] <> 0) and (slot_content[9] <> 13)) then
  PlacePieceToStartPosition(slot_content[9]);
  RedrawCurrentPiece();
  slot_content[9] := 13;

  piece_slot_address[12] := 10;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[10] - Piece13.Left) < piece_half_size) and (abs(slot_top[10] - Piece13.Top ) < piece_half_size)) then
  begin
      current_slot := 11;

  if ((slot_content[10] <> 0) and (slot_content[10] <> 13)) then
  PlacePieceToStartPosition(slot_content[10]);
  RedrawCurrentPiece();
  slot_content[10] := 13;

  piece_slot_address[12] := 11;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[11] - Piece13.Left) < piece_half_size) and (abs(slot_top[11] - Piece13.Top ) < piece_half_size)) then
  begin
      current_slot := 12;

  if ((slot_content[11] <> 0) and (slot_content[11] <> 13)) then
  PlacePieceToStartPosition(slot_content[11]);
  RedrawCurrentPiece();
  slot_content[11] := 13;

  piece_slot_address[12] := 12;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end
  else if ((abs(slot_left[12] - Piece13.Left) < piece_half_size) and (abs(slot_top[12] - Piece13.Top ) < piece_half_size)) then
  begin
      current_slot := 13;

  if ((slot_content[12] <> 0) and (slot_content[12] <> 13)) then
  PlacePieceToStartPosition(slot_content[12]);
  RedrawCurrentPiece();
  slot_content[12] := 13;

  piece_slot_address[12] := 13;
  MoveToNearestSlotAnimationTimer.Enabled := true;
  end;
end // if(rotation_mode = false)
else if(rotation_mode = true) then
begin

current_rotation_angle := Round(mouse_rotation_angle_difference);
angle_6th_part := mouse_rotation_angle_difference / 60.0;
final_rotation_angle := Round(angle_6th_part) * 60;
piece_rotation_angle[12] := final_rotation_angle;
RotateToNearest60angleAnimationTimer.Enabled := true;

end; // else if(rotation_mode = true)

RedrawCurrentPiece();


end;



procedure TPuzzleGameForm.FormShow(Sender: TObject);
begin

mousetop := 0;
mouseleft := 0;

//{$IF not Defined (DARWIN)}
{$IF Defined (WINDOWS)}
PuzzleGameForm.WindowState:= wsMaximized;

Application.ProcessMessages();

// https://forum.lazarus.freepascal.org/index.php?topic=7020.0
// Calibrate the mouse
// Finds title bar height and border size descrepecies
// From using different os's or windows themes
// MouseInput.Move([], self, x,y, speed);

// The trick here is the form needs to be docked at the top of the screen or maximized,
// then the title bar height can be measured by the mouse position.
// Once that's done put the form in whatever mode you want you've got the title bar height until you change themes etc.

  MouseInput.Move([], self, 0, 0, 0);

  // This gives the true position of the mouse with respect to the form.
  // Form now on I have a calibrated mouse until a screen resize or something
  mousetop := mouse.CursorPos.y;  //this is the title bars height if form is maximized
  mouseleft := mouse.CursorPos.x;

  PuzzleGameForm.WindowState:= wsNormal;
{$ENDIF}

  Left := (Screen.Width - Width) div 2;
  Top := (Screen.Height - Height) div 2;





end;


procedure TPuzzleGameForm.PlayerSelectComboBoxChange(Sender: TObject);
begin


if(PlayerSelectComboBox.ItemIndex = 0) then
begin
FlipButton.Visible := false;
NewGameButton.Visible := false;
ShowSavedSolutionsButton.Visible := false;
PlayerNameEdit.Text := '';
PlayerNameEdit.Visible := true;
AddDeletePlayerButton.Caption := 'Add player';
AddDeletePlayerButton.Visible := true;
end
else if(PlayerSelectComboBox.ItemIndex = 1) then
begin
FlipButton.Visible := false;
NewGameButton.Visible := false;
ShowSavedSolutionsButton.Visible := false;
PlayerNameEdit.Text := '';
PlayerNameEdit.Visible := true;
AddDeletePlayerButton.Caption := 'Delete player';
AddDeletePlayerButton.Visible := true;
end
else
begin
FlipButton.Visible := true;
NewGameButton.Visible := true;
ShowSavedSolutionsButton.Visible := true;
PlayerNameEdit.Visible := false;
AddDeletePlayerButton.Visible := false;
player_names_memo.Lines[0] := IntToStr(PlayerSelectComboBox.ItemIndex - 2);
player_names_memo.Lines.SaveToFile(player_names_full_filename);
//-------------------------------
if ((PlayerSelectComboBox.ItemIndex - 2) > 0) then
begin
puzzle_solutions_filename := player_names_memo.Lines[PlayerSelectComboBox.ItemIndex - 2] + '.txt';
puzzle_solutions_full_filename := puzzle_solutions_filepath + puzzle_solutions_filename;
end
else
begin
puzzle_solutions_filename := 'Player.txt';
puzzle_solutions_full_filename := puzzle_solutions_filepath + puzzle_solutions_filename;
end;

//ShowMessage(puzzle_solutions_filename);

if(not FileExists(puzzle_solutions_full_filename)) then
MessageDlgEx(PCHAR('Error: file not found:' + LineEnding + puzzle_solutions_full_filename), mtError, [mbOk], PuzzleGameForm)
//-------------------------------

end;


end;





procedure TPuzzleGameForm.ConvertPieceSlotPositionIntoSlotContent(piece_slot_position: Integer; piece_number: Integer);
begin


if (piece_slot_position = 1) then
slot_content[0] := piece_number
else if (piece_slot_position = 2) then
slot_content[1] := piece_number
else if (piece_slot_position = 3) then
slot_content[2] := piece_number
else if (piece_slot_position = 4) then
slot_content[3] := piece_number
else if (piece_slot_position = 5) then
slot_content[4] := piece_number
else if (piece_slot_position = 6) then
slot_content[5] := piece_number
else if (piece_slot_position = 7) then
slot_content[6] := piece_number
else if (piece_slot_position = 8) then
slot_content[7] := piece_number
else if (piece_slot_position = 9) then
slot_content[8] := piece_number
else if (piece_slot_position = 10) then
slot_content[9] := piece_number
else if (piece_slot_position = 11) then
slot_content[10] := piece_number
else if (piece_slot_position = 12) then
slot_content[11] := piece_number
else if (piece_slot_position = 13) then
slot_content[12] := piece_number;


end;

procedure TPuzzleGameForm.LoadPiecesIntoBoard();
var
 n: Integer;
begin

 ClearBoard();

 if (saved_puzzle_stringlist.Count > 0) then
 piece_slot_address[0] := StrToIntDef(saved_puzzle_stringlist.Strings[0], 0)
 else
 piece_slot_address[0] := 0;

 if(piece_slot_address[0] > 0) and (piece_slot_address[0] < 14) then
 begin
 Piece01.Left := slot_left[piece_slot_address[0]-1];
 Piece01.Top := slot_top[piece_slot_address[0]-1];
 ConvertPieceSlotPositionIntoSlotContent(piece_slot_address[0], 1);
 end
 else
 PlacePieceToStartPosition(1);


 if (saved_puzzle_stringlist.Count > 1) then
 piece_slot_address[1] := StrToIntDef(saved_puzzle_stringlist.Strings[1], 0)
 else
 piece_slot_address[1] := 0;

 if(piece_slot_address[1] > 0) and (piece_slot_address[1] < 14) then
 begin
 Piece02.Left := slot_left[piece_slot_address[1]-1];
 Piece02.Top := slot_top[piece_slot_address[1]-1];
 ConvertPieceSlotPositionIntoSlotContent(piece_slot_address[1], 2);
 end
 else
 PlacePieceToStartPosition(2);


 if (saved_puzzle_stringlist.Count > 2) then
 piece_slot_address[2] := StrToIntDef(saved_puzzle_stringlist.Strings[2], 0)
 else
 piece_slot_address[2] := 0;

 if(piece_slot_address[2] > 0) and (piece_slot_address[2] < 14) then
 begin
 Piece03.Left := slot_left[piece_slot_address[2]-1];
 Piece03.Top := slot_top[piece_slot_address[2]-1];
 ConvertPieceSlotPositionIntoSlotContent(piece_slot_address[2], 3);
 end
 else
 PlacePieceToStartPosition(3);


 if (saved_puzzle_stringlist.Count > 3) then
 piece_slot_address[3] := StrToIntDef(saved_puzzle_stringlist.Strings[3], 0)
 else
 piece_slot_address[3] := 0;

 if(piece_slot_address[3] > 0) and (piece_slot_address[3] < 14) then
 begin
 Piece04.Left := slot_left[piece_slot_address[3]-1];
 Piece04.Top := slot_top[piece_slot_address[3]-1];
 ConvertPieceSlotPositionIntoSlotContent(piece_slot_address[3], 4);
 end
 else
 PlacePieceToStartPosition(4);


 if (saved_puzzle_stringlist.Count > 4) then
 piece_slot_address[4] := StrToIntDef(saved_puzzle_stringlist.Strings[4], 0)
 else
 piece_slot_address[4] := 0;

 if(piece_slot_address[4] > 0) and (piece_slot_address[4] < 14) then
 begin
 Piece05.Left := slot_left[piece_slot_address[4]-1];
 Piece05.Top := slot_top[piece_slot_address[4]-1];
 ConvertPieceSlotPositionIntoSlotContent(piece_slot_address[4], 5);
 end
 else
 PlacePieceToStartPosition(5);


 if (saved_puzzle_stringlist.Count > 5) then
 piece_slot_address[5] := StrToIntDef(saved_puzzle_stringlist.Strings[5], 0)
 else
 piece_slot_address[5] := 0;

 if(piece_slot_address[5] > 0) and (piece_slot_address[5] < 14) then
 begin
 Piece06.Left := slot_left[piece_slot_address[5]-1];
 Piece06.Top := slot_top[piece_slot_address[5]-1];
 ConvertPieceSlotPositionIntoSlotContent(piece_slot_address[5], 6);
 end
 else
 PlacePieceToStartPosition(6);


 if (saved_puzzle_stringlist.Count > 6) then
 piece_slot_address[6] := StrToIntDef(saved_puzzle_stringlist.Strings[6], 0)
 else
 piece_slot_address[6] := 0;

 if(piece_slot_address[6] > 0) and (piece_slot_address[6] < 14) then
 begin
 Piece07.Left := slot_left[piece_slot_address[6]-1];
 Piece07.Top := slot_top[piece_slot_address[6]-1];
 ConvertPieceSlotPositionIntoSlotContent(piece_slot_address[6], 7);
 end
 else
 PlacePieceToStartPosition(7);


 if (saved_puzzle_stringlist.Count > 7) then
 piece_slot_address[7] := StrToIntDef(saved_puzzle_stringlist.Strings[7], 0)
 else
 piece_slot_address[7] := 0;

 if(piece_slot_address[7] > 0) and (piece_slot_address[7] < 14) then
 begin
 Piece08.Left := slot_left[piece_slot_address[7]-1];
 Piece08.Top := slot_top[piece_slot_address[7]-1];
 ConvertPieceSlotPositionIntoSlotContent(piece_slot_address[7], 8);
 end
 else
 PlacePieceToStartPosition(8);


 if (saved_puzzle_stringlist.Count > 8) then
 piece_slot_address[8] := StrToIntDef(saved_puzzle_stringlist.Strings[8], 0)
 else
 piece_slot_address[8] := 0;

 if(piece_slot_address[8] > 0) and (piece_slot_address[8] < 14) then
 begin
 Piece09.Left := slot_left[piece_slot_address[8]-1];
 Piece09.Top := slot_top[piece_slot_address[8]-1];
 ConvertPieceSlotPositionIntoSlotContent(piece_slot_address[8], 9);
 end
 else
 PlacePieceToStartPosition(9);


 if (saved_puzzle_stringlist.Count > 9) then
 piece_slot_address[9] := StrToIntDef(saved_puzzle_stringlist.Strings[9], 0)
 else
 piece_slot_address[9] := 0;

 if(piece_slot_address[9] > 0) and (piece_slot_address[9] < 14) then
 begin
 Piece10.Left := slot_left[piece_slot_address[9]-1];
 Piece10.Top := slot_top[piece_slot_address[9]-1];
 ConvertPieceSlotPositionIntoSlotContent(piece_slot_address[9], 10);
 end
 else
 PlacePieceToStartPosition(10);


 if (saved_puzzle_stringlist.Count > 10) then
 piece_slot_address[10] := StrToIntDef(saved_puzzle_stringlist.Strings[10], 0)
 else
 piece_slot_address[10] := 0;

 if(piece_slot_address[10] > 0) and (piece_slot_address[10] < 14) then
 begin
 Piece11.Left := slot_left[piece_slot_address[10]-1];
 Piece11.Top := slot_top[piece_slot_address[10]-1];
 ConvertPieceSlotPositionIntoSlotContent(piece_slot_address[10], 11);
 end
 else
 PlacePieceToStartPosition(11);


 if (saved_puzzle_stringlist.Count > 11) then
 piece_slot_address[11] := StrToIntDef(saved_puzzle_stringlist.Strings[11], 0)
 else
 piece_slot_address[11] := 0;

 if(piece_slot_address[11] > 0) and (piece_slot_address[11] < 14) then
 begin
 Piece12.Left := slot_left[piece_slot_address[11]-1];
 Piece12.Top := slot_top[piece_slot_address[11]-1];
 ConvertPieceSlotPositionIntoSlotContent(piece_slot_address[11], 12);
 end
 else
 PlacePieceToStartPosition(12);


 if (saved_puzzle_stringlist.Count > 12) then
 piece_slot_address[12] := StrToIntDef(saved_puzzle_stringlist.Strings[12], 0)
 else
 piece_slot_address[12] := 0;

 if(piece_slot_address[12] > 0) and (piece_slot_address[12] < 14) then
 begin
 Piece13.Left := slot_left[piece_slot_address[12]-1];
 Piece13.Top := slot_top[piece_slot_address[12]-1];
 ConvertPieceSlotPositionIntoSlotContent(piece_slot_address[12], 13);
 end
 else
 PlacePieceToStartPosition(13);



 if (saved_puzzle_stringlist.Count > 13) then
 piece_rotation_angle[0] := StrToIntDef(saved_puzzle_stringlist.Strings[13], 0)
 else
 piece_rotation_angle[0] := 0;

 if (saved_puzzle_stringlist.Count > 14) then
 piece_rotation_angle[1] := StrToIntDef(saved_puzzle_stringlist.Strings[14], 0)
 else
 piece_rotation_angle[1] := 0;

 if (saved_puzzle_stringlist.Count > 15) then
 piece_rotation_angle[2] := StrToIntDef(saved_puzzle_stringlist.Strings[15], 0)
 else
 piece_rotation_angle[2] := 0;

 if (saved_puzzle_stringlist.Count > 16) then
 piece_rotation_angle[3] := StrToIntDef(saved_puzzle_stringlist.Strings[16], 0)
 else
 piece_rotation_angle[3] := 0;

 if (saved_puzzle_stringlist.Count > 17) then
 piece_rotation_angle[4] := StrToIntDef(saved_puzzle_stringlist.Strings[17], 0)
 else
 piece_rotation_angle[4] := 0;

 if (saved_puzzle_stringlist.Count > 18) then
 piece_rotation_angle[5] := StrToIntDef(saved_puzzle_stringlist.Strings[18], 0)
 else
 piece_rotation_angle[5] := 0;

 if (saved_puzzle_stringlist.Count > 19) then
 piece_rotation_angle[6] := StrToIntDef(saved_puzzle_stringlist.Strings[19], 0)
 else
 piece_rotation_angle[6] := 0;

 if (saved_puzzle_stringlist.Count > 20) then
 piece_rotation_angle[7] := StrToIntDef(saved_puzzle_stringlist.Strings[20], 0)
 else
 piece_rotation_angle[7] := 0;

 if (saved_puzzle_stringlist.Count > 21) then
 piece_rotation_angle[8] := StrToIntDef(saved_puzzle_stringlist.Strings[21], 0)
 else
 piece_rotation_angle[8] := 0;

 if (saved_puzzle_stringlist.Count > 22) then
 piece_rotation_angle[9] := StrToIntDef(saved_puzzle_stringlist.Strings[22], 0)
 else
 piece_rotation_angle[9] := 0;

 if (saved_puzzle_stringlist.Count > 23) then
 piece_rotation_angle[10] := StrToIntDef(saved_puzzle_stringlist.Strings[23], 0)
 else
 piece_rotation_angle[10] := 0;

 if (saved_puzzle_stringlist.Count > 24) then
 piece_rotation_angle[11] := StrToIntDef(saved_puzzle_stringlist.Strings[24], 0)
 else
 piece_rotation_angle[11] := 0;

 if (saved_puzzle_stringlist.Count > 25) then
 piece_rotation_angle[12] := StrToIntDef(saved_puzzle_stringlist.Strings[25], 0)
 else
 piece_rotation_angle[12] := 0;



 if (saved_puzzle_stringlist.Count > 26) then
 piece_is_flipped[0] := StrToBoolDef(saved_puzzle_stringlist.Strings[26], false)
 else
 piece_is_flipped[0] := false;

 if (saved_puzzle_stringlist.Count > 27) then
 piece_is_flipped[1] := StrToBoolDef(saved_puzzle_stringlist.Strings[27], false)
 else
 piece_is_flipped[1] := false;

 if (saved_puzzle_stringlist.Count > 28) then
 piece_is_flipped[2] := StrToBoolDef(saved_puzzle_stringlist.Strings[28], false)
 else
 piece_is_flipped[2] := false;

 if (saved_puzzle_stringlist.Count > 29) then
 piece_is_flipped[3] := StrToBoolDef(saved_puzzle_stringlist.Strings[29], false)
 else
 piece_is_flipped[3] := false;

 if (saved_puzzle_stringlist.Count > 30) then
 piece_is_flipped[4] := StrToBoolDef(saved_puzzle_stringlist.Strings[30], false)
 else
 piece_is_flipped[4] := false;

 if (saved_puzzle_stringlist.Count > 31) then
 piece_is_flipped[5] := StrToBoolDef(saved_puzzle_stringlist.Strings[31], false)
 else
 piece_is_flipped[5] := false;

 if (saved_puzzle_stringlist.Count > 32) then
 piece_is_flipped[6] := StrToBoolDef(saved_puzzle_stringlist.Strings[32], false)
 else
 piece_is_flipped[6] := false;

 if (saved_puzzle_stringlist.Count > 33) then
 piece_is_flipped[7] := StrToBoolDef(saved_puzzle_stringlist.Strings[33], false)
 else
 piece_is_flipped[7] := false;

 if (saved_puzzle_stringlist.Count > 34) then
 piece_is_flipped[8] := StrToBoolDef(saved_puzzle_stringlist.Strings[34], false)
 else
 piece_is_flipped[8] := false;

 if (saved_puzzle_stringlist.Count > 35) then
 piece_is_flipped[9] := StrToBoolDef(saved_puzzle_stringlist.Strings[35], false)
 else
 piece_is_flipped[9] := false;

 if (saved_puzzle_stringlist.Count > 36) then
 piece_is_flipped[10] := StrToBoolDef(saved_puzzle_stringlist.Strings[36], false)
 else
 piece_is_flipped[10] := false;

 if (saved_puzzle_stringlist.Count > 37) then
 piece_is_flipped[11] := StrToBoolDef(saved_puzzle_stringlist.Strings[37], false)
 else
 piece_is_flipped[11] := false;

 if (saved_puzzle_stringlist.Count > 38) then
 piece_is_flipped[12] := StrToBoolDef(saved_puzzle_stringlist.Strings[38], false)
 else
 piece_is_flipped[12] := false;



 if (saved_puzzle_stringlist.Count > 39) then
 date_and_time_string := saved_puzzle_stringlist.Strings[39]
 else
 date_and_time_string := 'date unknown';


 ErrorCircleImage.Visible := false;
 for n := 1 to 13 do
 PlacePieceIntoBoardToFindCollisions(n, piece_slot_address[n-1]);




end;

procedure TPuzzleGameForm.LoadNextSolution(slideshow_direction: Integer);
begin


if (not FileExists(puzzle_solutions_full_filename)) then
begin
ShowSolutionsTimer.Enabled := false;
ShowSavedSolutionsButton.Caption := 'Show saved solutions';
ShowMessage('Error: puzzle saved solutions file not found.' + LineEnding + puzzle_solutions_full_filename);
Exit;
end;


saved_puzzle_memo.Clear;
saved_puzzle_memo.Lines.LoadFromFile(puzzle_solutions_full_filename);

if(saved_puzzle_memo.Lines.Count = 0) then
begin
ShowSavedSolutionsButtonClick(PuzzleGameForm);
Exit;
end;


if(slideshow_direction = 1) then
begin
  inc(saved_puzzle_number);
  if(saved_puzzle_number >= saved_puzzle_memo.Lines.Count) then
  saved_puzzle_number := 0;
end
else if(slideshow_direction = -1) then
begin
  dec(saved_puzzle_number);
  if(saved_puzzle_number < 0) then
  saved_puzzle_number := saved_puzzle_memo.Lines.Count-1;
end;


saved_puzzle_stringlist := TStringList.Create;
try
// https://www.freepascal.org/docs-html/rtl/classes/tstrings.delimitedtext.html
// DelimitedText returns all strings, properly quoted with QuoteChar and separated by the Delimiter character.
// Strings are quoted if they contain a space or any character with ASCII value less than 32.
// The CommaText property is a special case of delimited text where the delimiter character is a comma and the quote character is a double quote.
// If StrictDelimiter is set to True, then no quoting is done (The QuoteChar property is disregarded completely): the returned text will contain the items in the stringlist, separated by the Delimiter character. When writing the DelimitedText property, the text will be split at all occurrences of the Delimiter character; however, when reading, the QuoteChar property will be taken into account.

  saved_puzzle_stringlist.Delimiter := ';';
  // saved_puzzle_stringlist.StrictDelimiter := True;
  saved_puzzle_stringlist.DelimitedText := saved_puzzle_memo.Lines[saved_puzzle_number];

  LoadPiecesIntoBoard();

finally
  saved_puzzle_stringlist.Free;
end;



OutputLabel.Caption := IntToStr(saved_puzzle_number + 1) + ' from ' + IntToStr(saved_puzzle_memo.Lines.Count) + ' (total 1641 variants of solution exists)';

DateLabel.Caption := date_and_time_string;






RedrawCurrentPiece();



end;

procedure TPuzzleGameForm.ShowSavedSolutionsButtonClick(Sender: TObject);
begin



current_piece := 0;
OutputLabel.Background.Color := TColor($566a85); // <<<-----  R and B colors are inverted RGB becomes BRG
DateLabel.Background.Color := TColor($566a85); // <<<-----  R and B colors are inverted RGB becomes BRG


if (slideshow_mode = false) then
begin

  if(PlayerSelectComboBox.ItemIndex - 2 = 0) then
  OutputLabel.Caption := 'Player’s solutions'
  else if(PlayerSelectComboBox.ItemIndex - 2 > 0) then
  OutputLabel.Caption := player_names_memo.Lines[PlayerSelectComboBox.ItemIndex - 2] + '’s solutions'
  else
  Exit;

DebugLabel.Caption := '';
ErrorCircleImage.Visible := false;
current_piece := 0;
StartNewGame();
//OutputLabel.Caption := '';
OutputImage.BringToFront();
OutputLabel.BringToFront();
DateLabel.Caption := '';
PlayerSelectComboBox.Visible := false;
FlipButton.Visible := false;
NewGameButton.Visible := false;
ShowSavedSolutionsButton.Caption := 'Stop slideshow';

if(CompareStr( player_names_memo.Lines[PlayerSelectComboBox.ItemIndex - 2], 'Virginija') = 0) then
OutputImage.Visible := true;

OutputLabel.Visible := true;
DateLabel.Visible := false;
//SaveButton.Enabled := true;
Application.ProcessMessages;
Sleep(3000);
end;


saved_puzzle_number := -1;

slideshow_mode := not slideshow_mode;


if (slideshow_mode = false) then
begin
ShowSolutionsTimer.Enabled := false;
PlayerSelectComboBox.Visible := true;
FlipButton.Visible := true;
NewGameButton.Visible := true;
ShowSavedSolutionsButton.Caption := 'Show saved solutions';
OutputImage.Visible := false;
OutputLabel.Visible := false;
DateLabel.Visible := false;
end
else
begin
//-------------------------------
if ((PlayerSelectComboBox.ItemIndex - 2) > 0) then
begin
puzzle_solutions_filename := player_names_memo.Lines[PlayerSelectComboBox.ItemIndex - 2] + '.txt';
puzzle_solutions_full_filename := puzzle_solutions_filepath + puzzle_solutions_filename;
end
else
begin
puzzle_solutions_filename := 'Player.txt';
puzzle_solutions_full_filename := puzzle_solutions_filepath + puzzle_solutions_filename;
end;

//ShowMessage(puzzle_solutions_filename);

if(not FileExists(puzzle_solutions_full_filename)) then
MessageDlgEx(PCHAR('Error: file not found:' + LineEnding + puzzle_solutions_full_filename), mtError, [mbOk], PuzzleGameForm);
//-------------------------------

ShowSolutionsTimer.Enabled := true;
PlayerSelectComboBox.Visible := false;
FlipButton.Visible := false;
NewGameButton.Visible := false;
ShowSavedSolutionsButton.Caption := 'Stop slideshow';

  if(CompareStr( player_names_memo.Lines[PlayerSelectComboBox.ItemIndex - 2], 'Virginija') = 0) then
  OutputImage.Visible := true;

OutputLabel.Visible := true;
DateLabel.Visible := true;
//DateLabel.Visible := false;
//SaveButton.Enabled := true;
end;






end;

procedure TPuzzleGameForm.NewGameButtonClick(Sender: TObject);
begin

DebugLabel.Caption := '';
ErrorCircleImage.Visible := false;


if (ShowSolutionsTimer.Enabled = true) then
//ShowSavedSolutionsButton.Click();
ShowSavedSolutionsButtonClick(Sender);

current_piece := 0;
StartNewGame();
//RedrawCurrentPiece();

end;


procedure TPuzzleGameForm.BoardRedraw(Sender: TObject; Bitmap: TBGRABitmap);
var
 startangle, endangle: Double;
begin

//https://forum.lazarus.freepascal.org/index.php?topic=45210.0
Bitmap.FillTransparent;
//Bitmap.PutImage(0, 0, board_image, dmDrawWithTransparency); // OnRedraw event
//Bitmap.Rectangle(10, 10, 100, 100, BGRABlack, BGRAPixelTransparent, dmDrawWithTransparency);
//Bitmap.EllipseAntialias(100, 100, 50, 50, BGRABlack, 1, BGRAPixelTransparent);


Bitmap.EllipseAntialias(slot_x_center[0], slot_y_center[0], piece_quarter_size, piece_quarter_size, BGRABlack, 1, BGRAPixelTransparent);
Bitmap.EllipseAntialias(slot_x_center[1], slot_y_center[1], piece_quarter_size, piece_quarter_size, BGRABlack, 1, BGRAPixelTransparent);
Bitmap.EllipseAntialias(slot_x_center[2], slot_y_center[2], piece_quarter_size, piece_quarter_size, BGRABlack, 1, BGRAPixelTransparent);
Bitmap.EllipseAntialias(slot_x_center[3], slot_y_center[3], piece_quarter_size, piece_quarter_size, BGRABlack, 1, BGRAPixelTransparent);
Bitmap.EllipseAntialias(slot_x_center[4], slot_y_center[4], piece_quarter_size, piece_quarter_size, BGRABlack, 1, BGRAPixelTransparent);
Bitmap.EllipseAntialias(slot_x_center[5], slot_y_center[5], piece_quarter_size, piece_quarter_size, BGRABlack, 1, BGRAPixelTransparent);
Bitmap.EllipseAntialias(slot_x_center[6], slot_y_center[6], piece_quarter_size, piece_quarter_size, BGRABlack, 1, BGRAPixelTransparent);
Bitmap.EllipseAntialias(slot_x_center[7], slot_y_center[7], piece_quarter_size, piece_quarter_size, BGRABlack, 1, BGRAPixelTransparent);
Bitmap.EllipseAntialias(slot_x_center[8], slot_y_center[8], piece_quarter_size, piece_quarter_size, BGRABlack, 1, BGRAPixelTransparent);
Bitmap.EllipseAntialias(slot_x_center[9], slot_y_center[9], piece_quarter_size, piece_quarter_size, BGRABlack, 1, BGRAPixelTransparent);
Bitmap.EllipseAntialias(slot_x_center[10], slot_y_center[10], piece_quarter_size, piece_quarter_size, BGRABlack, 1, BGRAPixelTransparent);
Bitmap.EllipseAntialias(slot_x_center[11], slot_y_center[11], piece_quarter_size, piece_quarter_size, BGRABlack, 1, BGRAPixelTransparent);
Bitmap.EllipseAntialias(slot_x_center[12], slot_y_center[12], piece_quarter_size, piece_quarter_size, BGRABlack, 1, BGRAPixelTransparent);



//procedure Arc(cx,cy,rx,ry: single; const StartPoint,EndPoint: TPointF; AColor: TBGRAPixel; width: Single; ADrawChord: boolean; AFillColor: TBGRAPixel); overload;



Bitmap.Arc(board_border_x_center[0], board_border_y_center[0],board_border_radius,board_border_radius, 0,-Pi*0.68, board_border_color, board_border_pen_width, false, BGRAPixelTransparent);
Bitmap.Arc(board_border_x_center[1], board_border_y_center[1],board_border_radius,board_border_radius, 0,-Pi, board_border_color, board_border_pen_width, false, BGRAPixelTransparent);
Bitmap.Arc(board_border_x_center[2], board_border_y_center[2],board_border_radius,board_border_radius, 0,-Pi, board_border_color, board_border_pen_width, false, BGRAPixelTransparent);
Bitmap.Arc(board_border_x_center[3], board_border_y_center[3],board_border_radius,board_border_radius, 0,-Pi, board_border_color, board_border_pen_width, false, BGRAPixelTransparent);
Bitmap.Arc(board_border_x_center[4], board_border_y_center[4],board_border_radius,board_border_radius, -Pi, -Pi*0.35, board_border_color, board_border_pen_width, false, BGRAPixelTransparent);

Bitmap.Arc(board_border_x_center[5], board_border_y_center[5],board_border_radius,board_border_radius, Pi*0.35, -Pi*0.35, board_border_color, board_border_pen_width, false, BGRAPixelTransparent);
Bitmap.Arc(board_border_x_center[6], board_border_y_center[6],board_border_radius,board_border_radius, Pi*0.68, Pi, board_border_color, board_border_pen_width, false, BGRAPixelTransparent);
Bitmap.Arc(board_border_x_center[6], board_border_y_center[6],board_border_radius,board_border_radius, -Pi*0.68, -Pi, board_border_color, board_border_pen_width, false, BGRAPixelTransparent);

Bitmap.Arc(board_border_x_center[7], board_border_y_center[7],board_border_radius,board_border_radius, Pi*0.35, -Pi*0.68, board_border_color, board_border_pen_width, false, BGRAPixelTransparent);

Bitmap.Arc(board_border_x_center[8], board_border_y_center[8],board_border_radius,board_border_radius, Pi*0.68, -Pi*0.35, board_border_color, board_border_pen_width, false, BGRAPixelTransparent);

Bitmap.Arc(board_border_x_center[9], board_border_y_center[9],board_border_radius,board_border_radius, Pi*0.68, Pi, board_border_color, board_border_pen_width, false, BGRAPixelTransparent);
Bitmap.Arc(board_border_x_center[9], board_border_y_center[9],board_border_radius,board_border_radius, -Pi*0.35, -Pi, board_border_color, board_border_pen_width, false, BGRAPixelTransparent);

Bitmap.Arc(board_border_x_center[10], board_border_y_center[10],board_border_radius,board_border_radius, Pi*0.35, Pi, board_border_color, board_border_pen_width, false, BGRAPixelTransparent);
Bitmap.Arc(board_border_x_center[10], board_border_y_center[10],board_border_radius,board_border_radius, -Pi*0.68, -Pi, board_border_color, board_border_pen_width, false, BGRAPixelTransparent);

Bitmap.Arc(board_border_x_center[11], board_border_y_center[11],board_border_radius,board_border_radius, 0,Pi*0.68, board_border_color, board_border_pen_width, false, BGRAPixelTransparent);
Bitmap.Arc(board_border_x_center[12], board_border_y_center[12],board_border_radius,board_border_radius, 0,Pi, board_border_color, board_border_pen_width, false, BGRAPixelTransparent);
Bitmap.Arc(board_border_x_center[13], board_border_y_center[13],board_border_radius,board_border_radius, 0,Pi, board_border_color, board_border_pen_width, false, BGRAPixelTransparent);
Bitmap.Arc(board_border_x_center[14], board_border_y_center[14],board_border_radius,board_border_radius, 0,Pi, board_border_color, board_border_pen_width, false, BGRAPixelTransparent);
Bitmap.Arc(board_border_x_center[15], board_border_y_center[15],board_border_radius,board_border_radius, Pi,Pi*0.35, board_border_color, board_border_pen_width, false, BGRAPixelTransparent);






end;

procedure TPuzzleGameForm.AddDeletePlayerButtonClick(Sender: TObject);
var
 n: Integer;
 player_name: String;
begin

if(PlayerSelectComboBox.ItemIndex = 0) then // AddDeletePlayerButton.Caption := 'Add player';
begin
 if(CompareStr(PlayerNameEdit.Text, '') <> 0) then
 begin

  for n:= 0 to player_names_memo.Lines.Count-1 do
  begin
    if(CompareStr(PlayerNameEdit.Text, player_names_memo.Lines[n]) = 0) then
    begin
     MessageDlgEx(PCHAR('Player with ' + PlayerNameEdit.Text + ' name already exists.' + LineEnding + 'Please choose another name or delete old ' + PlayerNameEdit.Text + ' player.'), mtInformation, [mbOk], PuzzleGameForm);
     Exit;
    end;
  end; // for n:= 0 to player_names_memo.Lines.Count-1 do

  PlayerSelectComboBox.Items.Add(PlayerNameEdit.Text);
  PlayerSelectComboBox.ItemIndex := PlayerSelectComboBox.Items.Count - 1;

  puzzle_solutions_filename := PlayerNameEdit.Text + '.txt';
  puzzle_solutions_full_filename := puzzle_solutions_filepath + puzzle_solutions_filename;

  if (not FileExists(puzzle_solutions_full_filename)) then
  begin
  file_handle := FileCreate(puzzle_solutions_full_filename);
  FileClose(file_handle);
  end;


  player_names_memo.Lines.Add(PlayerNameEdit.Text);
  player_names_memo.Lines[0] := IntToStr(PlayerSelectComboBox.Items.Count - 3);
  player_names_memo.Lines.SaveToFile(player_names_full_filename);

  AddDeletePlayerButton.Visible := false;
  PlayerNameEdit.Visible := false;

  FlipButton.Visible := true;
  NewGameButton.Visible := true;
  ShowSavedSolutionsButton.Visible := true;

 end;//if(CompareStr(PlayerNameEdit.Text, '') <> 0)

end
else if(PlayerSelectComboBox.ItemIndex = 1) then // AddDeletePlayerButton.Caption := 'Delete player';
begin

for n:= 0 to player_names_memo.Lines.Count-1 do
begin

//  if(CompareText(PlayerNameEdit.Text, player_names_memo.Lines[n]) = 0) then  // Compare 2 ansistrings case insensitive.
  if(CompareStr(PlayerNameEdit.Text, player_names_memo.Lines[n]) = 0) then  // Compare 2 ansistrings case-sensitively, ignoring special characters.
  begin
//    ListBox1.Items.Delete(Index);
    player_names_memo.Lines.Delete(n);
    player_names_memo.Lines[0] := '0';
    player_names_memo.Lines.SaveToFile(player_names_full_filename);

    puzzle_solutions_filename := PlayerNameEdit.Text + '.txt';
    puzzle_solutions_full_filename := puzzle_solutions_filepath + puzzle_solutions_filename;

    if (FileExists(puzzle_solutions_full_filename)) then
    DeleteFile(puzzle_solutions_full_filename);

    LoadPlayerNames();

    AddDeletePlayerButton.Visible := false;
    PlayerNameEdit.Visible := false;

    FlipButton.Visible := true;
    NewGameButton.Visible := true;
    ShowSavedSolutionsButton.Visible := true;

    MessageDlgEx(PCHAR('Player ' + PlayerNameEdit.Text + ' deleted.'), mtInformation, [mbOk], PuzzleGameForm);
    Exit;
  end;
end; // for n:= 0 to player_names_memo.Lines.Count-1 do

MessageDlgEx(PCHAR('Unable to delete player with name ' + PlayerNameEdit.Text + '.' + LineEnding + PlayerNameEdit.Text + ' was not found.' + LineEnding + 'Hint: please write the name case-sensitive.'), mtInformation, [mbOk], PuzzleGameForm);

end; // else if(PlayerSelectComboBox.ItemIndex = 1) // AddDeletePlayerButton.Caption := 'Delete player';


end;

procedure TPuzzleGameForm.ErrorCircleImageClick(Sender: TObject);
begin

end;

procedure TPuzzleGameForm.ErrorCircleImageMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin

ErrorCircleImage.Visible := false;

end;




procedure TPuzzleGameForm.ErrorCircleImageRedraw(Sender: TObject;
  Bitmap: TBGRABitmap);
begin

Bitmap.FillTransparent;
//  TColor($0000FF) is Red <<--- R and B colors are inverted RGB becomes BGR
Bitmap.EllipseAntialias(current_piece_marking_ellipse_radius + error_circle_pen_width_div_2, current_piece_marking_ellipse_radius + error_circle_pen_width_div_2, current_piece_marking_ellipse_radius, current_piece_marking_ellipse_radius, TColor($0000FF), error_circle_pen_width, BGRAPixelTransparent);


end;



procedure TPuzzleGameForm.Piece01Redraw(Sender: TObject; Bitmap: TBGRABitmap
  );
begin

  if(current_piece = 1) then
  begin
  Bitmap.FillTransparent;
  Bitmap.PutImageAngle(Bitmap.Width/2-0.5,Bitmap.Height/2-0.5,piece_image_01,current_rotation_angle,piece_image_01.Width/2-0.5,piece_image_01.Height/2-0.5);
  Bitmap.Canvas.Ellipse(current_piece_marking_ellipse_rect);
  end
  else
  Bitmap.PutImageAngle(Bitmap.Width/2-0.5,Bitmap.Height/2-0.5,piece_image_01,piece_rotation_angle[0],piece_image_01.Width/2-0.5,piece_image_01.Height/2-0.5);

  if (piece_is_flipped[0]) then
  Bitmap.HorizontalFlip();

end;


procedure TPuzzleGameForm.Piece02Redraw(Sender: TObject; Bitmap: TBGRABitmap
  );
begin

    if(current_piece = 2) then
    begin
    Bitmap.FillTransparent;
    Bitmap.PutImageAngle(Bitmap.Width/2-0.5,Bitmap.Height/2-0.5,piece_image_02,current_rotation_angle,piece_image_02.Width/2-0.5,piece_image_02.Height/2-0.5);
    Bitmap.Canvas.Ellipse(current_piece_marking_ellipse_rect);
    end
    else
    Bitmap.PutImageAngle(Bitmap.Width/2-0.5,Bitmap.Height/2-0.5,piece_image_02,piece_rotation_angle[1],piece_image_02.Width/2-0.5,piece_image_02.Height/2-0.5);

    if (piece_is_flipped[1]) then
    Bitmap.HorizontalFlip();


end;

procedure TPuzzleGameForm.Piece03Redraw(Sender: TObject; Bitmap: TBGRABitmap
  );
begin

    if(current_piece = 3) then
    begin
    Bitmap.FillTransparent;
    Bitmap.PutImageAngle(Bitmap.Width/2-0.5,Bitmap.Height/2-0.5,piece_image_03,current_rotation_angle,piece_image_03.Width/2-0.5,piece_image_03.Height/2-0.5);
    Bitmap.Canvas.Ellipse(current_piece_marking_ellipse_rect);
    end
    else
    Bitmap.PutImageAngle(Bitmap.Width/2-0.5,Bitmap.Height/2-0.5,piece_image_03,piece_rotation_angle[2],piece_image_03.Width/2-0.5,piece_image_03.Height/2-0.5);

    if (piece_is_flipped[2]) then
    Bitmap.HorizontalFlip();

end;

procedure TPuzzleGameForm.Piece04Redraw(Sender: TObject; Bitmap: TBGRABitmap
  );
begin

    if(current_piece = 4) then
    begin
    Bitmap.FillTransparent;
    Bitmap.PutImageAngle(Bitmap.Width/2-0.5,Bitmap.Height/2-0.5,piece_image_04,current_rotation_angle,piece_image_04.Width/2-0.5,piece_image_04.Height/2-0.5);
    Bitmap.Canvas.Ellipse(current_piece_marking_ellipse_rect);
    end
    else
    Bitmap.PutImageAngle(Bitmap.Width/2-0.5,Bitmap.Height/2-0.5,piece_image_04,piece_rotation_angle[3],piece_image_04.Width/2-0.5,piece_image_04.Height/2-0.5);

    if (piece_is_flipped[3]) then
    Bitmap.HorizontalFlip();

end;

procedure TPuzzleGameForm.Piece05Redraw(Sender: TObject; Bitmap: TBGRABitmap
  );
begin

    if(current_piece = 5) then
    begin
    Bitmap.FillTransparent;
    Bitmap.PutImageAngle(Bitmap.Width/2-0.5,Bitmap.Height/2-0.5,piece_image_05,current_rotation_angle,piece_image_05.Width/2-0.5,piece_image_05.Height/2-0.5);
    Bitmap.Canvas.Ellipse(current_piece_marking_ellipse_rect);
    end
    else
    Bitmap.PutImageAngle(Bitmap.Width/2-0.5,Bitmap.Height/2-0.5,piece_image_05,piece_rotation_angle[4],piece_image_05.Width/2-0.5,piece_image_05.Height/2-0.5);

    if (piece_is_flipped[4]) then
    Bitmap.HorizontalFlip();

end;

procedure TPuzzleGameForm.Piece06Redraw(Sender: TObject; Bitmap: TBGRABitmap
  );
begin

    if(current_piece = 6) then
    begin
    Bitmap.FillTransparent;
    Bitmap.PutImageAngle(Bitmap.Width/2-0.6,Bitmap.Height/2-0.6,piece_image_06,current_rotation_angle,piece_image_06.Width/2-0.6,piece_image_06.Height/2-0.6);
    Bitmap.Canvas.Ellipse(current_piece_marking_ellipse_rect);
    end
    else
    Bitmap.PutImageAngle(Bitmap.Width/2-0.6,Bitmap.Height/2-0.6,piece_image_06,piece_rotation_angle[5],piece_image_06.Width/2-0.6,piece_image_06.Height/2-0.6);

    if (piece_is_flipped[5]) then
    Bitmap.HorizontalFlip();


end;

procedure TPuzzleGameForm.Piece07Redraw(Sender: TObject; Bitmap: TBGRABitmap
  );
begin

    if(current_piece = 7) then
    begin
    Bitmap.FillTransparent;
    Bitmap.PutImageAngle(Bitmap.Width/2-0.5,Bitmap.Height/2-0.5,piece_image_07,current_rotation_angle,piece_image_07.Width/2-0.5,piece_image_07.Height/2-0.5);
    Bitmap.Canvas.Ellipse(current_piece_marking_ellipse_rect);
    end
    else
    Bitmap.PutImageAngle(Bitmap.Width/2-0.5,Bitmap.Height/2-0.5,piece_image_07,piece_rotation_angle[6],piece_image_07.Width/2-0.5,piece_image_07.Height/2-0.5);

    if (piece_is_flipped[6]) then
    Bitmap.HorizontalFlip();

end;

procedure TPuzzleGameForm.Piece08Redraw(Sender: TObject; Bitmap: TBGRABitmap
  );
begin

    if(current_piece = 8) then
    begin
    Bitmap.FillTransparent;
    Bitmap.PutImageAngle(Bitmap.Width/2-0.5,Bitmap.Height/2-0.5,piece_image_08,current_rotation_angle,piece_image_08.Width/2-0.5,piece_image_08.Height/2-0.5);
    Bitmap.Canvas.Ellipse(current_piece_marking_ellipse_rect);
    end
    else
    Bitmap.PutImageAngle(Bitmap.Width/2-0.5,Bitmap.Height/2-0.5,piece_image_08,piece_rotation_angle[7],piece_image_08.Width/2-0.5,piece_image_08.Height/2-0.5);

    if (piece_is_flipped[7]) then
    Bitmap.HorizontalFlip();

end;

procedure TPuzzleGameForm.Piece09Redraw(Sender: TObject; Bitmap: TBGRABitmap
  );
begin

    if(current_piece = 9) then
    begin
    Bitmap.FillTransparent;
    Bitmap.PutImageAngle(Bitmap.Width/2-0.5,Bitmap.Height/2-0.5,piece_image_09,current_rotation_angle,piece_image_09.Width/2-0.5,piece_image_09.Height/2-0.5);
    Bitmap.Canvas.Ellipse(current_piece_marking_ellipse_rect);
    end
    else
    Bitmap.PutImageAngle(Bitmap.Width/2-0.5,Bitmap.Height/2-0.5,piece_image_09,piece_rotation_angle[8],piece_image_09.Width/2-0.5,piece_image_09.Height/2-0.5);

    if (piece_is_flipped[8]) then
    Bitmap.HorizontalFlip();

end;



procedure TPuzzleGameForm.Piece10Redraw(Sender: TObject; Bitmap: TBGRABitmap
  );
begin

  if(current_piece = 10) then
  begin
  Bitmap.FillTransparent;
  Bitmap.PutImageAngle(Bitmap.Width/2-0.5,Bitmap.Height/2-0.5,piece_image_10,current_rotation_angle,piece_image_10.Width/2-0.5,piece_image_10.Height/2-0.5);
  Bitmap.Canvas.Ellipse(current_piece_marking_ellipse_rect);
  end
  else
  Bitmap.PutImageAngle(Bitmap.Width/2-0.5,Bitmap.Height/2-0.5,piece_image_10,piece_rotation_angle[9],piece_image_10.Width/2-0.5,piece_image_10.Height/2-0.5);

  if (piece_is_flipped[9]) then
  Bitmap.HorizontalFlip();

end;



procedure TPuzzleGameForm.Piece11Redraw(Sender: TObject; Bitmap: TBGRABitmap
  );
begin

    if(current_piece = 11) then
    begin
    Bitmap.FillTransparent;
    Bitmap.PutImageAngle(Bitmap.Width/2-0.5,Bitmap.Height/2-0.5,piece_image_11,current_rotation_angle,piece_image_11.Width/2-0.5,piece_image_11.Height/2-0.5);
    Bitmap.Canvas.Ellipse(current_piece_marking_ellipse_rect);
    end
    else
    Bitmap.PutImageAngle(Bitmap.Width/2-0.5,Bitmap.Height/2-0.5,piece_image_11,piece_rotation_angle[10],piece_image_11.Width/2-0.5,piece_image_11.Height/2-0.5);

    if (piece_is_flipped[10]) then
    Bitmap.HorizontalFlip();


end;




procedure TPuzzleGameForm.Piece12Redraw(Sender: TObject; Bitmap: TBGRABitmap
  );
begin

    if(current_piece = 12) then
    begin
    Bitmap.FillTransparent;
    Bitmap.PutImageAngle(Bitmap.Width/2-0.5,Bitmap.Height/2-0.5,piece_image_12,current_rotation_angle,piece_image_12.Width/2-0.5,piece_image_12.Height/2-0.5);
    Bitmap.Canvas.Ellipse(current_piece_marking_ellipse_rect);
    end
    else
    Bitmap.PutImageAngle(Bitmap.Width/2-0.5,Bitmap.Height/2-0.5,piece_image_12,piece_rotation_angle[11],piece_image_12.Width/2-0.5,piece_image_12.Height/2-0.5);

    if (piece_is_flipped[11]) then
    Bitmap.HorizontalFlip();


end;



procedure TPuzzleGameForm.Piece13Redraw(Sender: TObject; Bitmap: TBGRABitmap
  );
begin

    if(current_piece = 13) then
    begin
    Bitmap.FillTransparent;
    Bitmap.PutImageAngle(Bitmap.Width/2-0.5,Bitmap.Height/2-0.5,piece_image_13,current_rotation_angle,piece_image_13.Width/2-0.5,piece_image_13.Height/2-0.5);
    Bitmap.Canvas.Ellipse(current_piece_marking_ellipse_rect);
    end
    else
    Bitmap.PutImageAngle(Bitmap.Width/2-0.5,Bitmap.Height/2-0.5,piece_image_13,piece_rotation_angle[12],piece_image_13.Width/2-0.5,piece_image_13.Height/2-0.5);

    if (piece_is_flipped[12]) then
    Bitmap.HorizontalFlip();


end;






procedure TPuzzleGameForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin


//DebugLabel.Caption:= 'valio';

if (Key = VK_D) then
DebugLabel.Visible := not DebugLabel.Visible;




if(slideshow_mode = true) then
begin


if (Key = VK_ESCAPE) then
begin
  //Close;
  ShowSolutionsTimer.Enabled := false;
end
else if (Key = VK_SPACE) then
begin
  ShowSolutionsTimer.Enabled := not ShowSolutionsTimer.Enabled;
end
else if ((Key = VK_LEFT) or (Key = VK_PRIOR)) then
begin
  LoadNextSolution(-1);
end
else if ((Key = VK_RIGHT) or (Key = VK_NEXT)) then
begin
  LoadNextSolution(1);
end;



end; //if(slideshow_mode = true)



end;








procedure TPuzzleGameForm.PieceRotationTrackBarChange(Sender: TObject);
begin

RotateToNearest60angleAnimationTimer.Enabled := false;
current_rotation_angle := PieceRotationTrackBar.Position;
RedrawCurrentPiece();

//DebugLabel.Caption := 'current_rotation_angle = ' + IntToStr(current_rotation_angle) + ', final_rotation_angle = ' + IntToStr(final_rotation_angle);


end;

procedure TPuzzleGameForm.PieceRotationTrackBarMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin

  current_rotation_angle := PieceRotationTrackBar.Position;
  angle_6th_part := PieceRotationTrackBar.Position / 60.0;
  final_rotation_angle := Round(angle_6th_part) * 60;

  PieceRotationTrackBar.OnChange := nil;
  PieceRotationTrackBar.Position := final_rotation_angle;
  PieceRotationTrackBar.OnChange := @PieceRotationTrackBarChange;

  RotateToNearest60angleAnimationTimer.Enabled := true;




end;


procedure TPuzzleGameForm.RedrawCurrentPiece();
begin

if(current_piece = 1) then
  Piece01.RedrawBitmap
else if(current_piece = 2) then
  Piece02.RedrawBitmap
else if(current_piece = 3) then
  Piece03.RedrawBitmap
else if(current_piece = 4) then
  Piece04.RedrawBitmap
else if(current_piece = 5) then
  Piece05.RedrawBitmap
else if(current_piece = 6) then
  Piece06.RedrawBitmap
else if(current_piece = 7) then
  Piece07.RedrawBitmap
else if(current_piece = 8) then
  Piece08.RedrawBitmap
else if(current_piece = 9) then
  Piece09.RedrawBitmap
else if(current_piece = 10) then
  Piece10.RedrawBitmap
else if(current_piece = 11) then
  Piece11.RedrawBitmap
else if(current_piece = 12) then
  Piece12.RedrawBitmap
else if(current_piece = 13) then
  Piece13.RedrawBitmap;

end;


procedure TPuzzleGameForm.RedrawAllPieces();
begin

  Piece01.RedrawBitmap;
  Piece02.RedrawBitmap;
  Piece03.RedrawBitmap;
  Piece04.RedrawBitmap;
  Piece05.RedrawBitmap;
  Piece06.RedrawBitmap;
  Piece07.RedrawBitmap;
  Piece08.RedrawBitmap;
  Piece09.RedrawBitmap;
  Piece10.RedrawBitmap;
  Piece11.RedrawBitmap;
  Piece12.RedrawBitmap;
  Piece13.RedrawBitmap;

end;






procedure TPuzzleGameForm.SaveSolution();
var
 n, pos_n: Integer;
 old_solved_puzzle: String;
begin


if(slideshow_mode = true) then
Exit;


saved_puzzle_memo.Clear;

if (FileExists(puzzle_solutions_full_filename)) then
saved_puzzle_memo.Lines.LoadFromFile(puzzle_solutions_full_filename);

SimplifySolution();

solved_puzzle_string := IntToStr(piece_slot_address[0]) + ';' + IntToStr(piece_slot_address[1]) + ';' + IntToStr(piece_slot_address[2]) + ';' + IntToStr(piece_slot_address[3]) + ';' + IntToStr(piece_slot_address[4]) + ';' + IntToStr(piece_slot_address[5]) + ';' + IntToStr(piece_slot_address[6]) + ';' + IntToStr(piece_slot_address[7]) + ';' + IntToStr(piece_slot_address[8]) + ';' + IntToStr(piece_slot_address[9]) + ';' + IntToStr(piece_slot_address[10]) + ';' + IntToStr(piece_slot_address[11]) + ';' + IntToStr(piece_slot_address[12]) + ';' + IntToStr(piece_rotation_angle[0]) + ';' + IntToStr(piece_rotation_angle[1]) + ';' + IntToStr(piece_rotation_angle[2]) + ';' + IntToStr(piece_rotation_angle[3]) + ';' + IntToStr(piece_rotation_angle[4]) + ';' + IntToStr(piece_rotation_angle[5]) + ';' + IntToStr(piece_rotation_angle[6]) + ';' + IntToStr(piece_rotation_angle[7]) + ';' + IntToStr(piece_rotation_angle[8]) + ';' + IntToStr(piece_rotation_angle[9]) + ';' + IntToStr(piece_rotation_angle[10]) + ';' + IntToStr(piece_rotation_angle[11]) + ';' + IntToStr(piece_rotation_angle[12]) + ';' + BoolToStr(piece_is_flipped[0]) + ';' + BoolToStr(piece_is_flipped[1]) + ';' + BoolToStr(piece_is_flipped[2]) + ';' + BoolToStr(piece_is_flipped[3]) + ';' + BoolToStr(piece_is_flipped[4]) + ';' + BoolToStr(piece_is_flipped[5]) + ';' + BoolToStr(piece_is_flipped[6]) + ';' + BoolToStr(piece_is_flipped[7]) + ';' + BoolToStr(piece_is_flipped[8]) + ';' + BoolToStr(piece_is_flipped[9]) + ';' + BoolToStr(piece_is_flipped[10]) + ';' + BoolToStr(piece_is_flipped[11]) + ';' + BoolToStr(piece_is_flipped[12]);


// old_solved_puzzle := Copy(saved_puzzle_memo.Lines.Strings[0], 1, Pos('"',saved_puzzle_memo.Lines.Strings[n]) - 2);
// MessageDlgEx(PCHAR(old_solved_puzzle), mtInformation, [mbOk], PuzzleGameForm);
// Exit;



old_solved_puzzle := '';
for n := 0 to saved_puzzle_memo.Lines.Count-1 do
begin
  old_solved_puzzle := Copy(saved_puzzle_memo.Lines.Strings[n], 1, Pos('"',saved_puzzle_memo.Lines.Strings[n]) - 2);

  if (CompareStr(solved_puzzle_string, old_solved_puzzle) = 0) then
  begin
    pos_n := Pos('"',saved_puzzle_memo.Lines.Strings[n]) + 1;
    old_date_and_time_string := Copy(saved_puzzle_memo.Lines.Strings[n], pos_n, saved_puzzle_memo.Lines.Strings[n].Length - pos_n);
    ShowMessage('This solution already exists in saved file as #' + IntToStr(n+1) + ' solution' + LineEnding +  'which was saved ' + old_date_and_time_string);
    Exit;
  end;
end; // for n := 0 to saved_puzzle_memo.Lines.Count-1;




solved_puzzle_string := solved_puzzle_string + ';"' + date_and_time_string + '"';


// MessageDlgEx(PCHAR(solved_puzzle_string), mtInformation, [mbOk], PuzzleGameForm);
// Exit;



saved_puzzle_memo.Lines.Add(solved_puzzle_string);
saved_puzzle_memo.Lines.SaveToFile(puzzle_solutions_full_filename);

ShowMessage('Solution saved.');



end;





procedure TPuzzleGameForm.FixButtonClick(Sender: TObject);
var
  n: Integer;
  solution_already_exists: Boolean;
begin




if( FileExists(puzzle_solutions_full_filename)) then
begin
DeleteFile(puzzle_solutions_full_filename);
CopyFile(puzzle_solutions_filename, puzzle_solutions_full_filename);
end;



saved_puzzle_memo.Clear;
saved_puzzle_memo.Lines.LoadFromFile(puzzle_solutions_full_filename);

fixed_puzzle_memo.Clear;

for saved_puzzle_number := 0 to saved_puzzle_memo.Lines.Count-1 do
begin
solution_already_exists := false;

saved_puzzle_stringlist := TStringList.Create;
try

  if (saved_puzzle_memo.Lines[saved_puzzle_number].Length <> 0) then
  begin

  saved_puzzle_stringlist.Delimiter := ';';
  saved_puzzle_stringlist.DelimitedText := saved_puzzle_memo.Lines[saved_puzzle_number];

  //===========================

piece_slot_address[0] := StrToIntDef(saved_puzzle_stringlist.Strings[0], 0);
piece_slot_address[1] := StrToIntDef(saved_puzzle_stringlist.Strings[1], 0);
piece_slot_address[2] := StrToIntDef(saved_puzzle_stringlist.Strings[2], 0);
piece_slot_address[3] := StrToIntDef(saved_puzzle_stringlist.Strings[3], 0);
piece_slot_address[4] := StrToIntDef(saved_puzzle_stringlist.Strings[4], 0);
piece_slot_address[5] := StrToIntDef(saved_puzzle_stringlist.Strings[5], 0);
piece_slot_address[6] := StrToIntDef(saved_puzzle_stringlist.Strings[6], 0);
piece_slot_address[7] := StrToIntDef(saved_puzzle_stringlist.Strings[7], 0);
piece_slot_address[8] := StrToIntDef(saved_puzzle_stringlist.Strings[8], 0);
piece_slot_address[9] := StrToIntDef(saved_puzzle_stringlist.Strings[9], 0);
piece_slot_address[10] := StrToIntDef(saved_puzzle_stringlist.Strings[10], 0);
piece_slot_address[11] := StrToIntDef(saved_puzzle_stringlist.Strings[11], 0);
piece_slot_address[12] := StrToIntDef(saved_puzzle_stringlist.Strings[12], 0);


piece_rotation_angle[0] := StrToIntDef(saved_puzzle_stringlist.Strings[13], 0);
piece_rotation_angle[1] := StrToIntDef(saved_puzzle_stringlist.Strings[14], 0);
piece_rotation_angle[2] := StrToIntDef(saved_puzzle_stringlist.Strings[15], 0);
piece_rotation_angle[3] := StrToIntDef(saved_puzzle_stringlist.Strings[16], 0);
piece_rotation_angle[4] := StrToIntDef(saved_puzzle_stringlist.Strings[17], 0);
piece_rotation_angle[5] := StrToIntDef(saved_puzzle_stringlist.Strings[18], 0);
piece_rotation_angle[6] := StrToIntDef(saved_puzzle_stringlist.Strings[19], 0);
piece_rotation_angle[7] := StrToIntDef(saved_puzzle_stringlist.Strings[20], 0);
piece_rotation_angle[8] := StrToIntDef(saved_puzzle_stringlist.Strings[21], 0);
piece_rotation_angle[9] := StrToIntDef(saved_puzzle_stringlist.Strings[22], 0);
piece_rotation_angle[10] := StrToIntDef(saved_puzzle_stringlist.Strings[23], 0);
piece_rotation_angle[11] := StrToIntDef(saved_puzzle_stringlist.Strings[24], 0);
piece_rotation_angle[12] := StrToIntDef(saved_puzzle_stringlist.Strings[25], 0);


piece_is_flipped[0] := StrToBoolDef(saved_puzzle_stringlist.Strings[26], false);
piece_is_flipped[1] := StrToBoolDef(saved_puzzle_stringlist.Strings[27], false);
piece_is_flipped[2] := StrToBoolDef(saved_puzzle_stringlist.Strings[28], false);
piece_is_flipped[3] := StrToBoolDef(saved_puzzle_stringlist.Strings[29], false);
piece_is_flipped[4] := StrToBoolDef(saved_puzzle_stringlist.Strings[30], false);
piece_is_flipped[5] := StrToBoolDef(saved_puzzle_stringlist.Strings[31], false);
piece_is_flipped[6] := StrToBoolDef(saved_puzzle_stringlist.Strings[32], false);
piece_is_flipped[7] := StrToBoolDef(saved_puzzle_stringlist.Strings[33], false);
piece_is_flipped[8] := StrToBoolDef(saved_puzzle_stringlist.Strings[34], false);
piece_is_flipped[9] := StrToBoolDef(saved_puzzle_stringlist.Strings[35], false);
piece_is_flipped[10] := StrToBoolDef(saved_puzzle_stringlist.Strings[36], false);
piece_is_flipped[11] := StrToBoolDef(saved_puzzle_stringlist.Strings[37], false);
piece_is_flipped[12] := StrToBoolDef(saved_puzzle_stringlist.Strings[38], false);


 SimplifySolution();



//================
solved_puzzle_string := IntToStr(piece_slot_address[0]) + ';' + IntToStr(piece_slot_address[1]) + ';' + IntToStr(piece_slot_address[2]) + ';' + IntToStr(piece_slot_address[3]) + ';' + IntToStr(piece_slot_address[4]) + ';' + IntToStr(piece_slot_address[5]) + ';' + IntToStr(piece_slot_address[6]) + ';' + IntToStr(piece_slot_address[7]) + ';' + IntToStr(piece_slot_address[8]) + ';' + IntToStr(piece_slot_address[9]) + ';' + IntToStr(piece_slot_address[10]) + ';' + IntToStr(piece_slot_address[11]) + ';' + IntToStr(piece_slot_address[12]) + ';' + IntToStr(piece_rotation_angle[0]) + ';' + IntToStr(piece_rotation_angle[1]) + ';' + IntToStr(piece_rotation_angle[2]) + ';' + IntToStr(piece_rotation_angle[3]) + ';' + IntToStr(piece_rotation_angle[4]) + ';' + IntToStr(piece_rotation_angle[5]) + ';' + IntToStr(piece_rotation_angle[6]) + ';' + IntToStr(piece_rotation_angle[7]) + ';' + IntToStr(piece_rotation_angle[8]) + ';' + IntToStr(piece_rotation_angle[9]) + ';' + IntToStr(piece_rotation_angle[10]) + ';' + IntToStr(piece_rotation_angle[11]) + ';' + IntToStr(piece_rotation_angle[12]) + ';' + BoolToStr(piece_is_flipped[0]) + ';' + BoolToStr(piece_is_flipped[1]) + ';' + BoolToStr(piece_is_flipped[2]) + ';' + BoolToStr(piece_is_flipped[3]) + ';' + BoolToStr(piece_is_flipped[4]) + ';' + BoolToStr(piece_is_flipped[5]) + ';' + BoolToStr(piece_is_flipped[6]) + ';' + BoolToStr(piece_is_flipped[7]) + ';' + BoolToStr(piece_is_flipped[8]) + ';' + BoolToStr(piece_is_flipped[9]) + ';' + BoolToStr(piece_is_flipped[10]) + ';' + BoolToStr(piece_is_flipped[11]) + ';' + BoolToStr(piece_is_flipped[12]);


for n := 0 to fixed_puzzle_memo.Lines.Count-1 do
begin
  if (CompareStr(solved_puzzle_string, fixed_puzzle_memo.Lines.Strings[n]) = 0) then
  begin
    MessageDlgEx(PCHAR('#' + IntToStr(saved_puzzle_number) + ' solution already exists in saved file as #' + IntToStr(n+1) + ' solution.'), mtInformation, [mbOk], PuzzleGameForm);
    solution_already_exists := true;
//    SaveButton.Enabled := true;
//    Exit;
  end;
end; // for n := 0 to saved_puzzle_memo.Lines.Count-1;
//================


if(solution_already_exists = false) then
fixed_puzzle_memo.Lines.Add(solved_puzzle_string);


end; //  if (saved_puzzle_memo.Lines[saved_puzzle_number].Length <> 0)

finally
  saved_puzzle_stringlist.Free;
end;

end;//for saved_puzzle_number := 0 to saved_puzzle_memo.Lines.Count-1 do


fixed_puzzle_memo.Lines.SaveToFile('fixed.txt');



ShowMessage('Saved solutions fixed.');


end;

procedure TPuzzleGameForm.FlipButtonClick(Sender: TObject);
begin

if(slideshow_mode = true) then
Exit;

if(current_piece = 0) then
Exit;


  ErrorCircleImage.Visible := false;
  piece_is_flipped[current_piece-1] := not piece_is_flipped[current_piece-1];

  PlacePieceIntoBoardToFindCollisions(current_piece, current_slot);

  RedrawCurrentPiece();


end;


procedure TPuzzleGameForm.SimplifySolution();
var
 n, temp_int: Integer;
 temp_bool: Boolean;
begin


for n := 0 to 12 do
begin
  if(piece_rotation_angle[n] = 360) then
  piece_rotation_angle[n] := 0;

  if(piece_rotation_angle[n] < 0) then
  piece_rotation_angle[n] := piece_rotation_angle[n] + 360;
end;


piece_rotation_angle[0] := 0;
piece_is_flipped[0] := false;

if ((piece_rotation_angle[1] = 0) or (piece_rotation_angle[1] = 180)) then
piece_is_flipped[1] := false;




n := 2;
begin
  if(piece_is_flipped[n] = true) then
  begin
    if (piece_rotation_angle[n] = 60) then
    begin
     piece_rotation_angle[n] := 0;
     piece_is_flipped[n] := false;
    end
    else if (piece_rotation_angle[n] = 0) then
    begin
      piece_rotation_angle[n] := 60;
      piece_is_flipped[n] := false;
    end
    else if (piece_rotation_angle[n] = 300) then
    begin
      piece_rotation_angle[n] := 120;
      piece_is_flipped[n] := false;
    end
    else if (piece_rotation_angle[n] = 240) then
    begin
      piece_rotation_angle[n] := 180;
      piece_is_flipped[n] := false;
    end
    else if (piece_rotation_angle[n] = 180) then
    begin
      piece_rotation_angle[n] := 240;
      piece_is_flipped[n] := false;
    end
    else if (piece_rotation_angle[n] = 120) then
    begin
      piece_rotation_angle[n] := 300;
      piece_is_flipped[n] := false;
    end;
  end; // if(piece_is_flipped[n] = true)
end; // for n := 0 to 12 do




if ((piece_rotation_angle[3] = 0) or (piece_rotation_angle[3] = 180)) then
begin
piece_is_flipped[3] := false;
piece_rotation_angle[3] := 0;
end;

if (piece_rotation_angle[3] > 180) then
piece_rotation_angle[3] := piece_rotation_angle[3] - 180;

n := 3;
begin
  if(piece_is_flipped[n] = true) then
  begin
    if (piece_rotation_angle[n] = 180) then
    begin
     piece_rotation_angle[n] := 0;
     piece_is_flipped[n] := false;
    end
    else if (piece_rotation_angle[n] = 120) then
    begin
      piece_rotation_angle[n] := 60;
      piece_is_flipped[n] := false;
    end
    else if (piece_rotation_angle[n] = 60) then
    begin
      piece_rotation_angle[n] := 120;
      piece_is_flipped[n] := false;
    end
  end; // if(piece_is_flipped[n] = true)
end; // for n := 0 to 12 do




if ((piece_rotation_angle[4] = 0) or (piece_rotation_angle[4] = 180)) then
piece_is_flipped[4] := false;


n := 4;
begin
  if(piece_is_flipped[n] = true) then
  begin
    if (piece_rotation_angle[n] = 300) then
    begin
      piece_rotation_angle[n] := 60;
      piece_is_flipped[n] := false;
    end
    else if (piece_rotation_angle[n] = 240) then
    begin
      piece_rotation_angle[n] := 120;
      piece_is_flipped[n] := false;
    end
    else if (piece_rotation_angle[n] = 120) then
    begin
      piece_rotation_angle[n] := 240;
      piece_is_flipped[n] := false;
    end
    else if (piece_rotation_angle[n] = 60) then
    begin
      piece_rotation_angle[n] := 300;
      piece_is_flipped[n] := false;
    end;
  end; // if(piece_is_flipped[n] = true)
end; // for n := 0 to 12 do




if ((piece_rotation_angle[5] = 0) or (piece_rotation_angle[5] = 180)) then
piece_is_flipped[5] := false;


n := 5;
begin
  if(piece_is_flipped[n] = true) then
  begin
    if (piece_rotation_angle[n] = 300) then
    begin
      piece_rotation_angle[n] := 60;
      piece_is_flipped[n] := false;
    end
    else if (piece_rotation_angle[n] = 240) then
    begin
      piece_rotation_angle[n] := 120;
      piece_is_flipped[n] := false;
    end
    else if (piece_rotation_angle[n] = 120) then
    begin
      piece_rotation_angle[n] := 240;
      piece_is_flipped[n] := false;
    end
    else if (piece_rotation_angle[n] = 60) then
    begin
      piece_rotation_angle[n] := 300;
      piece_is_flipped[n] := false;
    end;
  end; // if(piece_is_flipped[n] = true)
end; // for n := 0 to 12 do



if ((piece_rotation_angle[6] = 0) or (piece_rotation_angle[6] = 120) or (piece_rotation_angle[6] = 240)) then
piece_rotation_angle[6] := 0;

if ((piece_rotation_angle[6] = 60) or (piece_rotation_angle[6] = 180) or (piece_rotation_angle[6] = 300)) then
piece_rotation_angle[6] := 60;

piece_is_flipped[6] := false;



// piece 7 flipped must remain flipped


n := 8;
begin
  if(piece_is_flipped[n] = true) then
  begin
    if (piece_rotation_angle[n] = 240) then
    begin
     piece_rotation_angle[n] := 240;
     piece_is_flipped[n] := false;
    end
    else if (piece_rotation_angle[n] = 300) then
    begin
      piece_rotation_angle[n] := 180;
      piece_is_flipped[n] := false;
    end
    else if (piece_rotation_angle[n] = 0) then
    begin
      piece_rotation_angle[n] := 120;
      piece_is_flipped[n] := false;
    end
    else if (piece_rotation_angle[n] = 60) then
    begin
      piece_rotation_angle[n] := 60;
      piece_is_flipped[n] := false;
    end
    else if (piece_rotation_angle[n] = 120) then
    begin
      piece_rotation_angle[n] := 0;
      piece_is_flipped[n] := false;
    end
    else if (piece_rotation_angle[n] = 180) then
    begin
      piece_rotation_angle[n] := 300;
      piece_is_flipped[n] := false;
    end;
  end; // if(piece_is_flipped[n] = true)
end; // for n := 0 to 12 do


n := 9;
begin
  if(piece_is_flipped[n] = true) then
  begin
    if (piece_rotation_angle[n] = 180) then
    begin
     piece_rotation_angle[n] := 0;
     piece_is_flipped[n] := false;
    end
    else if (piece_rotation_angle[n] = 120) then
    begin
     piece_rotation_angle[n] := 60;
     piece_is_flipped[n] := false;
    end
    else if (piece_rotation_angle[n] = 60) then
    begin
     piece_rotation_angle[n] := 120;
     piece_is_flipped[n] := false;
    end
    else if (piece_rotation_angle[n] = 0) then
    begin
     piece_rotation_angle[n] := 180;
     piece_is_flipped[n] := false;
    end
    else if (piece_rotation_angle[n] = 300) then
    begin
     piece_rotation_angle[n] := 240;
     piece_is_flipped[n] := false;
    end
    else if (piece_rotation_angle[n] = 240) then
    begin
     piece_rotation_angle[n] := 300;
     piece_is_flipped[n] := false;
    end;
	end; // if(piece_is_flipped[n] = true)
end; // for n := 0 to 12 do




if (piece_rotation_angle[10] > 180) then
piece_rotation_angle[10] := piece_rotation_angle[10] - 180;


if ((piece_rotation_angle[10] = 0) or (piece_rotation_angle[10] = 180)) then
begin
piece_is_flipped[10] := false;
piece_rotation_angle[10] := 0;
end;

if ((piece_rotation_angle[11] = 0) or (piece_rotation_angle[11] = 180)) then
piece_is_flipped[11] := false;

if ((piece_rotation_angle[12] = 0) or (piece_rotation_angle[12] = 180)) then
piece_is_flipped[12] := false;




for n := 10 to 12 do
begin
  if(piece_is_flipped[n] = true) then
  begin
    if (piece_rotation_angle[n] = 60) then
    begin
     piece_rotation_angle[n] := 300;
     piece_is_flipped[n] := false;
    end
    else if (piece_rotation_angle[n] = 120) then
    begin
      piece_rotation_angle[n] := 240;
      piece_is_flipped[n] := false;
    end
    else if (piece_rotation_angle[n] = 240) then
    begin
      piece_rotation_angle[n] := 120;
      piece_is_flipped[n] := false;
    end
    else if (piece_rotation_angle[n] = 300) then
    begin
      piece_rotation_angle[n] := 60;
      piece_is_flipped[n] := false;
    end;
  end; // if(piece_is_flipped[n] = true)
end; // for n := 0 to 12 do


if (piece_rotation_angle[10] > 180) then
piece_rotation_angle[10] := piece_rotation_angle[10] - 180;




if (piece_slot_address[12] < piece_slot_address[11]) then
begin

temp_int := piece_slot_address[11];
piece_slot_address[11] := piece_slot_address[12];
piece_slot_address[12] := temp_int;

temp_int := piece_rotation_angle[11];
piece_rotation_angle[11] := piece_rotation_angle[12];
piece_rotation_angle[12] := temp_int;

temp_bool := piece_is_flipped[11];
piece_is_flipped[11] := piece_is_flipped[12];
piece_is_flipped[12] := temp_bool;


temp_int := Piece12.Top;
Piece12.Top := Piece13.Top;
Piece13.Top := temp_int;

temp_int := Piece12.Left;
Piece12.Left := Piece13.Left;
Piece13.Left := temp_int;

Piece12.RedrawBitmap();
Piece13.RedrawBitmap();


end; //if (piece_slot_address[12] < piece_slot_address[11])



// debug purposes
for n := 9 to 12 do
begin
  if ((piece_is_flipped[n] = true) and (n <> 7)) then
  ShowMessage('piece_is_flipped[' + IntToStr(n) +'] = true');
end;


end;



//procedure TPuzzleGameForm.ShowSavedSolutionsButtonKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
//begin
//
//if (Key = VK_SPACE) then
//  Key := $0;
//
//end;


initialization


{$IF Defined(LINUX)}
  {$I puzzle_game_resource_linux.lrs}  // Linux Draw Bug: black color is drawn as transparent. Workaround fix: in all images Black color (0,0,0) was replaced with color (2, 2, 2)
{$ELSE}
  {$I puzzle_game_resource.lrs}
{$IFEND}

  {$I puzzle_game_slideshow_resource.lrs}
//  {$I puzzle_game_slideshow_resource_virginija.lrs}


end.

